'WinPam - Phone & Address Manager by Charles Dietz                    
'winPam compiled with PBWin 10.04                                                              
'----------------------------------------------------------------------------------               
#COMPILE EXE                                                     
#DIM ALL                                                                   
#INCLUDE "win32api.inc"
#INCLUDE "comdlg32.inc"
#INCLUDE "TAPI dialer.inc"                                                        
#Include "RichEdit.inc"                       
#INCLUDE "winPam.inc"
#include ".\appHelp.inc"
'#INCLUDE "debug.inc"     
#RESOURCE "winPam.pbr" 'for icon in explorer & calendar marker                                      

'embedded resource data                               
#RESOURCE ICON, pam, "WinPam.ico"             
'#RESOURCE MANIFEST, 1, "Manifest.XML"
#RESOURCE VERSIONINFO
#RESOURCE FILEVERSION 3, 4, 0, 0
#RESOURCE PRODUCTVERSION 3, 4, 0, 0            
#RESOURCE STRINGINFO "0409", "04B0"
#RESOURCE VERSION$ "Comments",         "Phone and addresses"
#RESOURCE VERSION$ "CompanyName",      "CGD Software"
#RESOURCE VERSION$ "FileDescription",  "Application"
#RESOURCE VERSION$ "FileVersion",      "Version 4.07 (06-28-2017)"
#RESOURCE VERSION$ "InternalName",     "WinPam"
#RESOURCE VERSION$ "LegalCopyright",   "No Copyright 2016"
#RESOURCE VERSION$ "LegalTrademarks",  "None"
#RESOURCE VERSION$ "OriginalFilename", "WinPam.EXE"
#RESOURCE VERSION$ "ProductName",      "WinPam"  
#RESOURCE VERSION$ "ProductVersion",   "Version 4.07"
                                                                    
$Version = "Ver 4.11"                            
'GLOBAL dbug AS LONG                                                  
                                                            
FUNCTION PBMAIN()AS LONG
   LOCAL prgName AS ASCIIZ *64, windowName AS ASCIIZ *32                      
   static hMutex AS LONG, nStyle AS LONG
   LOCAL x, y, x1, x2, w1, w2, w AS LONG
   LOCAL s AS STRING                                      
   'check if instance of winPam already running...
   windowName = "Phone & Address Manager"
   PrgName = "winPam " + $version + " by chasDietz"
   hMutex = CreateMutex(BYVAL %NULL, BYVAL %NULL, BYVAL VARPTR(PrgName))
   IF hMutex THEN                                                                                                    
      IF GetLastError = %ERROR_ALREADY_EXISTS THEN 'instance already running
         hWin = FindWindow(BYVAL %NULL, BYVAL VARPTR(windowName))
         ShowWindow hWin, %SW_RESTORE
         SetForegroundWindow hWin                                                    
         CloseHandle hMutex: EXIT FUNCTION
      END IF
   END IF
   initialize
   openIniFile
   'override thisFile if file is double-clicked
   s = REMOVE$(COMMAND$, ANY """")
   IF LEN(s) THEN thisFile = s                                            
   nStyle = %WS_SYSMENU + %WS_MINIMIZEBOX
   DIALOG NEW 0, windowName , , , winWidth, winHeight, nStyle TO hWin
   addMenu
   addToolBar
   addStatusBar
   addTabButtons
   nStyle = %WS_VSCROLL OR %LBS_DISABLENOSCROLL OR %LBS_USETABSTOPS OR %LBS_EXTENDEDSEL OR %WS_TABSTOP
   CONTROL ADD LISTBOX, hWin, %ID_ListBox,, listX, listY, listW, listH, nStyle, %WS_EX_CLIENTEDGE
   x = listX: y = listY - 10
   w1 = 10: w2 = 125 
   x1 = x + w1: x2 = x1 + w2
   w = listW - w1 - w2 - 12
   CONTROL ADD LABEL, hWin, -1, "x", x, y, w1, 10, %SS_CENTER, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hWin, -1, "   Name", x1, y, w2, 10, %SS_LEFT, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hWin, -1, "   Phone", x2, y, w, 10, %SS_LEFT, %WS_EX_STATICEDGE       
   DIALOG SHOW MODAL hWin CALL winProc
   CloseHandle hMutex
END FUNCTION                                                     

CALLBACK FUNCTION winProc() AS LONG
   LOCAL hIcon, hInst, delMergeRecords AS LONG
   LOCAL i, j, j1, j2, k, n, ok, isel AS LONG
   local flags AS DWORD
   LOCAL s, f, sPath, filter, sHelpFile AS STRING
   STATIC hBrush, checkedProperties, chgName AS LONG
   static lastFile as string
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         'show application icon 
         hInst = GetModuleHandle(BYVAL %NULL)
         hIcon = LoadImage(hInst, "pam", %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
         DIALOG SEND CBHNDL, %WM_SETICON, 0, hIcon
         bkgdColor=RGB(192, 255, 255)
         CONTROL HANDLE hWin&, %ID_ListBox TO hLB
         gOrigLBProc = SetWindowLong (hLB, %GWL_WNDPROC, CODEPTR(newLBProc&))
         hBrush = CreateSolidBrush(bkgdColor)
         ghKbdHook = SetWindowsHookEx(%WH_KEYBOARD, CODEPTR(KeyboardHook), 0, GetCurrentThreadID)
         DIALOG POST CB.HNDL, %ShowWindow, 0, 0
      CASE %WM_INITMENUPOPUP
         menuMode = -1  'allow keybd use for popup menu
      CASE %WM_EXITMENULOOP
         menuMode = 0
      CASE %WM_CTLCOLORDLG
         FUNCTION = hBrush
      CASE %ShowWindow
         IF checkedProperties = 0 THEN
             checkedProperties = 1                 
             f = dataFolder + "winPam.ini"
             IF isfile(f) = 0 THEN
                FILECOPY dataFolder + "winPamIni", f: propertiesDlg
             END IF
         END IF
         displayStatus 1, "": openTheFile
         IF pwLen = 0 OR pwVerified THEN lastFile = thisFile 'last verified file with password
         IF pwLen THEN MENU SET TEXT hFileMenu, BYCMD %ID_SetPW, "Clear password" 
         'tabNo = 0: tabRecords 0: menuLists                                                                 
         'if recordNo = 0 then recordNo = 1
         tabRecords tabno: menuLists
         if hiLite = 0 then hiLite = 1                                   
         listbox unselect cb.hndl, %ID_Listbox
         listbox select cb.hndl, %ID_Listbox, hiLite                                 
         'IF numRecords THEN CONTROL SEND hWin, %ID_ListBox, %LB_SETSEL, 1, 0
      CASE %WM_HELP 'F1 for help
         sHelpFile = helpFile  'ASCIIZ *260 to string
         appHelp sHelpFile, "winPam help", cb.hndl
      CASE %WM_COMMAND                                                    
         IF CBCTL > %ID_ToolBar AND CBCTL < %ID_StatusBar THEN
            'toolbar buttons ----------------------------------------------------
            SELECT CASE CBCTL
              CASE %ID_DialTB 'dial phone 
                 windowNo = 5: dialPhone: windowNo = 0
              CASE %ID_PhoneTB 'dial phone
                 windowNo = 5: xDialPhone: windowNo = 0
              CASE %ID_RmindTB 'show reminders
                 remindMode = 1: showReminders
              CASE %ID_FindTB 'find records
                 windowNo = 3: findRecords: reloadList = findMode: windowNo = 0
              CASE %ID_PrintTB 'print marked records
                 DIALOG SEND hWin, %WM_COMMAND, %ID_Print, 0                            
              CASE %ID_DataTB 'view record data
                 windowNo = 2: dataForm(1): windowNo = 0
              CASE %ID_NewTB, %ID_EditTB 'create/edit record
                 k = windowNo
                 if cb.ctl = %ID_EditTB then n = 2 else n = 0 
                 windowNo = 2: dataForm(n): windowNo = 0
                 if k = 4 then windowNo = k
              CASE %ID_QuitTB 'quit program
                 DIALOG SEND hWin, %WM_COMMAND, %ID_Exit, 0
            END SELECT
            'IF findMode = 0 THEN windowNo = 0
            CONTROL SEND hWin, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
            IF reloadList THEN tabRecords tabNo
            CONTROL SEND hWin, %ID_ListBox, %LB_SETSEL, 1, hiLite - 1
         ELSEIF CBCTL >= 100 AND CBCTL < %ID_ToolBar THEN
            'menu selections ----------------------------------------------------
            SELECT CASE CBCTL
              'File menu --------------------------------------------------------
              CASE %ID_Open
                 windowNo = 1: sPath = dataFolder: f = ""  ': lastFile = thisFile
                 filter = CHR$("Pam files", 0, "*.PAM", 0, "All files", 0, "*.*", 0)
                 flags = %OFN_FILEMUSTEXIST OR %OFN_EXPLORER OR %OFN_ENABLESIZING or %OFN_CREATEPROMPT
                 display openfile cb.hndl,,, "Open File", dataFolder, filter, "", "PAM", flags to f
                 IF LEN(f) THEN
                    IF fileChanged THEN
                       s = "File has changed..." + "Save it now?" + $CRLF + _
                           "(or the changes will be lost when the new file is loaded) "
                       n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Save File")
                       IF n = %IDYES THEN saveTheFile
                    END IF
                    thisFile = f: n = FREEFILE
                    OPEN f FOR BINARY AS n                      
                    IF LOF(n) = 0 THEN PUT n,, pamID
                    CLOSE n
                    'clear window and then open file                                         
                    'numRecords = 0: tabRecords 0:
                    pwVerified = 0
                    tabNo = 0: hiLite = 0: openTheFile
                    if pwLen = 0 or pwVerified then lastFile = thisFile             
                    IF pwLen AND pwVerified = 0 THEN 'reload last verified file
                       thisFile = lastFile: pwVerified = 1: tabNo = 0: hiLite = 0: openTheFile
                    END IF
                    displayStatus 1, "": saveIniFile
                    IF pwLen = 0 OR pwVerified THEN
                       numMarked = 0: tabNo = 0: tabRecords 0: menuLists
                       showTabButtons %SW_SHOWNORMAL
                    END IF
                 END IF
                 windowNo = 0
              CASE %ID_Save
                 n = MSGBOX("Save file now?", %MB_YESNO OR %MB_ICONQUESTION, "Save File")
                 IF n = %IDYES THEN
                    IF ISFILE(thisFile) THEN
                       fileChanged = 1: saveTheFile
                    ELSE
                       DIALOG SEND hWin, %WM_COMMAND, %ID_SaveAs, 0
                    END IF
                 END IF
              CASE %ID_SaveAs
                 windowNo = 1: sPath = dataFolder
                 f = PARSE$(thisFile, "\", -1)
                 flags = %OFN_OVERWRITEPROMPT OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES
                 IF ISTRUE (SaveFileDialog(hWin, "Save File", f, sPath,_
                       "Pam Files (*.pam)|*.pam|All Files (*.*)|*.*", "pam", flags)) THEN
                    thisFile = f: fileChanged = 1
                    saveIniFile: saveTheFile
                    displayStatus 1, ""
                 END IF
                 windowNo = 0
              CASE %ID_Merge
                 windowNo = 1
                 ti = "Merging data"
                 IF numMarked = 0 THEN
                    MSGBOX "Must select some records first", %MB_ICONWARNING, ti
                    windowNo = 0: EXIT FUNCTION
                 ELSE
                    s = "Delete records to be merged from this file?"
                    k = MSGBOX(s, %MB_ICONQUESTION OR %MB_YESNO, ti)
                    IF k = %IDYES THEN delMergeRecords = 1: INCR undoLevel
                 END IF
                 DIM mergeRec(numMarked) AS pamRecord
                 DIM mergeStr(numMarked) AS STRING
                 DIM mergeName(numMarked) AS STRING
                 DIM mergeCatg(numMarked) AS STRING
                 FOR i = 1 TO numRecords
                    IF BIT(pamRec(i).flag, 2) THEN
                       INCR n: mergeRec(n) = pamRec(i): mergeStr(n) = pamData(i)
                       mergeRec(n).Flag = mergeRec(n).Flag AND &H000F 'no lists
                       s = $TAB + LEFT$(pamData(i), pamRec(i).Lname)
                       f = MID$(pamData(i), pamRec(i).Lname + 1, pamRec(i).Fname)
                       IF pamRec(i).Fname THEN s = s + ", " + f
                       mergeName(n) = s: mergeCatg(n) = catg(pamRec(i).Catg)
                       IF MID$(s, 2, 1) = "!" THEN ok = 1
                       IF delMergeRecords THEN undel(i) = undoLevel
                    END IF
                 NEXT i
                 sPath = dataFolder: f = "": lastFile = thisFile
                 flags = %OFN_LONGNAMES + %OFN_CREATEPROMPT + %OFN_EXTENSIONDIFFERENT
                 ti = "File to merge with"
                 IF ISTRUE (OpenFileDialog(BYVAL hWin, BYVAL ti, f, BYVAL sPath,_
                    BYVAL "Pam Files (*.pam)|*.pam|All Files (*.*)|*.*", BYVAL "pam", flags)) THEN
                    IF fileChanged THEN
                       s = "File has changed..." + $CRLF + "Save it now?"
                       n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Save File")
                    END IF
                    IF n = %IDYES OR delMergeRecords THEN fileChanged = 1: saveTheFile
                    thisFile = f: n = FREEFILE
                    OPEN f FOR BINARY AS n
                       IF LOF(n) = 0 THEN PUT n,, pamID
                    CLOSE n
                    tabNo = 0: hiLite = 0: openTheFile
                    IF pwLen AND pwVerified = 0 THEN
                       thisFile = lastFile: tabNo = 0: hiLite = 0: openTheFile
                    ELSE
                       FOR i = 1 TO numMarked
                          recordNo = 0
                          insertRecord mergeName(i), mergeCatg(i), mergeRec(i), mergeStr(i)
                       NEXT i
                    END IF
                    menuLists: saveIniFile                         
                    tabNo = 0: IF ok THEN tabNo = 28
                    tabRecords tabNo: windowNo = 0
                 END IF
              CASE %ID_Import, %ID_Export 'import/export
                 windowNo = 1: portOpt = %ID_Export - CBCTL: portData: windowNo = 0
              CASE %ID_Prop
                 windowNo = 1: propertiesDlg: windowNo = 0
              CASE %ID_SetPW
                 IF pwLen THEN 'clear password
                    if pwVerified then                                                                
                       s = "Are you sure you wish to clear password?"
                       n = msgbox(s, %MB_iconwarning or %MB_yesno, "Clear Password")
                       if n = %idyes then 
                          tabNo = 0: hiLite = 0: openTheFile: pwLen = 0: fileChanged = 1
                          MENU SET TEXT hFileMenu, BYCMD %ID_SetPW, "Set password" 
                       end if
                    end if
                 ELSE 'set password                                                          
                    pwFile = setPassword: pwLen = LEN(pwFile)
                    IF pwLen THEN
                       pwVerified = 1: fileChanged = 1
                       MENU SET TEXT hFileMenu, BYCMD %ID_SetPW, "Clear password"
                    END IF
                 END IF
              CASE %ID_Print
                 windowNo = 1: printChoice: windowNo = 0: markRecords 3
              CASE %ID_Exit 'exit program
                 windowNo = 10: quitProgram
                 IF doNotQuit THEN windowNo = 0: EXIT FUNCTION
                 DIALOG END hWin
              case %ID_Exit + 1 to %ID_Exit + 4
                 f = recent(cb.ctl - %ID_Exit)
                 if isfile(f) then
                    IF fileChanged THEN
                       s = "File has changed..." + "Save it now?" + $CRLF + _
                           "(or the changes will be lost when the new file is loaded) "
                       n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Save File")
                       IF n = %IDYES THEN saveTheFile
                    END IF
                    thisFile = f: saveIniFile: tabNo = 0: hiLite = 0: openTheFile
                    IF pwLen = 0 OR pwVerified THEN
                       numMarked = 0: tabNo = 0: tabRecords 0: menuLists
                       showTabButtons %SW_SHOWNORMAL
                    END IF
                 end if
              'Edit menu --------------------------------------------------------
              CASE %ID_MarkSel 'toggle marking of selected records
                 markRecords
              CASE %ID_Markall 'mark all records shown
                 markRecords 1
              CASE %ID_Clear   'unmark all records shown
                 markRecords 2
              CASE %ID_ClrAll
                 markRecords 3
              CASE %ID_ViewData
                 DIALOG POST CB.HNDL, %WM_COMMAND, %ID_DataTB, 0
              CASE %ID_NewRec, %ID_EditRec 'create/edit record
                 DIALOG POST CB.HNDL, %WM_COMMAND, %ID_EditTB, 0 
              CASE %ID_DelRec
                 windowNo = 7: delRecords: windowNo = 0
              CASE %ID_UnDel                                             
                 windowNo = 7: undo
              'View menu --------------------------------------------------------
              CASE %ID_ViewAZ
                 tabNo = 0: tabRecords tabNo
              CASE %ID_ViewSpec
                 tabNo = 27: tabRecords tabNo
              CASE %ID_ViewAll
                 tabNo = 28: tabRecords tabNo
              CASE %ID_FindRec
                 windowNo = 3: findRecords: reloadList = findMode
              'Lists menu -------------------------------------------------------
              CASE %ID_AddList, %ID_EditList
                 windowNo = 4: listMode = 1: chgName = 1
                 if cb.ctl = %ID_EditList then chgName = 0
                 IF CBCTL = %ID_AddList AND numLists = 12 THEN
                    MSGBOX "Maximum number of lists already defined", %MB_OK + %MB_ICONINFORMATION, "Add List"
                    windowNo = 0: EXIT FUNCTION
                 END IF
                 IF CBCTL = %ID_AddList THEN
                    listSelected = 0: MENU SET STATE hListMenu, 1, %MF_GRAYED
                 END IF
                 IF listNo THEN 'edit list
                    numMarked = 0
                    FOR i = 1 TO numRecords 'select records in list
                       IF BIT(pamRec(i).flag, 0) = 0 THEN
                          'activate all undeleted records
                          BIT SET pamRec(i).flag, 1   
                          IF BIT(pamRec(i).flag, 3 + listNo) THEN _
                             BIT SET pamRec(i).flag, 2: INCR numMarked
                       END IF
                    NEXT i
                 END IF
                 tabNo = 0: tabRecords 0 'show [a-z] records
                 displayStatus 1, "*Select records making up this list..."
                 markedAs = 3: showTabButtons(%SW_HIDE)
              case %ID_RenameList
                 windowNo = 4: listMode = 1: listName
              CASE %ID_DeleteList
                 IF numLists > 0 THEN
                    n = MSGBOX("Delete this list?", %MB_YESNO + %MB_ICONWARNING, "Delete List Warning")
                    IF n = %IDYES THEN
                       'windowNo = 4: listMode = 1
                       MENU DELETE hListMenu, 4 + numLists: DECR numLists
                       FOR i = listNo TO numLists
                          listNames(i) = listNames(i + 1)
                          s = "&" + TRIM$(STR$(i)) + " " + listNames(i)
                          MENU SET TEXT hListMenu, 5 + i, s
                       NEXT i
                       j1 = 3 + listNo: j2 = 3 + numLists
                       for i = 1 to numRecords
                          n = pamRec(i).flag 
                          for j = j1 to j2
                             bit calc n, j, bit(n, j + 1)
                          next j
                          bit reset n, j2 + 1
                          pamRec(i).flag = n
                       next i
                       fileChanged = 1: menuLists
                       DIALOG SEND hWin, %WM_COMMAND, %ID_List1 + listNo - 1, 0
                    END IF
                 END IF
              CASE %ID_List1 TO %ID_List1 + 11 'selected a list
                 listNo = CBCTL - %ID_List1 + 1
                 showList: showMenuListItems
                 showTabButtons %SW_SHOWNORMAL
                 reloadList = 1
              'Tasks menu -------------------------------------------------------
              CASE %ID_DialPhone
                 windowNo = 5: dialPhone: windowNo = 0
              CASE %ID_xDialPhone
                 windowNo = 5: xDialPhone: windowNo = 0
              CASE %ID_PrintData
                 windowNo = 1: printData: windowNo = 0
              CASE %ID_AddrBook
                 windowNo = 1: printAddrBook: windowNo = 0
              CASE %ID_Labels
                 windowNo = 1: prnLabels: windowNo = 0
              CASE %ID_Envelopes
                 windowNo = 1: prnEnvelopes: windowNo = 0
              CASE %ID_Calendar
                 windowNo = 5: calendar: windowNo = 0
              CASE %ID_Reminder
                 windowNo = 5: remindMode = 1: showReminders: remindMode = 0
              'Help menu --------------------------------------------------------
              CASE %ID_Help
                 windowNo = 6: sHelpFile = helpFile
                 appHelp sHelpFile, "winPam help", cb.hndl                 
              CASE %ID_About
                 windowNo = 6: showAbout
            END SELECT
            IF reloadList THEN
               CONTROL SEND hWin, %ID_ListBox, %LB_GETTOPINDEX, 0, 0 TO n
               tabRecords tabNo: reloadList = 0
               IF hiLite < n + 23 THEN CONTROL SEND hWin, %ID_ListBox, %LB_SETTOPINDEX, n, 0
            END IF
            IF pwLen = 0 OR pwVerified THEN
               IF numRecords THEN CONTROL SEND hWin, %ID_ListBox, %LB_SETSEL, 1, hiLite - 1
            END IF
         ELSEIF CBCTL = %IDOK AND findMode THEN
            FOR i = 1 TO numRecords
               ok = 0
               IF listNo = 0 AND BIT(pamRec(i).flag, 0) = 0 THEN ok = 1
               IF listNo AND BIT(pamRec(i).flag, 3 + listNo) THEN ok = 1
               IF ok THEN BIT SET pamRec(i).flag, 1
            NEXT i
            if listMode = 0 then
               tabNo = savedTabNo
               recordNo = viewList(hiLite)
               showTabButtons %SW_SHOWNORMAL
               tabRecords tabNo
               CONTROL SEND hWin, %ID_ListBox, %LB_SETSEL, 1, hiLite - 1
               showMenuListItems
            else
               DIALOG SEND hWin, %WM_COMMAND, %ID_EditList, 0
            END IF
            findMode = 0
         ELSEIF (CBCTL = %IDOK OR CBCTL = %IDCANCEL) AND windowNo = 4 THEN
            'add/edit list ------------------------------------------------------
            IF CBCTL = %IDOK and chgName THEN
               listName
            END IF
            listSelected = 0: chgName = 0
            j = 3 + listNo
            FOR i = 1 TO numRecords
               IF BIT(pamRec(i).flag, 2) THEN
                  BIT SET pamRec(i).flag, j
               ELSE
                  BIT RESET pamRec(i).flag, j
               END IF
            NEXT i
            fileChanged = 1
            IF listNo THEN
               DIALOG SEND hWin, %WM_COMMAND, %ID_List1 + listNo - 1, 0
            ELSE 'cancel button
               showTabButtons %SW_SHOWNORMAL
               DIALOG SEND hWin, %WM_COMMAND, %ID_ClrAll, 0
               MENU SET STATE hListMenu, 1, %MF_ENABLED
            END IF
            listMode = 0
         ELSEIF CBCTL >= %ID_TabButtons AND CBCTL < 950 THEN
            'tab buttons --------------------------------------------------------
            IF (CBCTL - 900 <> tabNo) OR (tabNo = 28) THEN
               tabNo = CBCTL - 900: tabRecords tabNo
            END IF
            CONTROL SEND hWin, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
            CONTROL SEND hWin, %ID_ListBox, %LB_SETSEL, 1, hiLite - 1
            CONTROL SET FOCUS hWin, %ID_ListBox
         ELSEIF CBCTL = %ID_ListBox THEN
            'listbox messages ---------------------------------------------------
            IF CBCTLMSG = %LBN_SELCHANGE THEN
               CONTROL SEND hWin, %ID_ListBox, %LB_GETCURSEL, 0, 0 TO isel
               hiLite = isel + 1: recordNo = viewList(hiLite): displayStatus 3, ""
            ELSEIF CBCTLMSG = %LBN_DBLCLK THEN 
               'DIALOG SEND CBHNDL, %WM_COMMAND, %ID_DialTB, 0
               DIALOG POST CB.HNDL, %WM_COMMAND, %ID_EditTB, 0
            END IF
         END IF
      CASE %WM_SYSCOMMAND
         'IF CBCTL = %SC_CLOSE THEN
         IF (CB.WPARAM AND &HFFF0) = %SC_CLOSE THEN
            quitProgram
            IF doNotQuit THEN FUNCTION = 1
         END IF
      CASE %WM_DESTROY
         DeleteObject hBrush
         ReleaseDC hWin, hDispDC
         UnhookWindowsHookEx ghKbdHook
   END SELECT
END FUNCTION

FUNCTION KeyboardHook(BYVAL iCode AS INTEGER, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS DWORD
   'trap keyboard responses - see newLBProc subclass for mouse responses
   LOCAL i AS LONG, j AS LONG, k AS LONG, n AS LONG, numSelected AS LONG
   STATIC COUNT AS LONG
   IF iCode < 0 THEN
      FUNCTION = CallNextHookEx(ghKbdHook, iCode, wParam, lParam)
      EXIT FUNCTION
   END IF
   IF iCode <> %HC_ACTION THEN EXIT FUNCTION
   INCR COUNT: IF COUNT MOD 2 = 0 THEN COUNT = 0: EXIT FUNCTION
   i = GetKeyState(%VK_SHIFT) AND &H8000
   j = GetKeyState(%VK_CONTROL) AND &H8000
   k = GetKeyState(%VK_MENU) AND &H8000
   if wParam = %VK_V and j then exit function
   CONTROL SEND hWin,%ID_ListBox, %LB_GETSELCOUNT, 0, 0 TO numSelected
   IF remindMode OR findMode OR findModeExp THEN
      n = hExpNote: IF remindMode THEN n = hRemind
      IF wParam = %VK_F3 AND i THEN
         DIALOG SEND n, %WM_COMMAND, %ID_Prev, 0
      ELSEIF wParam = %VK_F3 THEN
         DIALOG SEND n, %WM_COMMAND, %ID_Next, 0
      END IF
      EXIT FUNCTION
   ELSEIF viewOpt = 1 THEN
      SELECT CASE wParam
      CASE %VK_UP
         DIALOG SEND hForm, %WM_COMMAND, %ID_ADD, 0
      CASE %VK_DOWN
         DIALOG SEND hForm, %WM_COMMAND, %ID_Close, 0
      END SELECT
      EXIT FUNCTION
   elseif editPhoneID then
      if wParam = %VK_RETURN then
         returnKey = 1
         DIALOG SEND hForm, %WM_COMMAND, %ID_PhoneID, 0
      end if
      exit function
   ELSEIF pwMode OR windowNo OR k THEN
      EXIT FUNCTION
   ELSEIF menuMode THEN
      'IF wparam = %VK_RETURN THEN returnKey = 1
      EXIT FUNCTION
   END IF
   SELECT CASE wParam
   CASE %VK_RETURN
      'IF numSelected = 1 then
      IF numSelected = 1 and WindowNo <> 4 THEN
         IF i OR j THEN k = %ID_EditTB ELSE k = %ID_DataTB
         DIALOG SEND hwin, %WM_COMMAND, k, 0
      END IF
   CASE %VK_ESCAPE
      markRecords 3
   CASE %VK_A TO %VK_Z
      IF j AND wParam = %VK_A THEN
         markRecords 1: marking = 0
      ELSEIF listMode = 0 THEN
         FOR i = 1 TO 26
            IF UCASE$(CHR$(wParam)) = LEFT$(tabs(i), 1) THEN n = i
         NEXT i
      END IF
   CASE %VK_INSERT
      dataForm
   CASE %VK_DELETE
      DIALOG SEND hWin, %WM_COMMAND, %ID_DelRec, 0
   CASE %VK_SPACE
      marking = 0: n = -1
      IF j THEN n = 28
      IF i THEN n = 27
   CASE %VK_F3
      IF findMode THEN
         IF i THEN
            DIALOG SEND hExpNote, %WM_COMMAND, %ID_Prev, 0
         ELSE                                                                             
            DIALOG SEND hExpNote, %WM_COMMAND, %ID_Next, 0
         END IF
      ELSE
         DIALOG SEND hWin, %WM_COMMAND, %ID_FindTB, 0
      END IF
   CASE ELSE
      DIALOG SEND hWin, %WM_COMMAND, %ID_ListBox, 0
   END SELECT
   IF n = 0 THEN EXIT FUNCTION ELSE n = MAX(n, 0)
   IF tabNo <> n THEN
      tabNo = n: tabRecords tabNo
      CONTROL SEND hWin, %ID_ListBox, %LB_SETSEL, 1, hiLite - 1
   END IF
END FUNCTION

FUNCTION newLBProc&(BYVAL h&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&)
   'trap mouse responses - see keybdHook for keyboard responses
   LOCAL i, n AS LONG
   LOCAL pt AS POINTAPI
   STATIC mouseBtn, hiLite0 AS LONG
   SELECT CASE wMsg&
      CASE %WM_LBUTTONDOWN
         mouseBtn = 1
      CASE %WM_LBUTTONUP
         mouseBtn = 0
      CASE %WM_RBUTTONDOWN
         pt.x = LOWRD(lParm&): pt.y = HIWRD(lParm&)
         ClientToScreen hWin, pt
         CONTROL SEND hWin, %ID_Listbox, %LB_GETSELCOUNT, 0, 0 TO n
         IF n = 1 THEN CONTROL SEND hWin, %ID_ListBox, %LB_SETSEL, 0, hiLite - 1
         CONTROL SEND hWin, %ID_Listbox, %LB_ITEMFROMPOINT, 0, lParm& TO n
         hiLite = n + 1: recordNo = viewList(hiLite)
         CONTROL SEND hWin, %ID_ListBox, %LB_SETSEL, 1, hiLite - 1
         n = %TPM_RIGHTBUTTON + %TPM_LEFTALIGN
         TrackPopupMenuEx hMouseMenu, 0, pt.x, pt.y, hWin, BYVAL %NULL
      CASE %WM_KEYDOWN
         IF wParm& = %VK_CONTROL AND marking = 0 THEN
            marking = 1
            CONTROL SEND hWin, %ID_ListBox, %LB_GETCURSEL, 0, 0 TO hiLite0
         ELSEIF wParm& = %VK_SHIFT THEN
            marking = 2
         END IF
      CASE %WM_KEYUP
         IF wParm& = %VK_UP OR wParm& = %VK_DOWN OR _
            wParm& = %VK_PGUP OR wParm& = %VK_PGDN OR _
            wParm& = %VK_HOME OR wParm& = %VK_END THEN
            i = GetKeyState(%VK_SHIFT) AND &H8000
            IF i THEN marking = 2: EXIT SELECT
         ELSEIF wParm& = %VK_SHIFT OR wParm& = %VK_CONTROL THEN
            IF marking AND mouseBtn = 0 THEN
               IF marking = 1 THEN CONTROL SEND hWin, %ID_ListBox, %LB_SETSEL, 0, hiLite0
               CONTROL SEND hWin, %ID_ListBox, %LB_SETSEL, 1, hiLite - 1
               markRecords: marking = 0
               CONTROL SEND hWin, %ID_ListBox, %LB_SETSEL, 1, hiLite - 1
            END IF
         END IF
   END SELECT
   FUNCTION = callWindowProc(gOrigLBProc, h&, wMsg&, wParm&, lParm&)
END FUNCTION

SUB initialize()
   LOCAL tm AS TEXTMETRIC
   REDIM pamRec(0) AS GLOBAL pamRecord
   REDIM pamData(0) AS GLOBAL STRING
   REDIM viewListStr(0) AS GLOBAL STRING
   REDIM undel(0) AS LONG
   REDIM catg(%MaxCatgs) AS GLOBAL STRING
   REDIM listNames(12) AS GLOBAL STRING
   REDIM toTitle(11) AS GLOBAL STRING
   REDIM tabs(28) AS GLOBAL STRING
   REDIM phoneID(3) AS GLOBAL STRING
   REDIM labelName(1 TO %MaxLabels) AS GLOBAL STRING
   REDIM labelWidth(1 TO %MaxLabels) AS GLOBAL DOUBLE
   REDIM labelHeight(1 TO %MaxLabels) AS GLOBAL DOUBLE
   REDIM labelLeft(1 TO %MaxLabels) AS GLOBAL DOUBLE
   REDIM labelTop(1 TO %MaxLabels) AS GLOBAL DOUBLE
   REDIM labelSpacW(1 TO %MaxLabels) AS GLOBAL DOUBLE
   REDIM labelSpacH(1 TO %MaxLabels) AS GLOBAL DOUBLE
   REDIM envName(1 TO %MaxEnvelopes) AS GLOBAL STRING
   REDIM envHorz(1 TO %MaxEnvelopes) AS GLOBAL DOUBLE
   REDIM envVert(1 TO %MaxEnvelopes) AS GLOBAL DOUBLE
   REDIM month(1 TO 12) AS GLOBAL STRING 
   redim recData(15) as global string
   'REDIM myReminders(%maxReminders) AS reminderType
   reDIM recent(1 TO 4) as global string
   REDIM nEvents(1 TO 32) AS GLOBAL STRING
   REDIM sPrefix(2) AS GLOBAL STRING
   tabs(27) = "!"
   month(1) = "Jan"
   month(2) = "Feb"
   month(3) = "Mar"
   month(4) = "Apr"
   month(5) = "May"
   month(6) = "Jun"
   month(7) = "Jul"
   month(8) = "Aug"
   month(9) = "Sep"
   month(10) = "Oct"
   month(11) = "Nov"
   month(12) = "Dec"
   toTitle(0) = " "
   toTitle(1) = "Mr. & Mrs."
   toTitle(2) = "Mr."
   toTitle(3) = "Mrs."
   toTitle(4) = "Miss"
   toTitle(5) = "Ms."
   toTitle(6) = "Dr."
   toTitle(7) = "Rev."
   toTitle(8) = "Pastor"
   toTitle(9) = "Dr. & Mrs."
   toTitle(10) = "Rev. & Mrs."                                                        
   toTitle(11) = "Pastor & Mrs."                                                              
   envName(1) = "Business Env [4 1/8 x 9 1/2]"                                    
   envName(2) = "Monarch Env [3 7/8 x 7 1/2]"
   envName(3) = "Personal Env [3 5/8 x 6 1/2]"
   envelopeSize = 1
   pamID = "winPam" + MID$($version, 5)
   winWidth = 270
   winHeight = 280   
   listX = 10
   listY = 40
   listW = winWidth - 70
   listH = winHeight - 85
   hDispDC = GetDC(hWin)
   GetTextMetrics hDispDC, tm
   lineHt = tm.tmHeight + tm.tmExternalLeading
   screenY = GetSystemMetrics(%SM_CYSCREEN)        
   fontType = "Times New Roman"
   fontType = "MS Sans Serif"
   'progFolder = CURDIR$ 
   dataFolder = curdir$ + "\"
   if isfile(dataFolder + "winPam.ini") = 0 or isfile(dataFolder + "winPam.ahp") = 0 then
      dataFolder = specialFolder(%CSIDL_COMMON_APPDATA) + "\cgdSoftware\winPam\"
   end if
   helpFile = dataFolder + "winPam.ahp" 
END SUB
                                             
SUB addMenu()
   LOCAL i, k, n AS LONG
   LOCAL s AS STRING
   MENU NEW BAR TO hMenu
   MENU NEW POPUP TO hFileMenu '-----------------------------------
   MENU ADD STRING, hFileMenu, "&Open", %ID_Open, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Save", %ID_Save, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "Save&As", %ID_SaveAs, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0
   MENU ADD STRING, hFileMenu, "&Merge data", %ID_Merge, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Import data", %ID_Import, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "&Export data", %ID_Export, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0
   MENU ADD STRING, hFileMenu, "&Properties", %ID_Prop, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "Set pass&word", %ID_SetPW, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "P&rint", %ID_Print, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0
   MENU ADD STRING, hFileMenu, "E&xit", %ID_Exit, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0
   FOR i = 1 TO 4 'add recent files to File menu
      incr n: s = recent(i)
      if len(s) = 0 then iterate
      if isfile(s) = 0 then k = 1: iterate 
      if ucase$(pathname$(path, s)) = ucase$(dataFolder) then s = pathname$(namex, s)
      s = "&" + TRIM$(STR$(i)) + " " + s
      MENU ADD STRING, hFileMenu, s, %ID_Exit + i, %MF_ENABLED
      recent(n) = recent(i)
   NEXT i
   if k then saveIniFile 'recent() was just changed
   MENU ADD POPUP, hMenu, "&File", hFileMenu, %MF_ENABLED
   MENU NEW POPUP TO hEditMenu '-----------------------------------
   MENU ADD STRING, hEditMenu, "&Mark Selected", %ID_MarkSel, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "Mark &All Shown" + $TAB + "Ctrl+A", %ID_Markall, %MF_ENABLED     
   MENU ADD STRING, hEditMenu, "UnMark All &Shown", %ID_Clear, %MF_GRAYED
   MENU ADD STRING, hEditMenu, "UnMar&k All" + $TAB + "ESC", %ID_ClrAll, %MF_GRAYED       
   MENU ADD STRING, hEditMenu, "-", 0, 0                                                       
   MENU ADD STRING, hEditMenu, "&New Record", %ID_NewRec, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Edit Record" + $TAB + "SHFT+ENTER", %ID_EditRec, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "-", 0, 0
   MENU ADD STRING, hEditMenu, "&Delete Records" + $TAB + "DEL", %ID_DelRec, %MF_ENABLED
   MENU ADD STRING, hEditMenu, "&Undo", %ID_UnDel, %MF_GRAYED
   MENU ADD POPUP, hMenu, "&Edit", hEditMenu, %MF_ENABLED
   MENU NEW POPUP TO hViewMenu '-----------------------------------
   MENU ADD STRING, hViewMenu, "View A-&Z" + $TAB + "SPACE", %ID_ViewAZ, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "View &Special" + $TAB + "Shft+SPACE", %ID_ViewSpec, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "View &All" + $TAB + "Ctrl+SPACE", %ID_ViewALL, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "View &Data" + $TAB + "ENTER", %ID_ViewData, %MF_ENABLED
   MENU ADD STRING, hViewMenu, "&Find" + $TAB + "F3", %ID_FindRec, %MF_ENABLED
   MENU ADD POPUP, hMenu, "&View", hViewMenu, %MF_ENABLED
   MENU NEW POPUP TO hListMenu '-----------------------------------
   MENU ADD STRING, hListMenu, "&Add New List", %ID_AddList, %MF_ENABLED
   MENU ADD STRING, hListMenu, "&Redefine List", %ID_EditList, %MF_GRAYED
   MENU ADD STRING, hListMenu, "&Rename List", %ID_RenameList, %MF_GRAYED
   MENU ADD STRING, hListMenu, "&Delete List", %ID_DeleteList, %MF_GRAYED
   MENU ADD STRING, hListMenu, "-", 0, 0
   MENU ADD POPUP, hMenu, "&Lists", hListMenu, %MF_ENABLED
   MENU NEW POPUP TO hTaskMenu '-----------------------------------
   MENU ADD STRING, hTaskMenu, "&Dial Phone", %ID_DialPhone, %MF_ENABLED
   MENU ADD STRING, hTaskMenu, "&xDial Phone", %ID_xDialPhone, %MF_ENABLED
   MENU ADD STRING, hTaskMenu, "&Print Data", %ID_PrintData, %MF_ENABLED
   MENU ADD STRING, hTaskMenu, "&Print AddrBook", %ID_AddrBook, %MF_ENABLED
   MENU ADD STRING, hTaskMenu, "&Print Labels", %ID_Labels, %MF_ENABLED
   MENU ADD STRING, hTaskMenu, "&Print Envelopes", %ID_Envelopes, %MF_ENABLED
   MENU ADD STRING, hTaskMenu, "&Calendar", %ID_Calendar, %MF_ENABLED
   MENU ADD STRING, hTaskMenu, "&Reminders", %ID_Reminder, %MF_ENABLED
   MENU ADD POPUP, hMenu, "&Tasks", hTaskMenu, %MF_ENABLED
   MENU NEW POPUP TO hHelpMenu '-----------------------------------
   MENU ADD STRING, hHelpMenu, "&Help" + $TAB + "F1", %ID_Help, %MF_ENABLED
   MENU ADD STRING, hHelpMenu, "&About", %ID_About, %MF_ENABLED
   MENU ADD POPUP, hMenu, "&Help", hHelpMenu, %MF_ENABLED
   MENU ATTACH hMenu, hWin
   
   'create popup menu for record list
   MENU NEW POPUP TO hMouseMenu '-----------------------------------
   MENU ADD STRING, hMouseMenu, "Mark", %ID_MarkSel, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Dial", %ID_DialPhone, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Print", %ID_Print, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "-", 0, 0
   MENU ADD STRING, hMouseMenu, "Data", %ID_ViewData, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Edit", %ID_EditRec, %MF_ENABLED                          
   MENU ADD STRING, hMouseMenu, "Delete", %ID_DelRec, %MF_ENABLED
                           
   'create popup menu for textbox/richText control
   MENU NEW POPUP TO hTextboxMenu                                      
   MENU ADD STRING, hTextboxMenu, "Undo", %ID_Undo, %MF_ENABLED
   MENU ADD STRING, hTextboxMenu, "-", 0, 0
   MENU ADD STRING, hTextboxMenu, "Cut", %ID_Cut, %MF_ENABLED
   MENU ADD STRING, hTextboxMenu, "Copy", %ID_Copy, %MF_ENABLED
   MENU ADD STRING, hTextboxMenu, "Paste", %ID_Paste, %MF_ENABLED
   MENU ADD STRING, hTextboxMenu, "Delete", %ID_Clear, %MF_ENABLED
   MENU ADD STRING, hTextboxMenu, "-", 0, 0
   MENU ADD STRING, hTextboxMenu, "Select All", %ID_SelAll, %MF_ENABLED
END SUB

SUB updateMenus
   IF numMarked THEN
      MENU SET STATE hEditMenu, 3, %MF_ENABLED
      MENU SET STATE hEditMenu, 4, %MF_ENABLED
   ELSE
      MENU SET STATE hEditMenu, 3, %MF_GRAYED
      MENU SET STATE hEditMenu, 3, %MF_GRAYED
   END IF
   IF undoLevel THEN
      MENU SET STATE hEditMenu, 10, %MF_ENABLED
   ELSE                                                                         
      MENU SET STATE hEditMenu, 10, %MF_GRAYED
   END IF
END SUB

SUB menuLists
   LOCAL i AS INTEGER, s AS STRING
   FOR i = 1 TO 12
      MENU DELETE hListMenu, BYCMD (%ID_List1 + i - 1)
   NEXT i
   FOR i = 1 TO numLists
      s = "&" + TRIM$(STR$(i)) + " " + listNames(i)
      MENU ADD STRING, hListMenu, s, %ID_List1 + i - 1, %MF_ENABLED , AT 5 + i
   NEXT i
END SUB

SUB showMenuListItems
   IF listSelected THEN
      MENU SET STATE hListMenu, 1, %MF_GRAYED
      MENU SET STATE hListMenu, 2, %MF_ENABLED
      MENU SET STATE hListMenu, 3, %MF_ENABLED
      MENU SET STATE hListMenu, 4, %MF_ENABLED
   ELSE
      MENU SET STATE hListMenu, 1, %MF_ENABLED
      MENU SET STATE hListMenu, 2, %MF_GRAYED
      MENU SET STATE hListMenu, 3, %MF_GRAYED
      MENU SET STATE hListMenu, 4, %MF_GRAYED
   END IF
END SUB

SUB addToolBar()
   LOCAL nStyle AS LONG
   nStyle = %SS_GRAYRECT + %SS_BLACKFRAME
   CONTROL ADD LINE, hWin, %ID_Toolbar, "", 0, 0, winWidth - 4, 22, nStyle, %WS_EX_CLIENTEDGE
   nStyle = %BS_CENTER
   CONTROL ADD BUTTON, hWin, %ID_DialTB, "Dial", 2, 2, 25, 18, nStyle
   CONTROL ADD BUTTON, hWin, %ID_PhoneTB, "xDial", 27, 2, 25, 18, nStyle
   CONTROL ADD BUTTON, hWin, %ID_RmindTB, "Rmind", 60, 2, 25, 18, nStyle
   CONTROL ADD BUTTON, hWin, %ID_FindTB, "Find", 85, 2, 25, 18, nStyle
   CONTROL ADD BUTTON, hWin, %ID_PrintTB, "Print", 110, 2, 25, 18, nStyle
   CONTROL ADD BUTTON, hWin, %ID_DataTB, "Data", 143, 2, 25, 18, nStyle
   CONTROL ADD BUTTON, hWin, %ID_NewTB, "New", 168, 2, 25, 18, nStyle
   CONTROL ADD BUTTON, hWin, %ID_EditTB, "Edit", 193, 2, 25, 18, nStyle
   CONTROL ADD BUTTON, hWin, %ID_QuitTB, "Quit", 226, 2, 25, 18, nStyle
END SUB

SUB addStatusBar()
   DIM sbParts(3) AS LONG
   hStatus = CreateStatusWindow(%WS_CHILD OR %WS_VISIBLE, BYVAL %NULL, hWin, 200)
   sbParts(0) = 258
   sbParts(1) = 330
   sbParts(2) = -1      'sets last one to right edge
   SendMessage(hStatus, %SB_SETPARTS, 3, BYVAL VARPTR(sbParts(0)))
END SUB

SUB displayStatus(panelNo AS BYTE, s AS STRING)
   LOCAL n AS LONG
   LOCAL nameOfFile, thisFileDir AS STRING
   IF panelNo = 1 THEN
      IF LEN(s) THEN
         IF LEFT$(s, 1) = "*" THEN
            s = MID$(s, 2)
         ELSE
            s = "Status: " + s
            IF markedAs = 1 THEN
               s = s + " as undeleted"
            ELSEIF markedAs = 2 THEN
               s = s + " as unaddressable"
            ELSEIF markedAs = 3 THEN
               s = s +  " for list" + STR$(listNo)
            END IF
         END IF
      ELSE
         n = INSTR(-1, thisFile, "\")
         IF n THEN thisFileDir = LEFT$(thisFile, n)
         nameOfFile = MID$(thisFile, n + 1)
         IF LCASE$(dataFolder) = LCASE$(thisFileDir) THEN
            s = nameOfFile
         ELSE
            s = thisFile
         END IF
      END IF
   ELSEIF panelNo = 3 THEN
      s = STR$(hiLite) + " of " + STR$(numView)
   END IF
   SendMessage hStatus, %SB_SETTEXT, panelNo - 1, BYVAL STRPTR(s)
END SUB

SUB addTabButtons
   LOCAL i AS INTEGER, n AS INTEGER
   LOCAL x1 AS LONG, x2 AS LONG
   LOCAL x AS LONG, y AS LONG, w AS LONG
   LOCAL nStyle AS LONG, ID AS LONG
   x = listX + listW + 5: y = listY '+ 10
   i = listX + listW + 5
   nStyle = %BS_DEFAULT + %WS_TABSTOP
   CONTROL ADD BUTTON, hWin, %IDOK, "&Ok", x, y, 40, 25, nStyle
   CONTROL ADD BUTTON, hWin, %IDCANCEL, "&Cancel", i, listY+30, 40, 25
   CONTROL DISABLE hWin, %IDOK
   CONTROL DISABLE hWin, %IDCANCEL
   CONTROL SHOW STATE hWin, %IDOK, %SW_HIDE
   CONTROL SHOW STATE hWin, %IDCANCEL, %SW_HIDE
   nStyle = %BS_CENTER
   w = listX + listW
   getTabLabels
   FOR i = 0 TO 12
      n = 2 * i
      y = listY + 15 + 12 * i
      x1 = w + 5
      x2 = x1 + 20
      ID = %ID_TabButtons + n + 1
      CONTROL ADD BUTTON, hWin, ID, tabs(n + 1), x1, y, 20, 12, nStyle
      CONTROL ADD BUTTON, hWin, ID + 1, tabs(n + 2), x2, y, 20, 12, nStyle
   NEXT i
   CONTROL ADD BUTTON, hWin, %ID_TabButtons + 27, "&Special", x1, y + 12, 40, 18, nStyle
   CONTROL ADD BUTTON, hWin, %ID_TabButtons, "A-Z", x1, listY-3, 40, 18, nStyle
END SUB

SUB showTabButtons(n AS LONG)
   'show and hide tab buttons, ok button for find mode                             
   LOCAL i AS LONG
   FOR i = 0 TO 27
      CONTROL SHOW STATE hWin, %ID_TabButtons + i, n
   NEXT i
   IF n THEN
      CONTROL DISABLE hWin, %IDOK
      CONTROL DISABLE hWin, %IDCANCEL
      CONTROL SHOW STATE hWin, %IDOK, %SW_HIDE
      CONTROL SHOW STATE hWin, %IDCANCEL, %SW_HIDE
      findMode = 0: listMode = 0: windowNo = 0
   ELSEIF findMode THEN
      CONTROL ENABLE hWin, %IDOK
      CONTROL SHOW STATE hWin, %IDOK, %SW_SHOWNORMAL
   ELSEIF listMode THEN
      CONTROL ENABLE hWin, %IDOK
      CONTROL ENABLE hWin, %IDCANCEL
      CONTROL SHOW STATE hWin, %IDOK, %SW_SHOWNORMAL
      CONTROL SHOW STATE hWin, %IDCANCEL, %SW_SHOWNORMAL
   END IF
END SUB

SUB getTabLabels                                                              
   LOCAL i AS INTEGER, f AS STRING
   LOCAL TXT AS STRING
   f = tabLabels
   FOR i = 1 TO 26
      TXT = ""
      IF LEN(f) THEN
         TXT = MID$(f, 1, 1)
         IF LEN(f) > 2 AND MID$(f, 2, 1) = "-" THEN
            TXT = TXT + "-" + MID$(f, 3, 1)
            f = MID$(f, 4)
         ELSE
            f = MID$(f, 2)
         END IF
      END IF
      tabs(i) = TXT
   NEXT i
END SUB

SUB tabRecords(BYVAL ntab AS LONG)
   LOCAL f, f0, f1, strData, s AS STRING
   LOCAL i, ok, found AS LONG
   REDIM viewList(numRecords)
   IF ntab > 0 THEN f = tabs(ntab) ELSE f = "A-Z"
   f0 = f: f1 = f
   IF LEN(f) > 1 THEN
     f0 = MID$(f, 1, 1)
     f1 = MID$(f, 3, 1)
   END IF                                                       
   numView = 0 ': hiLite = 0
   FOR i = 1 TO numRecords
      ok = 0
      IF ntab < 0 THEN 'for viewing specials
         strData = pamData(i)
         s = UCASE$(LEFT$(strData, 1))
         IF s = "!" THEN ok = 1 ELSE EXIT FOR
      ELSEIF BIT(pamRec(i).flag, 1) THEN
         strData = pamData(i)
         s = UCASE$(LEFT$(strData, 1))
         IF ntab = 0 AND printingAddrBook AND numMarked = 0 THEN
            IF LEFT$(s, 1) >= "A" THEN EXIT FOR 'beginning with numbers only
         END IF
         IF nTab = 28 AND s = "!" THEN 'view all incl special
            ok = 1
         ELSEIF tabNo = 27 THEN 'view special only
            IF s = "!" THEN ok = 1 ELSE EXIT FOR
         ELSEIF nTab = 0 OR nTab = 28 THEN 'view all not special
            IF s > "!" THEN ok = 1
         ELSEIF nTab AND (s >= f0 AND s <= f1) THEN
            ok = 1
         END IF
      END IF
      
      IF ok THEN
         INCR numView: viewList(numView) = i
         IF hiLite and i = recordNo THEN found = numView
      END IF
   NEXT i
   IF printingAddrBook THEN EXIT SUB 'don't want to list records
   hiLite = found
   IF hiLite = 0 THEN hiLite = 1: recordNo = MIN(numRecords, viewList(1))
   listRecords
   reloadList = 0
   IF nTab = 27 THEN
      s = "Special"
   ELSEIF nTab = 28 THEN
      s = "All Records"
   ELSE
      s = "[ " + f + " ] list"
      IF listSelected THEN s = s + STR$(listNo)
   END IF
   displayStatus 2, s
END SUB

SUB listRecords()
   'dispay records for active tab - lastName, firstName, 1st phone
   LOCAL i AS INTEGER, j AS INTEGER, s AS STRING
   DIM lptr AS LONG PTR
   DIM tabstops(1) AS LONG
   tabstops(0) = 10
   tabstops(1) = 135
   lptr=VARPTR(tabstops(0))
   CONTROL SEND hWin, %ID_ListBox, %LB_SETTABSTOPS, 2, lptr
   LISTBOX RESET hWin, %ID_ListBox 
   FOR i = 1 TO numView
      j = viewList(i)
      s = viewListStr(j): s = TRIM$(s)
      IF tabNo = 27 THEN
         s = $TAB + LTRIM$(MID$(s, 2), ANY " ,!0123456789")
      END IF
      IF BIT(pamRec(j).flag, 2) THEN s = "x" + s
      LISTBOX ADD hWin,%ID_ListBox, s
   NEXT i
   CONTROL SET FOCUS hWin, %ID_ListBox
   s = ""
   IF numMarked THEN s = STR$(numMarked) + " marked" ELSE markedAs = 0
   displayStatus 1, s: displayStatus 3, ""
END SUB

SUB markRecords(OPTIONAL BYVAL nOpt AS LONG)
   'nOpt = 0  toggle mark for selected records (default)
   '     = 1  mark all records currently in listbox now
   '     = 2  unmark all records currently in listbox now
   '     = 3  unmark all records
   LOCAL i, j, k, m, top AS LONG, s AS STRING
   CONTROL SEND hWin, %ID_ListBox, %LB_GETTOPINDEX, 0, 0 TO top
   CONTROL SEND hWin, %ID_ListBox, %WM_SETREDRAW, %FALSE, 0
   IF nOpt = 3 THEN 'unmark all records
      FOR i = 1 TO numRecords
         BIT RESET pamRec(i).flag, 2
      NEXT i: numMarked = 0
   ELSE
      FOR i = 1 TO numView
         k = viewList(i): j = 0: m = BIT(pamRec(k).flag, 2)
         IF nOpt = 1 THEN 'mark all in listbox
            IF m = 0 THEN BIT SET pamRec(k).flag, 2: j = 1
         ELSEIF nOpt = 2 THEN 'unmark all in listbox
            IF m THEN BIT RESET pamRec(k).flag, 2: j = -1
         ELSE 'toggle selected marking (default)
            CONTROL SEND hWin, %ID_ListBox, %LB_GETSEL, i - 1, 0 TO j
            IF j THEN
               BIT TOGGLE pamRec(k).flag, 2
               IF m THEN j = -1 ELSE j = 1  'INCR numMarked ELSE DECR numMarked
            END IF
         END IF
         IF j THEN numMarked = numMarked + j
      NEXT i
   END IF 
   listRecords
   CONTROL SEND hWin, %ID_ListBox, %WM_SETREDRAW, %TRUE, 0
   CONTROL SEND hWin, %ID_ListBox, %LB_SETSEL, 1, hiLite - 1
   CONTROL SEND hWin, %ID_ListBox, %LB_SETTOPINDEX, top, 0
   s = "": IF numMarked THEN s = STR$(numMarked) + " marked"
   displayStatus 1, s: updateMenus
   IF numMarked THEN
      MENU SET STATE hEditMenu, 3, %MF_ENABLED
      MENU SET STATE hEditMenu, 4, %MF_ENABLED
   ELSE
      MENU SET STATE hEditMenu, 3, %MF_GRAYED
      MENU SET STATE hEditMenu, 4, %MF_GRAYED
   END IF
END SUB

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'===================================================================================================
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
END FUNCTION

SUB openIniFile()
   LOCAL fileNum AS LONG, i AS LONG
   LOCAL ver, f AS STRING
   f = dataFolder + "winPam.ini"
   IF isfile(f) THEN
      fileNum = FREEFILE
      OPEN f FOR INPUT AS fileNum
      INPUT #fileNum, ver 
      INPUT #fileNum, thisFile
      INPUT #fileNum, myAreaCode
      INPUT #fileNum, myPrefix
      INPUT #fileNum, commPortNo
      INPUT #fileNum, tabLabels
      INPUT #fileNum, myRetAddr
      INPUT #fileNum, leftPrnMargin
      INPUT #fileNum, labelSizePref
      INPUT #fileNum, envSizePref
      INPUT #fileNum, numLabels
      INPUT #fileNum, numEnvelopes
      FOR i = 1 TO numLabels
         INPUT #fileNum, labelName(i)
         INPUT #fileNum, labelWidth(i)
         INPUT #fileNum, labelHeight(i)
         INPUT #fileNum, labelLeft(i)
         INPUT #fileNum, labelTop(i)
         INPUT #fileNum, labelSpacW(i)
         INPUT #fileNum, labelSpacH(i)
      NEXT i
      FOR i = 1 TO numEnvelopes
         INPUT #fileNum, envName(i)
         INPUT #fileNum, envHorz(i)
         INPUT #fileNum, envVert(i)
      NEXT i                                                     
      INPUT #fileNum, morePrefixes1
      INPUT #fileNum, morePrefixes2
      INPUT #fileNum, phoneChrsQZ
      INPUT #fileNum, inclAreaCode
      for i = 1 to 4
         input #fileNum, recent(i)
      next i
      CLOSE #fileNum
      IF LEN(COMMAND$) THEN thisFile = COMMAND$
      'thisFile = REMOVE$(thisFile, ANY """") 'remove quotes from input
   else
      FILECOPY dataFolder + "winPamIni", f
   END IF
   IF LEN(tabLabels) = 0 THEN tabLabels = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
END SUB

SUB saveIniFile()
   LOCAL fileNum AS INTEGER
   LOCAL i AS LONG
   fileNum = FREEFILE
   OPEN dataFolder + "winPam.ini" FOR OUTPUT AS fileNum
   WRITE #fileNum, $version
   WRITE #fileNum, thisFile
   WRITE #fileNum, myAreaCode
   WRITE #fileNum, myPrefix
   WRITE #fileNum, commPortNo
   WRITE #fileNum, tabLabels
   WRITE #fileNum, myRetAddr
   WRITE #fileNum, leftPrnMargin
   WRITE #fileNum, labelSizePref
   WRITE #fileNum, envSizePref
   WRITE #fileNum, numLabels
   WRITE #fileNum, numEnvelopes
   FOR i = 1 TO numLabels
      WRITE #fileNum, labelName(i)
      WRITE #fileNum, labelWidth(i)
      WRITE #fileNum, labelHeight(i)              
      WRITE #fileNum, labelLeft(i)
      WRITE #fileNum, labelTop(i)
      WRITE #fileNum, labelSpacW(i)
      WRITE #fileNum, labelSpacH(i)
   NEXT i
   FOR i = 1 TO numEnvelopes
      WRITE #fileNum, envName(i)
      WRITE #fileNum, envHorz(i)
      WRITE #fileNum, envVert(i)
   NEXT i
   WRITE #fileNum, morePrefixes1
   WRITE #fileNum, morePrefixes2
   WRITE #fileNum, phoneChrsQZ
   WRITE #fileNum, inclAreaCode
   for i = 1 to 4
      WRITE #fileNum, recent(i)
   next i
   CLOSE #fileNum
END SUB
                                                       
sub updateDataFile                                                   
   'update data file to ver 4.00 format - pamRec.dataLength from WORD to DWORD
   local fileNum, i, n as long
   local s, sData as string
   local b as byte
   local xPamRec() as xPamRecord
   
   'read in old data file
   fileNum = FREEFILE
   OPEN thisFile FOR BINARY AS fileNum
   s = pamID: GET fileNum, , s                                         
   GET fileNum, , numRecords
   GET fileNum, , numCatgs
   GET fileNum, , numLists
   redim pamRec(numRecords) 'old 
   REDIM xPamRec(numRecords) 'new
   REDIM pamData(numRecords)
   REDIM viewListStr(numRecords)
   REDIM undel(numRecords)
   FOR i = 1 TO numRecords
      GET fileNum, , xPamRec(i)
      n = xPamRec(i).dataLength
      pamData(i) = SPACE$(n)
      GET fileNum, , pamData(i)
   NEXT i
   FOR i = 1 TO numCatgs
      GET fileNum, , b
      catg(i) = SPACE$(b)
      GET fileNum, , catg(i)
   NEXT i
   FOR i = 1 TO numLists
      GET fileNum, , b
      listNames(i) = SPACE$(b)
      GET fileNum, , listNames(i)
   NEXT i
   pwLen = 0
   GET fileNum, , pwLen
   IF pwLen THEN
      pwFile = SPACE$(pwLen)
      GET fileNum, , pwFile
   END IF                           
   CLOSE fileNum
   
   'write new data file with updated pamRec() format
   pamID = "winPam4.00"
   redim pamRec(numRecords)
   for i = 1 to numRecords
      pamRec(i).Lname = xPamRec(i).Lname
      pamRec(i).Fname = xPamRec(i).Fname
      pamRec(i).homePhone = xPamRec(i).homePhone           
      pamRec(i).busPhone = xPamRec(i).busPhone
      pamRec(i).cellPhone = xPamRec(i).cellPhone
      pamRec(i).faxPhone = xPamRec(i).faxPhone
      pamRec(i).toTitle = xPamRec(i).toTitle
      pamRec(i).toName = xPamRec(i).toName
      pamRec(i).addr1 = xPamRec(i).addr1
      pamRec(i).addr2 = xPamRec(i).addr2
      pamRec(i).city = xPamRec(i).city
      pamRec(i).zip = xPamRec(i).zip
      pamRec(i).email = xPamRec(i).email
      pamRec(i).catg = xPamRec(i).catg
      pamRec(i).dataLength = xPamRec(i).dataLength
      pamRec(i).flag = xPamRec(i).flag                             
   next i
   KILL thisFile
   fileNum = FREEFILE
   OPEN thisFile FOR BINARY AS fileNum
   PUT fileNum, , pamID
   PUT fileNum, , numRecords
   PUT fileNum, , numCatgs
   PUT fileNum, , numLists
   FOR i = 1 TO numRecords
      PUT fileNum, , pamRec(i)
      sData = pamData(i)
      PUT fileNum, , sData
   NEXT i
   FOR i = 1 TO numCatgs
      b = LEN(catg(i))
      PUT fileNum, , b
      PUT fileNum, , catg(i)
   NEXT i
   FOR i = 1 TO numLists
      b = LEN(listNames(i))
      PUT fileNum, , b
      PUT fileNum, , listNames(i)
   NEXT i
   PUT fileNum, , pwLen
   IF pwLen THEN PUT fileNum, , pwFile
   CLOSE fileNum
end sub                                           

SUB openTheFile() 
   local fileNum, i, n as long                            
   local s, pw, folder, prog, ver as string                           
   local b, n1, n2 as byte
   if isfile(thisFile) = 0 then exit sub     
   fileNum = FREEFILE
   OPEN thisFile FOR BINARY AS fileNum
   s = pamID: GET fileNum, , s
   close fileNum
   prog = left$(s, 6): ver = mid$(s, 7)                                         
   if prog = "winPam" and ver < "4.00" then                      
      updateDataFile
   elseif prog <> "winPam" then 
      MSGBOX "Not a winPam file", %MB_OK + %MB_ICONINFORMATION, "Open File"
      thisFile = "": EXIT SUB
   end if
   viewRecord = 0
   fileNum = FREEFILE
   OPEN thisFile FOR BINARY AS fileNum
   s = pamID: GET fileNum, , s                                         
   GET fileNum, , numRecords
   GET fileNum, , numCatgs
   GET fileNum, , numLists
   n = numCatgs: IF n < 0 THEN numCatgs = 0 'to read bad file
   n = numLists: IF n < 0 THEN numLists = 0
   maxRecords = numRecords + 100 
   REDIM pamRec(maxRecords)
   REDIM pamData(maxRecords)
   REDIM viewListStr(maxRecords)
   REDIM undel(maxRecords)
   FOR i = 1 TO numRecords
      GET fileNum, , pamRec(i)
      n = pamRec(i).dataLength
      pamData(i) = SPACE$(n)
      GET fileNum, , pamData(i)
      IF BIT(pamRec(i).flag, 2) THEN
         INCR numMarked
      END IF
   NEXT i
   FOR i = 1 TO numCatgs
      GET fileNum, , b
      catg(i) = SPACE$(b)
      GET fileNum, , catg(i)
   NEXT i
   FOR i = 1 TO numLists
      GET fileNum, , b
      listNames(i) = SPACE$(b)                                               
      GET fileNum, , listNames(i)
   NEXT i                                                                                         
   pwLen = 0
   GET fileNum, , pwLen
   IF pwLen > 15 THEN pwLen = 0
   IF pwLen THEN
      pwFile = SPACE$(pwLen)
      GET fileNum, , pwFile                                        
      if pwVerified = 0 then pwVerified = verifyPassword
      IF pwVerified = 0 THEN CLOSE fileNum: EXIT SUB
      FOR i = 1 TO numRecords
         encrypt pamData(i), pwFile
      NEXT i
   END IF
   CLOSE fileNum
   IF pwLen THEN s = "Clear" ELSE s = "Set"
   MENU SET TEXT hFileMenu, BYCMD %ID_SetPW, s + " password"
   FOR i = 1 TO numRecords 'create global viewListStr() array
      s = pamData(i)
      n1 = pamRec(i).Lname
      n2 = pamRec(i).Fname
      lastName = LEFT$(s, n1)
      firstName = MID$(s, n1 + 1, n2)
      s = $TAB + lastName
      IF LEN(firstName) THEN
         s = s & ", " & firstName
      END IF
      s = truncateStr(hDispDC, s, 200) + $TAB + getPriPhoneNo(pamRec(i), pamData(i))
      viewListStr(i) = s
   NEXT i
   fileChanged = 0: 'recordNo = 1 ''''
'   tabNo = 0: tabRecords 0: menuLists
   displayStatus 1, ""
   
   '-----------------------------------------------------
   'get complete path name of reminders file (ver 3.19)                                           
   '-----------------------------------------------------
   folder = pathname$(path, thisFile)
   remindersFile = folder + $RemindFile
   if isfile(remindersFile) = 0 then
      remindersFile = dataFolder + $RemindFile
   end if
END SUB  

SUB saveTheFile()
   LOCAL fileNum, i AS LONG
   LOCAL savNum AS WORD, b AS BYTE
   LOCAL s, pw, sData AS STRING
   REDIM saveRecords(numRecords) AS INTEGER
   IF fileChanged THEN
      displayStatus 1, "Saving file..."
      KILL thisFile
      fileNum = FREEFILE
      OPEN thisFile FOR BINARY AS fileNum
      PUT fileNum, , pamID
      PUT fileNum, , numRecords
      PUT fileNum, , numCatgs
      PUT fileNum, , numLists
      FOR i = 1 TO numRecords
         'identify which records to dump
         IF undel(i) THEN
            delUnusedCatg i                                             
         ELSE
            BIT SET pamRec(i).flag, 1
            saveRecords(i) = i
         END IF
      NEXT i
      FOR i = 1 TO numRecords
         IF saveRecords(i) THEN
            INCR savNum
            IF listMode THEN                                                               
               BIT CALC pamRec(i).flag, 3 + listNo, BIT(pamRec(i).flag, 2)
            END IF
            'pamRec(i).flag = pamRec(i).flag AND 65531  'clear bits 0 and 2
            'problem - should have used 65530 (better to reset)
            BIT RESET pamRec(i).flag, 0
            BIT RESET pamRec(i).flag, 2
            PUT fileNum, , pamRec(i)
            sData = pamData(i)
            IF pwLen THEN encrypt sData, pwFile
            PUT fileNum, , sData
         END IF
      NEXT i
      FOR i = 1 TO numCatgs                 
         b = LEN(catg(i))
         PUT fileNum, , b
         PUT fileNum, , catg(i)
      NEXT i
      FOR i = 1 TO numLists
         b = LEN(listNames(i))
         PUT fileNum, , b
         PUT fileNum, , listNames(i)
      NEXT i
      PUT fileNum, , pwLen
      IF pwLen THEN PUT fileNum, , pwFile                                   
      SEEK fileNum, 1
      PUT fileNum, , pamID
      PUT fileNum, , savNum
      PUT fileNum, , numCatgs       
      CLOSE fileNum
      fileChanged = 0
      'process last four saved files in recent()
      ARRAY SCAN recent(), COLLATE UCASE, = thisFile, TO i
      if i then array delete recent(i)
      array insert recent(1), thisFile
      saveIniFile(): addMenu()
   END IF
   displayStatus 1, "" 
END SUB 

SUB delUnusedCatg(n AS LONG)
   LOCAL nCatg AS BYTE, i AS LONG
   nCatg = pamRec(n).catg
   IF nCatg = 0 THEN EXIT SUB
   'first, check if catg associated with record n is unused
   FOR i = 1 TO numRecords
     IF BIT(pamRec(i).flag, 1) THEN
       IF pamRec(i).catg = nCatg THEN EXIT SUB
     END IF
   NEXT i
   'the catg is unused, so delete it
   IF numCatgs > 0 THEN
      DECR numCatgs
      ARRAY DELETE catg(nCatg)
      FOR i = 1 TO numRecords
        IF pamRec(i).catg > nCatg THEN
          pamRec(i).catg = pamRec(i).catg - 1
        END IF
      NEXT i
   END IF
END SUB

FUNCTION truncateStr(hdc AS LONG, s AS STRING, allowExt AS LONG) AS STRING
   LOCAL sTxt AS ASCIIZ*256, nLen AS LONG, nFit AS LONG, cSize AS SIZEL
   sTxt = s: nLen = LEN(sTxt)
   GetTextExtentExPoint hdc, BYVAL VARPTR(sTxt), nLen, allowExt, nFit, BYVAL %NULL, cSize
   FUNCTION = LEFT$(s, nFit)
END FUNCTION

FUNCTION stringSize(hdc AS LONG, s AS STRING) AS LONG
   LOCAL TXT AS ASCIIZ*256, cSize AS SIZEL
   TXT = s: GetTextExtentPoint32 hdc, txt, len(txt), cSize
   FUNCTION = cSize.cx
END FUNCTION

FUNCTION getPriPhoneNo(rec AS pamRecord, strData AS STRING) AS STRING
   LOCAL i AS INTEGER, n AS INTEGER, s AS STRING, phnID AS STRING
   DIM lenPh(3) AS INTEGER
   n = rec.Lname + rec.Fname + 1
   lenPh(0) = rec.homePhone
   lenPh(1) = rec.busPhone
   lenPh(2) = rec.cellPhone
   lenPh(3) = rec.faxPhone
   FOR i = 0 TO 3
      IF lenPh(i) THEN
         s = MID$(strData, n, lenPh(i))
         phnID = PARSE$(s, $NUL, 2)
         IF LEN(phnID) = 0 AND i = 3 THEN phnID = "Fax phone"
         IF INSTR(LCASE$(phnID), "fax") THEN n = n + lenPh(i): ITERATE
         FUNCTION = PARSE$(s, " ", 1): EXIT FUNCTION
      END IF
   NEXT i
END FUNCTION

SUB quitProgram()
   LOCAL n AS INTEGER
   doNotQuit = 0
   IF fileChanged THEN
      n = MSGBOX("File records have changed..." & $CRLF _
      & "do you want to save them?", %MB_YESNOCANCEL + %MB_ICONQUESTION, "Save File")
      IF n = %IDCANCEL THEN
         doNotQuit = 1: EXIT SUB
      ELSEIF n = %IDYES THEN
         IF ISFILE(thisFile) THEN
            saveTheFile
         ELSE
            DIALOG SEND hWin, %WM_COMMAND, %ID_SaveAs, 0
         END IF
      END IF
   END IF
END SUB
                                                     
'-----------------------------------------------------------------------
'WinPam - Data form routines                  
'-----------------------------------------------------------------------
SUB dataForm(OPTIONAL BYVAL nOpt AS LONG)                 
   LOCAL ts, cs AS LONG
   LOCAL title, title1, title2 AS STRING
   IF getWindow(hForm, %GW_OWNER) THEN EXIT SUB
   viewOpt = nOpt
   ts = %WS_TABSTOP
   cs = %WS_TABSTOP OR %WS_VSCROLL OR %CBS_DISABLENOSCROLL OR %CBS_DROPDOWNLIST
   SELECT CASE viewOpt              
      CASE 0 'new record
         title = "Add Record Data"
         title1 = "&Add": title2 = "C&lear"
      CASE 1 'view record data
         title = "View Record Data"
         title1 = "&Prev": title2 = "&Next"
         ts = ts + %ES_READONLY
         cs = cs + %WS_DISABLED
      CASE 2 'edit record data
         title = "Edit Record DATA"
         title1 = "&Replace": title2 = "&Original"
   END SELECT
   formWidth = 330: formHeight = 295
   DIALOG NEW hWin, title, 20, -35, formWidth, formHeight, %WS_SYSMENU TO hForm
   CONTROL ADD LABEL, hForm, -1, "Last Name", 5, 6, 38, 10, %SS_RIGHT
   CONTROL ADD LABEL, hForm, -1, "First Names", 140, 6, 43, 10, %SS_RIGHT
   CONTROL ADD TEXTBOX, hForm, %ID_Lname, "", 45, 5, 80, 12, ts, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hForm, %ID_Fname, "", 185, 5, 130, 12, ts, %WS_EX_CLIENTEDGE
   'phone data ------------------------------------------------------------------------
   CONTROL ADD FRAME, hForm, %ID_PhoneGrp, "Phone Numbers", 5, 20, 310, 82
   CONTROL ADD LABEL, hForm, %ID_Phone1, "Home phone", 10, 34, 70, 10, %SS_RIGHT
   CONTROL ADD LABEL, hForm, %ID_Phone2, "Bus phone", 10, 51, 70, 10, %SS_RIGHT
   CONTROL ADD LABEL, hForm, %ID_Phone3, "Cell phone", 10, 68, 70, 10, %SS_RIGHT
   CONTROL ADD LABEL, hForm, %ID_Phone4, "Fax phone", 10, 85, 70, 10, %SS_RIGHT
   CONTROL ADD TEXTBOX, hForm, %ID_HomePh, "", 87, 33, 120, 12, ts, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hForm, %ID_BusPh, "", 87, 50, 120, 12, ts, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hForm, %ID_SelfPh, "", 87, 67, 120, 12, ts, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hForm, %ID_FaxPh, "", 87, 84, 120, 12, ts, %WS_EX_CLIENTEDGE
   IF viewOpt <> 1 THEN
      CONTROL ADD BUTTON, hForm, %ID_PhoneID, "&Phone IDs", 220, 50, 50, 30, %BS_CENTER
   END IF
   CONTROL ADD LABEL, hForm, -1, "E-mail", 7, 109, 25, 12, %SS_RIGHT
   CONTROL ADD TEXTBOX, hForm, %ID_Email, "", 35, 108, 190, 12, ts, %WS_EX_CLIENTEDGE
   'address data ----------------------------------------------------------------------
   CONTROL ADD FRAME, hForm, %ID_AddrGrp, "Mailing Address", 5, 124, 315, 83
   CONTROL ADD LABEL, hForm, -1, "Mail To", 7, 138, 25, 10, %SS_RIGHT
   CONTROL ADD COMBOBOX, hForm, %ID_ToTitle, toTitle(), 35, 137, 55, 80, cs, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hForm, %ID_ToName, "", 95, 137, 130, 12, ts, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hForm, %ID_Addr1, "", 35, 154, 190, 12, ts, %WS_EX_CLIENTEDGE
   IF viewOpt <> 1 THEN
      CONTROL ADD CHECKBOX, hForm, %ID_USA, "&Outside USA", 250, 150, 55, 20,%BS_LEFT CALL USAProc
   END IF
   CONTROL ADD LABEL, hForm, %ID_Addr1Label, "Addr 1", 7, 155, 25, 10, %SS_RIGHT
   CONTROL ADD LABEL, hForm, %ID_Addr2Label, "Addr 2", 7, 172, 25, 10, %SS_RIGHT
   CONTROL ADD TEXTBOX, hForm, %ID_Addr2, "", 35, 171, 190, 12, ts, %WS_EX_CLIENTEDGE
   CONTROL ADD LABEL, hForm, %ID_CityLabel, "City", 7, 189, 25, 10, %SS_RIGHT
   CONTROL ADD TEXTBOX, hForm, %ID_City, "", 35, 188, 130, 12, ts, %WS_EX_CLIENTEDGE
   CONTROL ADD LABEL, hForm, %ID_StateLabel, "State", 175, 189, 20, 10
   CONTROL ADD TEXTBOX, hForm, %ID_State, "", 195, 188, 16, 12, ts, %WS_EX_CLIENTEDGE
   CONTROL ADD LABEL, hForm, %ID_ZipLabel, "Zip", 225, 189, 10, 10  ', %SS_RIGHT
   CONTROL ADD TEXTBOX, hForm, %ID_Zip, "", 240, 188, 70, 12, ts, %WS_EX_CLIENTEDGE
   'remaining data + buttons -----------------------------------------------------------------------------
   ts = %WS_TABSTOP
   cs = %WS_TABSTOP OR %WS_VSCROLL OR %CBS_DISABLENOSCROLL OR %CBS_DROPDOWN
   SELECT CASE viewOpt
      CASE 0 'new record
         title1 = "&Add": title2 = "A&dd + Close"                                     
      CASE 1 'view record data
         title1 = "&Prev": title2 = "&Next"
         ts = ts + %ES_READONLY
         cs = cs + %WS_DISABLED
      CASE 2 'edit record data                          
         title1 = "&Replace": title2 = "&Original"
   END SELECT
   CONTROL ADD LABEL, hForm, -1, "Catg", 7, 217, 25, 10, %SS_RIGHT
   CONTROL ADD COMBOBOX, hForm, %ID_Catg, catg(), 35, 216, 80, 62, cs+%CBS_SORT, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hForm, %ID_ExpandNote, "&Expand note", 135, 215, 70, 16
   CONTROL ADD LABEL, hForm, -1, "Note", 7, 234, 25, 10, %SS_RIGHT
   ts = ts + %ES_MULTILINE + %ES_WANTRETURN + %WS_VSCROLL or %ES_AUTOVSCROLL                             
   CONTROL ADD TEXTBOX, hForm, %ID_Note, "", 35, 233, 180, 30, ts, %WS_EX_CLIENTEDGE
   CONTROL SEND hForm, %ID_Note, %EM_LIMITTEXT, 240, 0
   control add label, hForm, %ID_NoteLimit, "Note limit reached", 35, 264, 180, 10
   control set color hForm, %ID_NoteLimit, %RGB_RED, -1
   control hide hForm, %ID_NoteLimit
   CONTROL ADD FRAME, hForm, -1, "", 224, 205, 96, 60                             
   CONTROL ADD BUTTON, hForm, %ID_Add, title1, 230, 212, 50, 25
   CONTROL ADD BUTTON, hForm, %ID_Close, title2, 230, 237, 50, 25
   CONTROL ADD BUTTON, hForm, %IDCANCEL, "&Cancel", 280, 212, 35, 50
   IF viewOpt = 1 THEN 'viewed record                                               
      CONTROL ADD TEXTBOX, hForm, %ID_ToTitleTxt, "", 37, 139, 34, 9, ts
      CONTROL ADD TEXTBOX, hForm, %ID_CatgText, "", 37, 218, 66, 9, ts
   END IF
   CONTROL SET FOCUS hForm, %ID_Lname
   DIALOG SHOW MODAL hForm CALL dataFormProc
END SUB

CALLBACK FUNCTION dataFormProc() AS LONG
   LOCAL i, n, textLength, hMem AS LONG
   LOCAL s, toName, recordStr AS STRING
   LOCAL TXT AS ASCIIZ * 21
   LOCAL lpMem AS ASCIIZ PTR
   STATIC lastFormCtrl, hNoteCtrl AS LONG
   STATIC recStr, sNote AS STRING
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      recordNo = viewList(hiLite)
      IF viewOpt = 0 THEN recordNo = 0
      savedRecordNo = recordNo                          
      control handle cb.hndl, %ID_Catg to hCatg
      control handle cb.hndl, %ID_Note to hNote
      IF viewOpt = 1 THEN 'viewed record
         IF hiLite = 1 THEN CONTROL DISABLE hForm, %ID_Add
         IF hiLite = numView THEN CONTROL DISABLE hForm, %ID_Close
      ELSE
         COMBOBOX RESET hForm, %ID_Catg
         FOR i = 1 TO numCatgs                                                      
            TXT = catg(i)
            CONTROL SEND hForm, %ID_Catg, %CB_ADDSTRING, 0, VARPTR(TXT) TO n
            CONTROL SEND hForm, %ID_Catg, %CB_SETITEMDATA, n, i
         NEXT i                                                          
      END IF
      fillForm
      nPhone = 0: recStr = ""                     
      FOR i = 0 TO 14
         CONTROL GET TEXT CBHNDL, %ID_Lname + i TO s                                              
         recStr = recStr + TRIM$(s)
      NEXT i                                                            
      sExpNote = recData(15)
      recStr = recStr + trim$(recData(15))
      'define accelerator keys -------------------------------------------------------------------------
      REDIM ac(1 TO 1) AS ACCELAPI
      ac(1).fvirt = %FVIRTKEY OR %FCONTROL
      ac(1).key   = %VK_V
      ac(1).cmd   =  %ID_Paste                         
      ACCEL ATTACH cb.hndl, ac() TO hAccel
      control handle cb.hndl, %ID_Note to hNoteCtrl
      gNoteProc = SetWindowLong(hNoteCtrl, %GWL_WNDPROC, CODEPTR(subClassNote))                                                                                                
   CASE %WM_COMMAND
      IF CBCTL >= %ID_Lname AND CBCTL < %ID_PhoneID AND editPhoneID THEN
         IF editPhoneID THEN
            CONTROL KILL hForm, %ID_PhoneLabel
            CONTROL SET TEXT hForm, %ID_PhoneID, "&Phone IDs"
            editPhoneID = 0: nPhone = 0
         END IF
      END IF
      SELECT CASE CBCTL
      CASE %IDCANCEL
         recordNo = savedRecordNo: viewOpt = 0
         DIALOG END hForm
      CASE %ID_Add
         IF viewOpt = 1 THEN 'view record
            IF hiLite > 1 THEN DECR hiLite
            recordNo = viewList(hiLite): fillForm
            displayStatus 4, "": scrollRecords -1                 
            IF hiLite = 1 THEN
               CONTROL DISABLE hForm, CBCTL
            ELSE
               CONTROL ENABLE CBHNDL, %ID_Close
            END IF
         ELSE 'add or replace record
            addRecord
            IF recError THEN
               IF recError = %ID_Lname THEN
                  MSGBOX "Must specify last name", %MB_OK + %MB_ICONERROR, "Error"             
               ELSEIF recError = %ID_Catg THEN
                  s = "Maximum number of categories already defined"
                  MSGBOX s, %MB_OK + %MB_ICONINFORMATION, "Error"
               ELSE
                  MSGBOX "Invalid Phone Number", %MB_ICONERROR, "Error"
               END IF
               CONTROL SET FOCUS hForm, recError
            ELSEIF closeDlg THEN
               recordNo = savedRecordNo
               DIALOG END hForm                                                         
            ELSE                                                                                     
               CONTROL SET FOCUS hForm, %ID_Lname                                                   
            END IF
            closeDlg = 0: recError = 0
         END IF
         CONTROL SEND hForm, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
      '-------- edit menu for textbox                  
      CASE %ID_Undo   : SendMessage hNoteCtrl, %WM_UNDO, 0, 0
      CASE %ID_Cut    : SendMessage hNoteCtrl, %WM_CUT, 0, 0
      CASE %ID_Copy   : SendMessage hNoteCtrl, %WM_COPY, 0, 0                       
      CASE %ID_Paste  : stripClipBd(): dataPasted = 1: SendMessage hNoteCtrl, %WM_PASTE, 0, 0
      CASE %ID_Clear  : SendMessage hNoteCtrl, %WM_CLEAR, 0, 0
      CASE %ID_SelAll : SendMessage hNoteCtrl, %EM_SETSEL, 0, -1
      CASE %ID_Close
         IF viewOpt = 1 THEN                               
            IF hiLite < numView THEN INCR hiLite
            recordNo = viewList(hiLite): fillForm                                  
            displayStatus 4, "": scrollRecords 1
            IF hiLite = numView THEN
               CONTROL DISABLE CBHNDL, CBCTL
            ELSE
               CONTROL ENABLE CBHNDL, %ID_Add
            END IF
         ELSEIF viewOpt = 2 THEN
            fillForm: CONTROL SET FOCUS hForm, %ID_Lname
         ELSE                           
            closeDlg = 1
            DIALOG SEND hForm, %WM_COMMAND, %ID_Add, 0
         END IF
         CONTROL SEND hForm, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
      CASE %ID_HomePh TO %ID_FaxPh
         IF CBCTLMSG <> %EN_KILLFOCUS THEN nPhone = CBCTL - %ID_homePh + 1
      CASE %ID_PhoneID
         IF lastFormCtrl < %ID_Phone1 OR lastFormCtrl > %ID_Phone4 THEN
            CONTROL SET FOCUS hForm, lastFormCtrl
         END IF
         CONTROL GET TEXT hForm, %ID_PhoneID TO s
         IF returnKey or s = "&Ok" THEN
            editPhoneID = 0: returnKey = 0
            CONTROL GET TEXT hForm, %ID_PhoneLabel TO s
            CONTROL KILL hForm, %ID_PhoneLabel
            IF RIGHT$(s, 1) = ":" THEN s = LEFT$(s, LEN(s) - 1)
            n = %ID_Phone1 + nPhone - 1
            CONTROL SET TEXT hForm, n, s
            CONTROL SET TEXT hForm, %ID_PhoneID, "&Phone IDs"
            CONTROL SET FOCUS hForm, %ID_HomePh + nPhone - 1
            nPhone = 0
         ELSEIF nPhone >= 1 AND nPhone <= 4 THEN
            CONTROL SET TEXT hForm, %ID_PhoneID, "&Ok"
            n = 33 + 17 * (nPhone - 1)
            CONTROL GET TEXT hForm, %ID_Phone1 + nPhone - 1 TO s
            CONTROL ADD TEXTBOX, hForm, %ID_PhoneLabel, s, 10, n, 70, 12
            CONTROL SEND hForm, %ID_PhoneLabel, %EM_SETSEL, 0, -1
            CONTROL SET FOCUS hForm, %ID_PhoneLabel
            editPhoneID = 1
         END IF
      CASE %ID_ToTitle
         IF CBCTLMSG = %LBN_SELCHANGE THEN
            CONTROL SEND hForm, %ID_ToTitle, %CB_GETCURSEL, 0, 0 TO n
            IF n THEN
               CONTROL GET TEXT hForm, %ID_LName TO toName
               CONTROL GET TEXT hForm, %ID_FName TO s
               IF n = 1 THEN
                  i = INSTR(s, "&"): IF i THEN s = LEFT$(s, i - 1)
               END IF
               IF LEN(s) THEN toName = TRIM$(s) + " " + toName
               CONTROL SET TEXT hForm, %ID_ToName, toName
            END IF
         END IF
      CASE %ID_State
         IF CBCTLMSG = %EN_KILLFOCUS THEN
            CONTROL GET TEXT hForm, %ID_State TO s
            CONTROL SET TEXT hForm, %ID_State, UCASE$(s)
         END IF
      case %ID_Note
         if cb.ctlmsg = %en_setfocus then
            control get text hForm, %ID_Note to sNote
            if expand < 0 then expand = 0: exit function
            incr expand
            control hide cb.hndl, %ID_NoteLimit
            if len(recData(15)) > 240 then
               expandNote()
            end if
            if Len(sExpNote) > 240 then SetFocus hCatg else SetFocus hNote
            if len(recData(15)) = 240 or len(sExpNote) = 240 then
               control normalize cb.hndl, %ID_NoteLimit
            end if
         elseif cb.ctlmsg = %en_killfocus then
            control hide cb.hndl, %ID_NoteLimit                      
         elseif cb.ctlmsg = %EN_CHANGE then                                
            if dataPasted then  'ver 4.11       
               dataPasted = 0
               hMem = GetClipboardData(%CF_TEXT) 'memory object
               lpMem = GlobalLock(hMem) 'lock it and get a pointer to the data
               recData(15) = sNote + @lpMem                                               
            end if         
            textLength = SendMessage(hNoteCtrl, %WM_GetTextLength, 0, 0)
            if textLength = 240 then control normalize cb.hndl, %ID_NoteLimit             
         end if                                   
      CASE %ID_ExpandNote  'button to expand the note
         expand = 0: control hide cb.hndl, %ID_NoteLimit                                          
         expandNote()
         if Len(sExpNote) > 240 then SetFocus hCatg else SetFocus hNote
         if len(sExpNote) = 240 then control normalize cb.hndl, %ID_NoteLimit
      END SELECT 
      lastFormCtrl = CBCTL
   CASE %WM_SYSCOMMAND                                                  
      IF CBCTL=%SC_CLOSE THEN
         viewOpt = 0
         FOR i = 0 TO 14
            CONTROL GET TEXT CBHNDL, %ID_Lname + i TO s
            recordStr = recordStr + TRIM$(s)
         NEXT i
         s = sExpNote                                                             
         's = getRicheditText(hExpNoteCtrl)
         if len(s) = 0 then CONTROL GET TEXT hForm, %ID_Note TO s         
         recordStr = recordStr + trim$(s)
         IF viewOpt <> 1 AND recordStr <> recStr THEN 
            s = "Data has been added or changed" + $CRLF
            s = s + "... save the data on closing the form?"                                  
            n = MSGBOX(s, %MB_YESNO, "Record data")
            IF n = %IDYES THEN
               closeDlg = 1: DIALOG SEND CBHNDL, %WM_COMMAND, %ID_Add, 0
            END IF                                                                 
         END IF
         dialog end hExpNote                                    
         dialog end cb.hndl                           
      END IF
      expand = 0
   END SELECT
END FUNCTION

SUB expandNote()
   local nStyle as long
   if expand > 1 then expand = 0: exit sub
   DIALOG NEW hForm, "Expanded Note", 40, 20, 250, 270, %WS_SYSMENU TO hExpNote
   'create richedit control  
   nStyle = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll or _
            %ES_AutoVScroll Or %ES_WantReturn Or %ES_NoHideSel Or %WS_TabStop
   LoadLibrary("riched32.dll") : InitCommonControls    
   Control Add "RichEdit", hExpNote, %ID_NoteExp, "", 5, 5, 235, 220, nStyle, %WS_EX_ClientEdge
   Control Handle hExpNote, %ID_NoteExp To hExpNoteCtrl
   SendMessage hExpNoteCtrl, %EM_SETEVENTMASK, 0, %ENM_SELCHANGE Or %ENM_CHANGE Or %ENM_LINK
   SendMessage hExpNoteCtrl, %EM_SETLIMITTEXT, 1000000, 0
   IF viewOpt = 1 then
      SendMessage hExpNoteCtrl, %EM_SETREADONLY, 1, 0
      'control disable hExpNote, %ID_NoteExp
   end if
   CONTROL ADD BUTTON, hExpNote, %ID_Find, "&Find", 20, 230, 40, 18
   CONTROL ADD BUTTON, hExpNote, %ID_Next, "&Next", 60, 230, 40, 18, %WS_DISABLED
   CONTROL ADD BUTTON, hExpNote, %ID_Prev, "&Prev", 100, 230, 40, 18, %WS_DISABLED
   IF viewOpt <> 1 THEN                                                  
      CONTROL ADD BUTTON, hExpNote, %ID_SaveBtn, "&Save", 170, 230, 50, 18
      control disable hExpNote, %ID_SaveBtn
   END IF                      
   DIALOG SHOW MODAL hExpNote CALL expandNoteProc
END SUB

CALLBACK FUNCTION expandNoteProc()
   LOCAL i, nChg, nStyle, hAccel AS LONG
   local pd as CHARRANGE
   STATIC k, m, n, nLast, noteExpChanged, saveBtn AS LONG
   STATIC f, s, sNote AS STRING
   SELECT CASE CBMSG                                                                       
   CASE %WM_INITDIALOG                                                         
      CONTROL GET TEXT hForm, %ID_Note TO sNote                                   
      sExpNote = recData(15)
      if sNote > sExpNote then 
         sExpNote = sNote                                         
      else
         mid$(sExpNote, 1, len(sNote)) = sNote
      end if
      control send cb.hndl, %ID_NoteExp, %WM_SetText, 0, strptr(sExpNote)
      noteExpChanged = 0 
      REDIM ac(1 TO 1) AS ACCELAPI
      ac(1).fvirt = %FVIRTKEY OR %FCONTROL
      ac(1).key   = %VK_V
      ac(1).cmd   =  %ID_Paste
      ACCEL ATTACH CBHNDL, ac() TO hAccel
      IF findMode THEN
         f = LCASE$(findStr): k = LEN(f)                                
         IF k = 0 THEN EXIT FUNCTION                      
         s = LCASE$(sNote)
         n = INSTR(1, s, f)                                                      
         IF n THEN
            CONTROL POST CB.HNDL, %ID_NoteExp, %EM_SETSEL, n - 1, n + k - 1
            CONTROL POST CB.HNDL, %ID_NoteExp, %EM_SCROLLCARET, 0, 0
            m = INSTR(n + k + 1, sNote, f)
            IF m THEN 'more than one found                                                             
               CONTROL SHOW STATE CB.HNDL, %ID_Find, %SW_HIDE
               CONTROL ADD BUTTON, CB.HNDL, %ID_Next, "&Next", 30, 230, 32, 18
               CONTROL ADD BUTTON, CB.HNDL, %ID_Prev, "&Prev", 65, 230, 32, 18
            END IF
         END IF                                         
      END IF 
      'subclass hTextbox to process right mouse click
      gExpNoteProc = SetWindowLong(hExpNoteCtrl, %GWL_WNDPROC, CODEPTR(subClassExpNote))
   CASE %WM_COMMAND
      SELECT CASE CB.CTL                                 
      CASE %ID_SaveBtn
         saveBtn = 1
         dialog send cb.hndl, %WM_SYSCOMMAND, %SC_CLOSE, 0
      CASE %IDCANCEL
         findModeExp = 0: DIALOG END CB.HNDL
      case %ID_NoteExp
         if cb.ctlmsg = %EN_CHANGE then                 
            noteExpChanged = 1
            control enable cb.hndl, %ID_SaveBtn
            n = 0: CONTROL POST CB.HNDL, %ID_NoteExp, %EM_SETSEL, -1, 0  'deselect text
         elseif cb.ctlmsg = %en_killfocus then
            CONTROL GET TEXT CB.HNDL, %ID_NoteExp TO sNote
         end if                                                      
      '-------- edit menu for textbox                                   
      CASE %ID_Undo   : SendMessage hExpNoteCtrl, %WM_UNDO, 0, 0
      CASE %ID_Cut    : SendMessage hExpNoteCtrl, %WM_CUT, 0, 0
      CASE %ID_Copy   : SendMessage hExpNoteCtrl, %WM_COPY, 0, 0                       
      CASE %ID_Paste  : stripClipBd(): SendMessage hExpNoteCtrl, %WM_PASTE, 0, 0
      CASE %ID_Clear  : SendMessage hExpNoteCtrl, %WM_CLEAR, 0, 0
      CASE %ID_SelAll : SendMessage hExpNoteCtrl, %EM_SETSEL, 0, -1
      CASE %ID_Find
         IF LEN(sNote) THEN
            findModeExp = 1
            nChg = noteExpChanged
            findStr = myInput(CB.HNDL, "Find what:  ", "", findStr)                  
            noteExpChanged = nChg
            if len(findStr) then 
               f = LCASE$(findStr): k = LEN(f)
            else
               CONTROL POST CB.HNDL, %ID_NoteExp, %EM_SETSEL, -1, -1 
               findMode = 0: k = 0: function = 1: EXIT FUNCTION
            end if
            CONTROL SET FOCUS CB.HNDL, %ID_NoteExp
            pd.cpMin = 0: pd.cpMax = 0
            SendMessage(hExpNoteCtrl, %EM_EXSETSEL, 0, varptr(pd))
            s = lcase$(getRicheditText(hExpNoteCtrl))
            n = INSTR(1, s, f)
            IF n THEN 
               CONTROL POST CB.HNDL, %ID_NoteExp, %EM_SETSEL, n - 1, n + k - 1
               m = INSTR(n + k + 1, s, f)
               IF m THEN 'more than one found
                  CONTROL enable CB.HNDL, %ID_Next
                  CONTROL enable CB.HNDL, %ID_Prev
               END IF
            ELSE
               findModeExp = 0
               MSGBOX "None found", , f                      
            END IF
         END IF                                                                        
         EXIT FUNCTION
      CASE %ID_Next, %ID_Prev                                         
         s = getRicheditText(hExpNoteCtrl)
         s = LCASE$(s)
         CONTROL SET FOCUS CB.HNDL, %ID_NoteExp: nLast = n
         local w1, w2 as dword 
         CONTROL send CB.HNDL, %ID_NoteExp, %EM_GETSEL, varptr(w1), varptr(w2)
         if w1 = w2 then n = w1
         IF CB.CTL = %ID_Next THEN
            i = n + k
         elseif CB.CTL = %ID_Prev THEN                                      
            i = -(LEN(s) - n + 2)
         end if
         n = INSTR(i, s, f)
         IF n THEN 
            CONTROL POST CB.HNDL, %ID_NoteExp, %EM_SETSEL, -1, -1
            CONTROL POST CB.HNDL, %ID_NoteExp, %EM_SETSEL, n - 1, n + k - 1            
            'CONTROL POST CB.HNDL, %ID_NoteExp, %EM_SCROLLCARET, 0, 0
            IF i > 0 THEN
               CONTROL ENABLE CB.HNDL, %ID_Prev
            ELSE
               CONTROL ENABLE CB.HNDL, %ID_Next
            END IF                                                            
         ELSE
            findModeExp = 0                                       
            MSGBOX "No more found", , f: n = 0 
            findModeExp = 1
            n = nLast                                                      
            IF i > 0 THEN                                       
               CONTROL DISABLE CB.HNDL, %ID_Next
            ELSE                                                                    
               CONTROL DISABLE CB.HNDL, %ID_Prev
            END IF
         END IF                                                                    
         CONTROL SEND hWin, CB.CTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %false
      END SELECT                      
   CASE %WM_SYSCOMMAND
      IF (CB.WPARAM AND &HFFF0) = %SC_CLOSE THEN                         
         if noteExpChanged then
            if saveBtn = 0 then               
               n = MSGBOX("Keep the changes?", %MB_YESNO, "Expanded note data")
            end if   
            IF n = %IDyes or saveBtn then                          
               saveBtn = 0                                                                             
               sExpNote = GetRichEditText(hExpNoteCtrl)                   
               sExpNote = rtrim$(remove$(sExpNote, chr$(0)))                  
               recData(15) = sExpNote: sNote = left$(sExpNote, 240)
               CONTROL SET TEXT hForm, %ID_Note, sNote                              
            end if
         end if                                    
         DIALOG END CB.HNDL                                   
      END IF                                                                            
   CASE %WM_DESTROY                          
      findModeExp = 0
   END SELECT              
END FUNCTION

FUNCTION subClassNote(BYVAL hWnd&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&) AS LONG
   LOCAL lRet, textLength AS LONG
   local pt AS POINTAPI 
   SELECT CASE wMsg&                                                                                        
      CASE %WM_command
         SendMessage GetParent(hWnd&), %wm_command, wParm&, 0                             
      Case %WM_CONTEXTMENU
         if moreThan240 then 'right click from expanded note only 
            expand = 0: control hide hForm, %ID_NoteLimit                                          
            expandNote()
            if Len(sExpNote) > 240 then SetFocus hCatg else SetFocus hNote          
            if len(sExpNote) = 240 then control normalize hForm, %ID_NoteLimit
            function = 0: exit function 
         end if
         setFocus hWnd& 
         pt.x = LOWRD(lParm&): pt.y = HIWRD(lParm&)
         TrackPopupMenuEx hTextboxMenu, 0, pt.x, pt.y, hForm, BYVAL %NULL   'hform 
         function = 0: exit function
   END SELECT
   ' Pass the message on to the original window procedure                            
   FUNCTION = CallWindowProc(gNoteProc, hWnd&, wMsg&, wParm&, lParm&)
END FUNCTION                                                                                  
                      
FUNCTION subClassExpNote(BYVAL hWnd&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&) AS LONG
   LOCAL lRet AS LONG
   local pt AS POINTAPI
   if wParm& = &H16 then
      exit function
      SendMessage GetParent(hWnd&), %wm_command, %ID_Paste, 0                 
   end if
   SELECT CASE wMsg&
      CASE %WM_RBUTTONDOWN
         pt.x = LOWRD(lParm&): pt.y = HIWRD(lParm&)
         ClientToScreen hWnd&, pt
         TrackPopupMenuEx hTextboxMenu, 0, pt.x, pt.y, hExpNote, BYVAL %NULL           
   END SELECT
   ' Pass the message on to the original window procedure                            
   FUNCTION = CallWindowProc(gExpNoteProc, hWnd&, wMsg&, wParm&, lParm&)
END FUNCTION
             
'
' Get all RichEdit contents as plain text in a string
' by Borje Hagsten
'--------------------------------------------------------------------
FUNCTION GetRichEditText (BYVAL hEdit AS DWORD) AS STRING
  LOCAL ln AS LONG, sTxt AS STRING, cr AS CHARRANGE, crOld AS CHARRANGE                     
  SendMessage hEdit, %WM_SETREDRAW, 0, 0                 'turn off redraw
  SendMessage hEdit, %EM_EXGETSEL, 0, VARPTR(crOld)      'get current selection
  cr.cpMin = 0 : cr.cpMax = -1
  SendMessage hEdit, %EM_EXSETSEL, 0, VARPTR(cr)         'select all
  SendMessage hEdit, %EM_EXGETSEL, 0, VARPTR(cr)         'get selection = length
  ln = ABS(cr.cpMax - cr.cpMin)
  IF ln THEN
     sTxt = SPACE$(ln + 1)
     SendMessage hEdit, %EM_GETSELTEXT, 0, STRPTR(sTxt)
     FUNCTION = RTRIM$(Remove$(sTxt, CHR$(0)))
  END IF
  SendMessage hEdit, %EM_EXSETSEL, 0, VARPTR(crOld)         'reset selection                                 
  SendMessage hEdit, %WM_SETREDRAW, 1, 0                    'and turn on redraw
END FUNCTION

SUB scrollRecords(i AS LONG)
   LOCAL n AS LONG
   CONTROL SEND hWin, %ID_LISTBOX, %LB_GETTOPINDEX, 0, 0 TO n
   IF hiLite > n + 23 THEN
      CONTROL SEND hWin, %ID_LISTBOX, %LB_SETTOPINDEX, n + i, 0
   END IF
   CONTROL SEND hWin, %ID_ListBox, %LB_SETSEL, 0, -1
   CONTROL SEND hWin, %ID_ListBox, %LB_SETSEL, 1, hiLite - 1
END SUB

CALLBACK FUNCTION USAProc() AS LONG
   LOCAL n AS LONG
   CONTROL GET CHECK hForm, %ID_USA TO n
   notUSA = CBYT(n): outsideUSA
   CONTROL SET FOCUS hForm, %ID_Lname
END FUNCTION

SUB outsideUSA
    IF notUSA THEN
       CONTROL SET TEXT hForm, %ID_Addr1Label, "Addr"
       CONTROL SET TEXT hForm, %ID_Addr2Label, "City"
       CONTROL SET SIZE hForm, %ID_Addr2, 130, 12
       CONTROL SET LOC hForm, %ID_CityLabel, 170, 172
       CONTROL SET TEXT hForm, %ID_CityLabel, "Prov"
       CONTROL SET LOC hForm, %ID_City, 200, 171
       CONTROL SET SIZE hForm, %ID_City, 110, 12
       CONTROL SET LOC hForm, %ID_StateLabel, 7, 189
       CONTROL SET SIZE hForm, %ID_StateLabel, 25, 10
       CONTROL SET TEXT hForm, %ID_StateLabel, "Country"
       CONTROL SET LOC hForm, %ID_State, 35, 188
       CONTROL SET SIZE hForm, %ID_State, 130, 12
       CONTROL SET LOC hForm, %ID_ZipLabel, 175, 189
       CONTROL SET SIZE hForm, %ID_ZipLabel, 20, 10
       CONTROL SET TEXT hForm, %ID_ZipLabel, "Postal"
       CONTROL SET LOC hForm, %ID_Zip, 200, 188
       CONTROL SET SIZE hForm, %ID_Zip, 110, 12
    ELSE
       CONTROL SET TEXT hForm, %ID_Addr1Label, "Addr 1"
       CONTROL SET TEXT hForm, %ID_Addr2Label, "Addr 2"
       CONTROL SET SIZE hForm, %ID_Addr2, 190, 12
       CONTROL SET LOC hForm, %ID_CityLabel, 7, 189
       CONTROL SET TEXT hForm, %ID_CityLabel, "City"
       CONTROL SET LOC hForm, %ID_City, 35, 188
       CONTROL SET SIZE hForm, %ID_City, 130, 12
       CONTROL SET LOC hForm, %ID_StateLabel, 175, 189
       CONTROL SET SIZE hForm, %ID_StateLabel, 20, 10
       CONTROL SET TEXT hForm, %ID_StateLabel, "State"
       CONTROL SET LOC hForm, %ID_State, 195, 188
       CONTROL SET SIZE hForm, %ID_State, 16, 12
       CONTROL SET LOC hForm, %ID_ZipLabel, 225, 189
       CONTROL SET SIZE hForm, %ID_ZipLabel, 10, 10
       CONTROL SET TEXT hForm, %ID_ZipLabel, "Zip"
       CONTROL SET LOC hForm, %ID_Zip, 240, 188
       CONTROL SET SIZE hForm, %ID_Zip, 70, 12
    END IF
END SUB

SUB fillForm()
   'fill form with text from recordNo
   LOCAL i AS INTEGER, n AS LONG
   LOCAL TXT AS ASCIIZ * 32
   local s as string
   REDIM recData(15)
   IF viewOpt THEN 'view data or edit data
      notUSA = BIT(pamRec(recordNo).flag, 3)
      CONTROL SET CHECK hForm, %ID_USA, CINT(notUSA)
      getRecordData(0)
   ELSE 'new record
      CONTROL SET CHECK hForm, %ID_USA, 0
      notUSA = 0
      phoneID(0) = "Home phone"
      phoneID(1) = "Bus phone"
      phoneID(2) = "Cell phone"
      phoneID(3) = "Fax phone"
   END IF
   outsideUSA
   FOR i = 0 TO 3
      CONTROL SET TEXT hForm, %ID_Phone1 + i, phoneID(i)
   NEXT i
   IF viewOpt = 1 THEN 'view data
      CONTROL SET TEXT hForm, %ID_CatgText, recData(14)
      CONTROL SET TEXT hForm, %ID_ToTitleTxt, recData(7)
   ELSE 'new record or edit record
      COMBOBOX SELECT hForm, %ID_ToTitle, pamRec(recordNo).toTitle + 1
      TXT = recData(14)
      CONTROL SEND hForm, %ID_Catg, %CB_FINDSTRINGEXACT, 0, VARPTR(TXT) TO n
      COMBOBOX SELECT hForm, %ID_Catg, n + 1
   END IF
   CONTROL SET TEXT hForm, %ID_Lname, recData(0)
   CONTROL SET TEXT hForm, %ID_Fname, recData(1)
   CONTROL SET TEXT hForm, %ID_HomePh, recData(2)
   CONTROL SET TEXT hForm, %ID_BusPh, recData(3)
   CONTROL SET TEXT hForm, %ID_SelfPh, recData(4)
   CONTROL SET TEXT hForm, %ID_FaxPh, recData(5)
   CONTROL SET TEXT hForm, %ID_Email, recData(6)
   CONTROL SET TEXT hForm, %ID_ToName, recData(8)
   CONTROL SET TEXT hForm, %ID_Addr1, recData(9)
   CONTROL SET TEXT hForm, %ID_Addr2, recData(10)
   CONTROL SET TEXT hForm, %ID_City, recData(11)
   CONTROL SET TEXT hForm, %ID_Zip, recData(12)
   CONTROL SET TEXT hForm, %ID_State, recData(13)
   s = left$(recData(15), 240)
   CONTROL SET TEXT hForm, %ID_Note, left$(recData(15), 240)    'recData(15)
   if len(recData(15)) <= 240 then                              
      CONTROL GET TEXT hForm, %ID_Note TO s
      recData(15) = TRIM$(s): moreThan240 = 0
   else
      moreThan240 = 1
   end if                                                  
END SUB                     

SUB getRecordData(spec AS LONG)
   LOCAL i, k, n AS LONG
   LOCAL s AS STRING 
   DIM numBytes(12) AS LONG 
   numBytes(0) = pamRec(recordNo).Lname
   numBytes(1) = pamRec(recordNo).Fname
   numBytes(2) = pamRec(recordNo).homePhone
   numBytes(3) = pamRec(recordNo).busPhone
   numBytes(4) = pamRec(recordNo).cellPhone
   numBytes(5) = pamRec(recordNo).faxPhone
   numBytes(6) = pamRec(recordNo).email
   numBytes(8) = pamRec(recordNo).ToName
   numBytes(9) = pamRec(recordNo).addr1
   numBytes(10) = pamRec(recordNo).addr2
   numBytes(11) = pamRec(recordNo).city
   numBytes(12) = pamRec(recordNo).zip 
   k = 1
   FOR i = 0 TO 12
      n = numBytes(i): recData(i) = ""
      IF n THEN                                             
         recData(i) = MID$(pamData(recordNo), k, n)
         k = k + n
      END IF
   NEXT i
   recData(15) = MID$(pamData(recordNo), k)  'note
   IF spec AND LEFT$(recData(0), 1) = "!" THEN
      recData(0) = LTRIM$(recData(0), ANY " ,!0123456789")
   END IF
   phoneID(0) = "Home phone"
   phoneID(1) = "Bus phone"
   phoneID(2) = "Cell phone"
   phoneID(3) = "Fax phone"
   FOR i = 0 TO 3
      s = recData(2 + i): n = INSTR(s, $NUL)
      IF n THEN phoneID(i) = MID$(s, n + 1)
   NEXT i
   k = pamRec(recordNo).toTitle
   IF k THEN recData(7) = ToTitle(k)
   n = pamRec(recordNo).city
   notUSA = BIT(pamRec(recordNo).flag, 3)
   IF n THEN 'separate city and state [prov]
      s = recData(11)
      recData(11) = PARSE$(s, 1)
      recData(13) = PARSE$(s, 2)
   END IF
   k = pamRec(recordNo).catg
   IF k THEN recData(14) = catg(k)
   IF notUSA THEN 'stored -> displayed
      SWAP recData(10), recData(13)        
      SWAP recData(12), recData(13)
      SWAP recData(10), recData(11)
   END IF
END SUB  

SUB fillRecord(rec AS pamRecord, strData AS STRING)
   'fill rec with text from form for new or edited record 
   LOCAL i, n, USA AS LONG
   LOCAL s, cityName AS STRING
   DIM numBytes(15) AS LONG
   CONTROL GET CHECK hForm, %ID_USA TO n
   IF n THEN notUSA = 1 ELSE USA = 1
   FOR i = 0 TO 14
      CONTROL GET TEXT hForm, %ID_Lname + i TO s
      REPLACE "," WITH " " IN s
      recData(i) = TRIM$(s)
   NEXT i
   if len(recData(15)) <= 240 then                              
      CONTROL GET TEXT hForm, %ID_Note TO s
      recData(15) = TRIM$(s)      
   end if
   IF notUSA THEN 'displayed -> stored
      SWAP recData(10), recData(11)
      SWAP recData(12), recData(13)
      SWAP recData(10), recData(13)
   END IF
   FOR i = 0 TO 15
      numBytes(i) = LEN(recData(i)) 
   NEXT i
   numBytes(7) = 0
   numBytes(14) = 0
   numBytes(13) = 0
   lastName = recData(0)
   firstName = recData(1)
   IF LEN(lastName) = 0 THEN
      recError = %ID_Lname: EXIT SUB
   END IF
   phoneID(0) = "Home phone"
   phoneID(1) = "Bus phone"                                                      
   phoneID(2) = "Cell phone"
   phoneID(3) = "Fax phone"
   FOR i = 0 TO 3
      IF USA THEN 'inside USA, check for valid phone nos.
         CONTROL GET TEXT hForm, %ID_HomePh + i TO s
         IF LEN(s) THEN
            IF invalidPhoneNo(s) THEN
               recError = %ID_HomePh + i: EXIT SUB
            ELSE
               numBytes(i + 2) = LEN(s)
               recData(i + 2) = s
            END IF
         END IF
      END IF
      IF LEN(recData(i + 2)) THEN
         CONTROL GET TEXT hForm, %ID_Phone1 + i TO s
         IF s <> phoneID(i) THEN recData(i + 2) = recData(i + 2) + $NUL + s
         numBytes(i + 2) = LEN(recData(i + 2))
      END IF
   NEXT i
   cityName = recData(11)                                                                     
   IF LEN(cityName) THEN
      cityName = recData(11) + ", " + recData(13)
      recData(13) = ""
   END IF                                               
   recData(11) = cityName
   numBytes(11) = CBYT(LEN(cityName))
   strData = ""
   FOR i = 0 TO 15
      IF numBytes(i) THEN strData = strData + recData(i)
   NEXT i
   rec.Lname = numBytes(0)
   rec.Fname = numBytes(1)
   rec.homePhone = numBytes(2)
   rec.busPhone = numBytes(3)
   rec.cellPhone = numBytes(4)
   rec.faxPhone = numBytes(5)
   rec.email = numBytes(6)
   rec.ToName = numBytes(8)
   rec.addr1 = numBytes(9)
   rec.addr2 = numBytes(10)
   rec.city = numBytes(11)
   rec.zip = numBytes(12)
   rec.dataLength = LEN(strData)
   'flag must reflect list numbers                                             
   BIT SET rec.flag, 1
   IF listNo THEN BIT SET rec.flag, 3 + listNo
   IF notUSA THEN BIT SET rec.flag, 3
   'setup title------------------------------------------------------
   CONTROL SEND hForm, %ID_ToTitle, %CB_GETCURSEL, 0, 0 TO n
   rec.toTitle = CBYT(n)
END SUB
                         
SUB addRecord()
   LOCAL s, sCatg, strData AS STRING
   LOCAL rec AS pamRecord 
   fillRecord rec, strData
   IF recError THEN EXIT SUB
   s = $TAB + lastName
   IF rec.Fname THEN s = s + ", " + firstName                  
   sCatg = recData(14)
   insertRecord s, sCatg, rec, strData
   IF recError THEN EXIT SUB
   IF LEFT$(lastName, 1) = "!" THEN tabNo = 27
   savedRecordNo = recordNo
   IF viewOpt THEN
      DIALOG END hForm
   ELSE
      recordNo = 0: fillForm
      CONTROL SET FOCUS hForm, %ID_Lname
   END IF
END SUB   

SUB insertRecord(sRec AS STRING, sCatg AS STRING, rec AS pamRecord, str AS STRING)
   'insert record, rec, into its proper sorted position
   LOCAL i, n AS LONG
   LOCAL s AS STRING
   IF LEN(sCatg) THEN 'process category
      FOR i = 1 TO numCatgs 'find if catg exists
         IF catg(i) = sCatg THEN n = i: EXIT FOR
      NEXT i                                                                             
      IF n THEN 'existing category
         rec.Catg = n
      ELSE 'new category
         IF numCatgs = 255 THEN
            recError = %ID_Catg: EXIT SUB
         END IF
         INCR numCatgs: catg(numCatgs) = sCatg: rec.Catg = numCatgs
      END IF
   ELSE
      rec.Catg = 0
   END IF
   n = 1
   IF numRecords THEN
      ARRAY SCAN viewListStr(1) FOR numRecords, COLLATE UCASE, > UCASE$(sRec), TO n
   END IF
   INCR numRecords
   IF n = 0 THEN n = numRecords
   IF recordNo THEN 'edited recordNo replaced by record n 
      rec.flag = pamRec(recordNo).flag     'keep same flags
      BIT SET pamRec(recordNo).flag, 0     'replaced record as deleted
      BIT RESET pamRec(recordNo).flag, 1   'replaced record as inactive
      INCR undoLevel: updateMenus
      undel(recordNo) = MAK(LONG, undoLevel, n)
   END IF
   sRec = truncateStr(hDispDC, sRec, 200) + $TAB + getPriPhoneNo(rec, str)
   IF numRecords > maxRecords THEN
      maxRecords = maxRecords + 100
      REDIM PRESERVE pamRec(maxRecords)
      REDIM PRESERVE pamData(maxRecords)
      REDIM PRESERVE viewListStr(maxRecords)
      REDIM PRESERVE undel(maxRecords)                                      
   END IF
   ARRAY INSERT pamRec(n), rec
   ARRAY INSERT pamData(n), str
   ARRAY INSERT viewListStr(n), sRec
   ARRAY INSERT undel(n), 0
   FOR i = recordNo + 2 TO numRecords 'incr high word
      IF undel(i) THEN undel(i) = undel(i) + 65536
   NEXT i
   recordNo = n: fileChanged = 1: reloadList = 1
END SUB

SUB delRecords()
   LOCAL i, n AS LONG
   IF numMarked THEN
      n = deleteWhat: IF n = 0 THEN EXIT SUB
   ELSE
      n = MSGBOX("Delete this record now?", %MB_YESNO OR %MB_ICONQUESTION, "Delete Record")
      IF n = %IDNO THEN EXIT SUB ELSE n = 1
   END IF
   windowNo = 0: INCR undoLevel
   IF n = 1 THEN 'delete just recordNo
      IF BIT(pamRec(recordNo).flag, 2) THEN DECR numMarked
      BIT RESET pamRec(recordNo).flag, 1
      BIT RESET pamRec(recordNo).flag, 2
      undel(recordNo) = undoLevel
   ELSE 'delete all marked records
      FOR i = 1 TO numRecords
         IF BIT(pamRec(i).flag, 2) THEN
            undel(i) = undoLevel
            BIT RESET pamRec(i).flag, 1
            BIT RESET pamRec(i).flag, 2
         END IF
      NEXT i
      numMarked = 0
   END IF
   recordNo = viewList(hiLite)
   fileChanged = 1: reloadList = 1: updateMenus
END SUB

FUNCTION deleteWhat() AS LONG
   LOCAL hDel, result AS LONG
   LOCAL s AS STRING
   DIALOG NEW hWin, "Delete Records", , , 150, 120, %WS_SYSMENU TO hDel
   s = TRIM$(STR$(numMarked)) + " records marked"
   CONTROL ADD LABEL, hDel, -1, s, 10, 10, 120, 12
   CONTROL ADD OPTION, hDel, 101, "Delete single highlighted record", 10, 30, 120, 10
   CONTROL ADD OPTION, hDel, 102, "Delete all marked records", 10, 45, 120, 10
   CONTROL ADD BUTTON, hDel, %IDOK, "Ok", 50, 65, 50, 25
   DIALOG SHOW MODAL hDel, CALL deleteWhatProc TO result
   FUNCTION = result
END FUNCTION

CALLBACK FUNCTION deleteWhatProc()
   LOCAL m, n AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         CONTROL SET OPTION CBHNDL, 101, 101, 102
      CASE %WM_COMMAND
         IF CBCTL = %IDOK THEN
            CONTROL GET CHECK CBHNDL, 101 TO m
            CONTROL GET CHECK CBHNDL, 102 TO n
            IF n THEN m = 2
            DIALOG END CBHNDL, m
         END IF
      CASE %WM_SYSCOMMAND
         IF CBWPARAM = %SC_CLOSE THEN DIALOG END 0
   END SELECT
END FUNCTION

SUB unDo()
   LOCAL i, n AS LONG
   LOCAL s AS STRING
   s = "Undo last delete operation?"
   n = MSGBOX(s, %MB_YESNO + %MB_ICONWARNING, "Undo Last Deletes")
   IF n = %IDNO THEN windowNo = 0: EXIT SUB
   numMarked = 0
   FOR i = 1 TO numRecords
      IF LO(INTEGER, undel(i)) = undoLevel THEN
         IF BIT(pamRec(i).flag, 0) THEN 'replaced record
            n = HI(INTEGER, undel(i)) 'record that replaced it
            BIT RESET pamRec(n).flag, 1  'record n --> inactive
            undel(n) = -1
         END IF
         BIT RESET pamRec(i).flag, 0
         BIT SET pamRec(i).flag, 1   'record i --> active
         BIT SET pamRec(i).flag, 2
         recordNo = i: INCR numMarked: undel(i) = 0
      END IF
   NEXT i
   markedAs = 1: reloadList = 1
   undoLevel = MAX(undoLevel - 1, 0): updateMenus
END SUB

FUNCTION invalidPhoneNo(ph AS STRING) AS LONG
   'use space to separate phone number from aux data
   'aux data can be an extension or a name to ask for, or something else
   'end of phone Number + aux denoted by $NUL
   '-----------------------------------------------------------------------
   LOCAL phNo, s AS STRING
   LOCAL i, k, m, number AS LONG
   LOCAL fcn AS BYTE
   phNo = TRIM$(ph)
   IF LEN(ph) and notUSA = 0 THEN 'check phone number only if in USA
      'first, convert (xxx) xxx-xxxx --> xxx-xxx-xxxx
      s = TRIM$(PARSE$(phNo, ANY "()", 2))
      IF  LEN(s) THEN phNo = s + "-" + TRIM$(PARSE$(phNo, ANY "()", 3))
      s = ""
      m = INSTR(phNo, $NUL)
      IF m THEN phNo = LEFT$(phNo, m - 1): s = MID$(ph, m)
      m = INSTR(phNo, " ")
      IF m THEN phNo = LEFT$(phNo, m - 1): s = MID$(ph, m + 1)
      IF LEN(phNo) = 8 THEN phNo = myAreaCode + "-" + phNo
      if len(phNo) = 10 then phNo = left$(phNo, 3) + "-" + mid$(phNo, 4, 3) + "-" + right$(phNo, 4)
      IF MID$(phNo, 4, 1) <> "-" THEN fcn = 1
      IF MID$(phNo, 8, 1) <> "-" THEN fcn = 1
      if tally(phNo, "-") <> 2 then fcn = 1
      phNo = RETAIN$(phNo, ANY "0123456789-")
      IF LEN(phNo) <> 12 THEN fcn = 1
   END IF
   FUNCTION = fcn: IF fcn THEN EXIT FUNCTION
   ph = phNo: IF LEN(s) THEN ph = ph + " " + s
END FUNCTION

'-----------------------------------------------------------------------
'Properties routines
'-----------------------------------------------------------------------
SUB propertiesDlg()
   LOCAL i, j, n, nStyle AS LONG
   LOCAL s AS STRING
   formWidth = 250: formHeight = 295
   DIALOG NEW hWin, "Define Program Settings", 5, 5, formWidth, formHeight, %WS_SYSMENU TO hProp
   CONTROL ADD LABEL, hProp, -1, "My area code:", 5, 10, 50, 10, %SS_RIGHT
   CONTROL ADD TEXTBOX, hProp, %ID_AreaCode, myAreaCode, 60, 9, 20, 12
   CONTROL ADD LABEL, hProp, -1, "Optional ssPrefix:", 5, 27, 50, 10, %SS_RIGHT
   CONTROL ADD COMBOBOX, hProp, %ID_OptPrefix, , 65, 26, 105, 50, %CBS_DROPDOWN OR %CBS_AUTOHSCROLL OR %WS_TABSTOP
   s = "Phone dial characters include Q and Z"
   CONTROL ADD CHECKBOX, hProp, %ID_PhoneChrsQZ, s, 10, 49, 140, 12
   s = "Include area code for local calls"
   CONTROL ADD CHECKBOX, hProp, %ID_InclAreaCode, s, 10, 64, 140, 12
   CONTROL ADD LABEL, hProp, -1, "Comm port:", 5, 84, 50, 10, %SS_RIGHT
   CONTROL ADD TEXTBOX, hProp, %ID_CommPort, STR$(commPortNo), 60, 83, 20, 12
   CONTROL ADD BUTTON, hProp, %ID_AutoDetect, "&Auto Detect", 90, 79, 50, 20
   CONTROL ADD LABEL, hProp, -1, "Left print margin:", 5, 110, 65, 10, %SS_RIGHT
   s = FORMAT$(leftPrnMargin, "#.###")
   CONTROL ADD TEXTBOX, hProp, %ID_LeftPrnMargin, s, 75, 109, 28, 12
   CONTROL ADD LABEL, hProp, -1, "inches", 106, 110, 20, 10
   CONTROL ADD LABEL, hProp, -1, "Label Pref:", 5, 130, 60, 10, %SS_RIGHT
   nStyle = %CBS_DROPDOWN + %WS_VSCROLL
   CONTROL ADD COMBOBOX, hProp, %ID_LabelSizePref, labelName(), 70, 129, 115, 70, nStyle
   CONTROL ADD BUTTON, hProp, %ID_LabelSize, "Label size", 190, 126, 50, 18
   CONTROL ADD LABEL, hProp, -1, "Envelope Pref:", 5, 150, 60, 10, %SS_RIGHT
   nStyle = %CBS_DROPDOWN + %WS_VSCROLL
   CONTROL ADD COMBOBOX, hProp, %ID_EnvSizePref, envName(), 70, 149, 115, 70, nStyle
   CONTROL ADD BUTTON, hProp, %ID_EnvSize, "Envelope size", 190, 147, 50, 18
   CONTROL ADD LABEL, hProp, -1, "My return address:", 5, 175, 60, 10, %SS_RIGHT
   nStyle = %WS_TABSTOP + %ES_MULTILINE + %ES_WANTRETURN + %WS_VSCROLL
   CONTROL ADD TEXTBOX, hProp, %ID_ReturnAddr, myRetAddr, 70, 175, 170, 28, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hProp, %ID_OK, "&OK", 180, 5, 50, 20
   CONTROL ADD BUTTON, hProp, %IDCANCEL, "&Cancel", 180, 30, 50, 20
   CONTROL ADD FRAME, hProp, -1, "Define Tabs", 2, 210, 240, 60
   nStyle = %BS_NOTIFY + %WS_TABSTOP: getTabLabels
   FOR i = 0 TO 8
      FOR j = 0 TO 2
         n = %ID_Tab + 9 * j + i: s = tabs(9 * j + i + 1)
         CONTROL ADD BUTTON, hProp, n, s, 10 + i * 25, 220 + j * 15, 25, 15,nStyle
         IF i = 8 AND j = 1 THEN EXIT, EXIT
      NEXT j
   NEXT i
   CONTROL ADD TEXTBOX, hProp, %ID_TabEd, tabs(1), 11, 221, 22, 12, %ES_UPPERCASE
   DIALOG SHOW MODAL hProp CALL propertiesProc
END SUB

CALLBACK FUNCTION propertiesProc()
   LOCAL i, j, n, portNo AS LONG
   LOCAL s, ss AS STRING
   STATIC hTabEd AS LONG, nChange AS BYTE
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      s = dataFolder + "winPam.ini"
      IF isfile(s) = 0 THEN 'reset winPam.ini file
         MSGBOX s, %MB_ICONWARNING, "File not found": EXIT FUNCTION
      END IF
      openIniFile
      sPrefix(0) = myPrefix
      sPrefix(1) = morePrefixes1
      sPrefix(2) = morePrefixes2
      COMBOBOX RESET CBHNDL, %ID_OptPrefix
      FOR i = 0 TO 2
         COMBOBOX ADD CBHNDL, %ID_OptPrefix, sPrefix(i)
      NEXT i
      COMBOBOX SELECT CBHNDL, %ID_OptPrefix, 1
      nPrefix = 0: nChange = 0
      CONTROL SET CHECK CBHNDL, %ID_PhoneChrsQZ, phoneChrsQZ
      CONTROL SET CHECK CBHNDL, %ID_InclAreaCode, inclAreaCode
      COMBOBOX RESET CBHNDL, %ID_LabelSizePref
      COMBOBOX RESET CBHNDL, %ID_EnvSizePref
      FOR i = 1 TO numLabels
         COMBOBOX ADD CBHNDL, %ID_LabelSizePref, labelName(i)
      NEXT i
      FOR i = 1 TO numEnvelopes
         COMBOBOX ADD CBHNDL, %ID_EnvSizePref, envName(i)
      NEXT i
      COMBOBOX SELECT CBHNDL, %ID_LabelSizePref, CLNG(labelSizePref)
      COMBOBOX SELECT CBHNDL, %ID_EnvSizePref, CLNG(EnvSizePref)
      CONTROL HANDLE CBHNDL, %ID_TabEd TO hTabEd
      ShowWindow hTabEd, %SW_HIDE
      gOrigTabEdProc = SetWindowLong (hTabEd, %GWL_WNDPROC, CODEPTR(newTabEdProc&))
      lastTab = %ID_Tab
   CASE %WM_COMMAND
      IF CBCTL >= %ID_Tab AND CBCTL < %ID_Tab + 26 THEN
         IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = %BN_SETFOCUS THEN
            n = CBCTL - %ID_Tab: i = n MOD 9: j = n \ 9
            ShowWindow hTabEd, %SW_RESTORE
            'CONTROL SET LOC CBHNDL, %ID_TabEd, 11 + i * 25, 186 + j * 15
            CONTROL SET LOC CBHNDL, %ID_TabEd, 11 + i * 25, 221 + j * 15
            CONTROL SET TEXT CBHNDL, %ID_TabEd, tabs(n + 1)
            CONTROL SET FOCUS CBHNDL, %ID_TabEd
            CONTROL SEND CBHNDL, %ID_TabEd, %EM_SETSEL, 0, -1
            lastTab = CBCTL
         END IF
      ELSEIF CBCTL = %ID_TabEd AND CBCTLMSG = %EN_KILLFOCUS    THEN
         ShowWindow hTabEd, %SW_HIDE
         CONTROL SEND CBHNDL, lastTab, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
      END IF
      IF CBCTL = %ID_AutoDetect THEN
         portNo = GetModemPort(9)
         IF portNo = 0 THEN
            MSGBOX "Could not detect modem", %MB_ICONWARNING, "Modem Detection"
         ELSE
            CONTROL SET TEXT CBHNDL, %ID_CommPort, STR$(portNo)
         END IF
         CONTROL SET FOCUS CBHNDL, %ID_CommPort
         CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
      ELSEIF CBCTL = %ID_OptPrefix THEN
         IF CBCTLMSG = %CBN_CLOSEUP THEN
            CONTROL SEND CBHNDL, %ID_OptPrefix, %CB_GETCURSEL, 0, 0 TO nPrefix
         ELSEIF CBCTLMSG = %CBN_EDITUPDATE THEN
            nChange = 1
         ELSEIF CBCTLMSG = %CBN_DROPDOWN OR CBCTLMSG = %CBN_KILLFOCUS THEN
            IF nChange THEN nChange = 2
         END IF
         IF nChange > 1 AND nPrefix >= 0 THEN
            CONTROL GET TEXT CBHNDL, %ID_OptPrefix TO ss
            n = INSTR(s, "~"): IF n THEN s = LEFT$(s, n - 1)
            IF n THEN s = ss + MID$(s, n) ELSE s = ss
            sPrefix(nPrefix) = s: nChange = 0
            COMBOBOX RESET CBHNDL, %ID_OptPrefix
            FOR i = 0 TO 2
               COMBOBOX ADD CBHNDL, %ID_OptPrefix, sPrefix(i)
            NEXT i
            COMBOBOX SELECT CBHNDL, %ID_OptPrefix, nPrefix + 1
         END IF
      ELSEIF CBCTL = %ID_LabelSize THEN
         defineLabelSize
         n = labelSizePref - 1
         CONTROL SEND CBHNDL, %ID_LabelSizePref, %CB_SETCURSEL, n, 0
      ELSEIF CBCTL = %ID_EnvSize THEN
         defineEnvSize
         n = envSizePref - 1
         CONTROL SEND CBHNDL, %ID_EnvSizePref, %CB_SETCURSEL, n, 0
      ELSEIF CBCTL = %ID_OK THEN
         CONTROL GET TEXT CBHNDL, %ID_AreaCode TO s
         myAreaCode = s
         myPrefix = sPrefix(0)
         morePrefixes1 = sPrefix(1)
         morePrefixes2 = sPrefix(2)
         CONTROL GET CHECK CBHNDL, %ID_PhoneChrsQZ TO phoneChrsQZ
         CONTROL GET CHECK CBHNDL, %ID_InclAreaCode TO inclAreaCode
         CONTROL GET TEXT CBHNDL, %ID_CommPort TO s: commPortNo = VAL(s)
         CONTROL GET TEXT CBHNDL, %ID_LeftPrnMargin TO s
         leftPrnMargin = MAX(0, VAL(s))
         CONTROL SEND CBHNDL, %ID_LabelSizePref, %CB_GETCURSEL, 0, 0 TO n
         labelSizePref = MAX(n, 0) + 1
         CONTROL GET TEXT CBHNDL, %ID_ReturnAddr TO myRetAddr
         myRetAddr = RTRIM$(myRetAddr)
         IF LEFT$(myRetAddr, 2) = $CRLF THEN myRetAddr = MID$(myRetAddr, 3)
         IF RIGHT$(myRetAddr, 2) = $CRLF THEN myRetAddr = LEFT$(myRetAddr, LEN(myRetAddr) - 2)
         tabLabels = "": n = 0
         FOR i = 0 TO 25
            CONTROL GET TEXT CBHNDL, %ID_Tab + i TO s
            IF LEN(s) THEN
               tabLabels = tabLabels + s: INCR n
               CONTROL SET TEXT hWin, %ID_TabButtons + n, s
            END IF
         NEXT i
         saveIniFile
         DIALOG END CBHNDL
      ELSEIF CBCTL = %IDCANCEL THEN
         openIniFile
         DIALOG END CBHNDL
      END IF
   END SELECT
END FUNCTION

FUNCTION getModemPort(ports AS LONG) AS LONG
   LOCAL hComm, lComm, lVal, i, n AS LONG
   LOCAL s AS STRING
   LOCAL comPort AS ASCIIZ * 6
   FOR i = 1 TO 9
      comPort = "COM" + TRIM$(STR$(i))
      lComm = CreateFile (comPort, %GENERIC_READ OR %GENERIC_WRITE, 0, _
                          BYVAL %NULL, %OPEN_EXISTING, 0, BYVAL %NULL)
      SLEEP 100: lVal = 0
      IF (lComm <> %INVALID_HANDLE_VALUE) THEN
         GetCommModemStatus lComm, lVal
      END IF
      CloseHandle lComm
      IF lVal THEN
         FUNCTION = i: EXIT FOR
      ELSE 'now try another way
         hComm = FREEFILE
         COMM OPEN comPort AS #hComm
         COMM SET #hComm, BAUD = 9600
         COMM PRINT #hComm, "ATQ0Z"
         SLEEP 1000
         n = COMM(#hComm, RXQUE)
         COMM RECV #hComm, n, s
         COMM CLOSE #hComm
         IF INSTR(LCASE$(s), "ok") THEN FUNCTION = i: EXIT FOR
      END IF
   NEXT
END FUNCTION

SUB defineLabelSize
   LOCAL hLabelSize AS LONG
   ti = "Label Size"
   DIALOG NEW hProp, ti, 40, -30, 220, 200, %WS_SYSMENU TO hLabelSize
   CONTROL ADD LABEL, hLabelSize, -1, "Label size: ", 10, 10, 40, 10
   CONTROL ADD TEXTBOX, hLabelSize, %ID_LabelName, "", 50, 10, 100, 12
   CONTROL ADD LABEL, hLabelSize, -1, "Label width:", 10, 25, 45, 10
   CONTROL ADD TEXTBOX, hLabelSize, %ID_LabelWidth, "", 55, 25, 40, 12
   CONTROL ADD LABEL, hLabelSize, -1, "Label height:", 10, 40, 45, 10
   CONTROL ADD TEXTBOX, hLabelSize, %ID_LabelHeight, "", 55, 40, 40, 12
   CONTROL ADD FRAME, hLabelSize, -1, "", 5, 55, 170, 75
   CONTROL ADD LABEL, hLabelSize, -1, "Left margin:", 10, 65, 45, 10
   CONTROL ADD TEXTBOX, hLabelSize, %ID_LabelLeft, "", 55, 65, 40, 12
   CONTROL ADD LABEL, hLabelSize, -1, "Top margin:", 10, 80, 45, 10
   CONTROL ADD TEXTBOX, hLabelSize, %ID_LabelTop, "", 55, 80, 40, 12
   CONTROL ADD LABEL, hLabelSize, -1, "Width Spac:", 10, 95, 45, 10
   CONTROL ADD TEXTBOX, hLabelSize, %ID_LabelSpacW, "", 55, 95, 40, 12
   CONTROL ADD LABEL, hLabelSize, -1, "Height Spac", 10, 110, 45, 10
   CONTROL ADD TEXTBOX, hLabelSize, %ID_LabelSpacH, "", 55, 110, 40, 12
   CONTROL ADD BUTTON, hLabelSize, %ID_NewLabel, "&New", 110, 27, 40, 25
   CONTROL ADD BUTTON, hLabelSize, %ID_RemoveLabel, "&Remove",160, 27, 40, 25
   CONTROL ADD BUTTON, hLabelSize, %ID_Compute, "&Compute", 110, 70, 50, 25
   CONTROL ADD BUTTON, hLabelSize, %IDOK, "Ok", 40, 140, 50, 25, %BS_DEFAULT
   CONTROL ADD BUTTON, hLabelSize, %IDCANCEL, "Cancel", 100, 140, 50, 25
   DIALOG SHOW MODAL hLabelSize, CALL labelSizeProc
END SUB

CALLBACK FUNCTION labelSizeProc() AS LONG
   LOCAL fmt, s AS STRING
   LOCAL x, y, r AS DOUBLE
   LOCAL n1, n2, i, n AS LONG
   DIM s(6) AS STRING
   fmt = "#.###"
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         CONTROL SEND hProp, %ID_LabelSizePref, %CB_GETCURSEL, 0, 0 TO n
         IF n < 0 THEN EXIT FUNCTION ELSE labelNo = n + 1
         CONTROL SET TEXT CBHNDL, %ID_LabelName, labelName(labelNo)
         CONTROL DISABLE CBHNDL, %ID_Compute
         CONTROL SET TEXT CBHNDL, %ID_LabelWidth, FORMAT$(labelWidth(labelNo), fmt)
         CONTROL SET TEXT CBHNDL, %ID_LabelHeight, FORMAT$(labelHeight(labelNo), fmt)
         CONTROL SET TEXT CBHNDL, %ID_LabelLeft, FORMAT$(labelLeft(labelNo), fmt)
         CONTROL SET TEXT CBHNDL, %ID_LabelTop, FORMAT$(labelTop(labelNo), fmt)
         CONTROL SET TEXT CBHNDL, %ID_LabelSpacW, FORMAT$(labelSpacW(labelNo), fmt)
         CONTROL SET TEXT CBHNDL, %ID_LabelSpacH, FORMAT$(labelSpacH(labelNo), fmt)
         IF labelNo <= 6 THEN CONTROL DISABLE CBHNDL, %ID_RemoveLabel
         CONTROL SET FOCUS CBHNDL, %ID_LabelWidth
      CASE %WM_COMMAND
         IF CBCTL = %ID_NewLabel THEN
            CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
            IF numLabels = %MaxLabels THEN
               MSGBOX "Maximum number of labels defined", %MB_ICONERROR, ti
               EXIT FUNCTION
            END IF
            labelNo = numLabels + 1
            CONTROL SET TEXT CBHNDL, %ID_LabelName, ""
            CONTROL ENABLE CBHNDL, %ID_Compute
            CONTROL SET TEXT CBHNDL, %ID_LabelWidth, ""
            CONTROL SET TEXT CBHNDL, %ID_LabelHeight, ""
            CONTROL SET TEXT CBHNDL, %ID_LabelLeft, ""
            CONTROL SET TEXT CBHNDL, %ID_LabelTop, ""
            CONTROL SET TEXT CBHNDL, %ID_LabelSpacW, ""
            CONTROL SET TEXT CBHNDL, %ID_LabelSpacH, ""
            CONTROL SET FOCUS CBHNDL, %ID_LabelName
         ELSEIF CBCTL = %ID_RemoveLabel THEN
            n = MSGBOX("Remove this label size?", %MB_YESNO + %MB_ICONWARNING, ti)
            IF n = %IDYES THEN
               DECR numLabels
               FOR i = labelNo TO numLabels
                  labelName(i) = labelName(i+1)
                  labelWidth(i) = labelWidth(i+1)
                  labelHeight(i) = labelHeight(i+1)
                  labelLeft(i) = labelLeft(i+1)
                  labelTop(i) = labelTop(i+1)
                  labelSpacW(i) = labelSpacW(i+1)
                  labelSpacH(i) = labelSpacH(i+1)
               NEXT i
               COMBOBOX DELETE hProp, %ID_LabelSizePref, labelNo
            END IF
            DIALOG END CBHNDL
         ELSEIF CBCTL = %ID_Compute THEN
            CONTROL SEND CBHNDL, %ID_Compute, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
            CONTROL GET TEXT CBHNDL, %ID_LabelName TO s(0)
            CONTROL GET TEXT CBHNDL, %ID_LabelWidth TO s(1)
            CONTROL GET TEXT CBHNDL, %ID_LabelHeight TO s(2)
            x = VAL(s(1)): y = VAL(s(2))
            n1 = VAL(PARSE$(s(0), ANY "[x]", 2))
            n2 = VAL(PARSE$(s(0), ANY "[x]", 3))
            IF n1 = 0 OR n2 = 0 OR x = 0 OR y = 0 THEN
               s = "Must include width and height of label" + $CRLF
               s = s + "and must include [m x n] specification"
               MSGBOX s, %MB_ICONWARNING, "Compute Requirements"
            END IF
            IF x AND y AND n1 AND n2 THEN
               r = x / y
               s(3) = FORMAT$((8.50 - n1 * x)/(n1 + 1), fmt)
               s(4) = FORMAT$((11 - n2 * y)/2, fmt)
               CONTROL SET TEXT CBHNDL, %ID_LabelLeft, s(3)
               CONTROL SET TEXT CBHNDL, %ID_LabelTop, s(4)
               s(5) = STR$(VAL(s(1)) + VAL(s(3))): s(6) = s(2)
               CONTROL SET TEXT CBHNDL, %ID_LabelSpacW, s(5)
               CONTROL SET TEXT CBHNDL, %ID_LabelSpacH, s(6)
            END IF
            CONTROL SET FOCUS CBHNDL, %ID_LabelLeft
            CONTROL SEND CBHNDL, %IDOK, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL
         ELSEIF CBCTL = %IDOK THEN
            FOR i = 0 TO 6
               CONTROL GET TEXT CBHNDL, %ID_LabelName + i TO s(i)
               IF LEN(s(0)) = 0 THEN DIALOG END CBHNDL: EXIT FUNCTION
               IF LEN(s(i)) = 0 THEN
                  MSGBOX "Must fill in all fields", %MB_ICONERROR, ti
                  CONTROL SET FOCUS CBHNDL, %ID_LabelName + i
                  EXIT FUNCTION
               END IF
            NEXT i
            labelName(labelNo) = s(0)
            labelWidth(labelNo) = VAL(s(1))
            labelHeight(labelNo) = VAL(s(2))
            labelLeft(labelNo) = VAL(s(3))
            labelTop(labelNo) = VAL(s(4))
            labelSpacW(labelNo) = VAL(s(5))
            labelSpacH(labelNo) = VAL(s(6))
            IF labelNo > numLabels THEN
               INCR numLabels
               COMBOBOX ADD hProp, %ID_LabelSizePref, labelName(labelNo)
            END IF
            DIALOG END CBHNDL
         END IF
   END SELECT
END FUNCTION

SUB defineEnvSize
   LOCAL hEnvSize AS LONG
   ti = "Envelope Print Index"
   DIALOG NEW hProp, ti, 40, -30, 220, 120, %WS_SYSMENU TO hEnvSize
   CONTROL ADD LABEL, hEnvSize, -1, "Envelope: ", 10, 10, 40, 10
   CONTROL ADD TEXTBOX, hEnvSize, %ID_EnvName, "", 50, 10, 115, 12
   CONTROL ADD LABEL, hEnvSize, -1, "Horz posn:", 10, 25, 45, 10
   CONTROL ADD TEXTBOX, hEnvSize, %ID_EnvHorz, "", 50, 25, 40, 12
   CONTROL ADD LABEL, hEnvSize, -1, "Vert posn:", 10, 40, 45, 10
   CONTROL ADD TEXTBOX, hEnvSize, %ID_EnvVert, "", 50, 40, 40, 12
   CONTROL ADD BUTTON, hEnvSize, %ID_NewEnv, "&New", 110, 27, 40, 25
   CONTROL ADD BUTTON, hEnvSize, %ID_RemoveEnv, "&Remove",160, 27, 40, 25
   CONTROL ADD BUTTON, hEnvSize, %IDOK, "Ok", 40, 70, 50, 25, %BS_DEFAULT
   CONTROL ADD BUTTON, hEnvSize, %IDCANCEL, "Cancel", 100, 70, 50, 25
   DIALOG SHOW MODAL hEnvSize, CALL envSizeProc
END SUB

CALLBACK FUNCTION envSizeProc()
   LOCAL n, i AS LONG
   LOCAL s, fmt AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         fmt = "#.###"
         CONTROL SEND hProp, %ID_EnvSizePref, %CB_GETCURSEL, 0, 0 TO n
         IF n < 0 THEN EXIT FUNCTION ELSE envNo = n + 1
         CONTROL SET TEXT CBHNDL, %ID_EnvName, envName(envNo)
         CONTROL SET TEXT CBHNDL, %ID_EnvHorz, FORMAT$(envHorz(envNo), fmt)
         CONTROL SET TEXT CBHNDL, %ID_EnvVert, FORMAT$(envVert(envNo), fmt)
         IF envNo <= 3 THEN CONTROL DISABLE CBHNDL, %ID_RemoveEnv
         CONTROL SET FOCUS CBHNDL, %ID_EnvHorz
      CASE %WM_COMMAND
         IF CBCTL = %ID_NewEnv THEN
            CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
            IF numEnvelopes = %MaxEnvelopes THEN
               MSGBOX "Maximum number of envelopes defined", %MB_ICONERROR, ti
               EXIT FUNCTION
            END IF
            envNo = numEnvelopes + 1
            CONTROL SET TEXT CBHNDL, %ID_EnvName, ""
            CONTROL SET TEXT CBHNDL, %ID_EnvHorz, ""
            CONTROL SET TEXT CBHNDL, %ID_EnvVert, ""
            CONTROL SET FOCUS CBHNDL, %ID_EnvName
         ELSEIF CBCTL = %ID_RemoveEnv THEN
            n = MSGBOX("Remove this envelope size?", %MB_YESNO + %MB_ICONWARNING, ti)
            IF n = %IDYES THEN
               DECR numEnvelopes
               FOR i = envNo TO numEnvelopes
                  envName(i) = envName(i+1)
                  envHorz(i) = envHorz(i+1)
                  envVert(i) = envVert(i+1)
               NEXT i
               COMBOBOX DELETE hProp, %ID_EnvSizePref, envNo
            END IF
            DIALOG END CBHNDL
         ELSEIF CBCTL = %IDOK THEN
            CONTROL GET TEXT CBHNDL, %ID_EnvName TO s
            IF LEN(s) = 0 THEN DIALOG END CBHNDL: EXIT FUNCTION
            envName(envNo) = s
            CONTROL GET TEXT CBHNDL, %ID_EnvHorz TO s
            envHorz(envNo) = VAL(s)
            CONTROL GET TEXT CBHNDL, %ID_EnvVert TO s
            envVert(envNo) = VAL(s)
            IF envNo > numEnvelopes THEN
               INCR numEnvelopes
               COMBOBOX ADD hProp, %ID_EnvSizePref, envName(envNo)
            END IF
            DIALOG END CBHNDL
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL
         END IF
      END SELECT
END FUNCTION

FUNCTION newTabEdProc&(BYVAL h&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&)
   LOCAL s AS STRING
   SELECT CASE wMsg&
   CASE %WM_KEYUP
      IF wParm& = %VK_RETURN THEN
         CONTROL GET TEXT hProp, %ID_TabEd TO s
         IF MID$(s, 2, 1) = "-" THEN s = LEFT$(s, 3) ELSE s = LEFT$(s, 1)
         CONTROL SET TEXT hProp, lastTab, s
         CONTROL SEND hProp, lastTab, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
         tabs(lastTab - %ID_Tab + 1) = s
         INCR lastTab: IF lastTab = %ID_Tab + 26 THEN lastTab = %ID_Tab
         DIALOG SEND hProp, %WM_COMMAND, lastTab, %BN_CLICKED
      END IF
   END SELECT
   FUNCTION = callWindowProc(gOrigTabEdProc, h&, wMsg&, wParm&, lParm&)
END FUNCTION

'-----------------------------------------------------------------------
'Find Records
'-----------------------------------------------------------------------
SUB findRecords()
   LOCAL nStyle AS LONG
   formWidth = 260: formHeight = 150
   DIALOG NEW hWin, "Find Selected Records", 5, 30, formWidth, formHeight, %WS_SYSMENU TO hFind
   CONTROL ADD LABEL, hFind, -1, "Select category:", 5, 10, 60, 10, %SS_RIGHT
   nStyle = %LBS_SORT + %WS_VSCROLL + %WS_TABSTOP + %LBS_DISABLENOSCROLL
   CONTROL ADD LISTBOX, hFind, %ID_Catg, catg(), 70, 10, 120, 80, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD LABEL, hFind, %ID_Find0, "Find records containing:", 5, 100, 80, 10, %SS_RIGHT
   CONTROL ADD TEXTBOX, hFind, %ID_Find, "", 100, 100, 120, 12
   CONTROL ADD CHECKBOX, hFind, %ID_FindWhole, "Whole Word", 10, 110, 80, 10
   CONTROL ADD BUTTON, hFind, %IDOK, "&OK", 205, 10, 40, 25, %BS_DEFAULT + %WS_TABSTOP
   CONTROL ADD BUTTON, hFind, %IDCANCEL, "&Cancel", 205, 45, 40, 25
   DIALOG SHOW MODAL hFind CALL findRecordsProc
   IF findMode THEN showTabButtons %SW_HIDE
END SUB

CALLBACK FUNCTION findRecordsProc()
   LOCAL n, n1, n2, i, j, k, whole AS LONG
   LOCAL nCatg, ok, spec AS BYTE
   LOCAL TXT AS ASCIIZ * 64
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      findMode = 1
      LISTBOX RESET hFind, %ID_Catg
      FOR i = 1 TO numCatgs
         TXT = catg(i)
         CONTROL SEND hFind, %ID_Catg, %LB_ADDSTRING, 0, VARPTR(TXT) TO n
         CONTROL SEND hFind, %ID_Catg, %LB_SETITEMDATA, n, i
      NEXT i
      findStr = ""
      'CONTROL SET TEXT CB.HNDL, %ID_Find, findStr
      CONTROL SEND CB.HNDL, %ID_Find, %EM_SETSEL, 0, -1
      CONTROL SET FOCUS CB.HNDL, %ID_Find
   CASE %WM_COMMAND
      IF CBCTL = %IDCANCEL THEN
         findMode = 0: DIALOG END hFind
      ELSEIF CBCTL = %IDOK THEN
         LISTBOX GET TEXT hFind, %ID_Catg TO TXT
         CONTROL SEND hFind, %ID_Catg, %LB_FINDSTRINGEXACT, 0, VARPTR(TXT) TO n
         CONTROL SEND hFind, %ID_Catg, %LB_GETITEMDATA, n, 0 TO n
         nCatg = MAX(n, 0): tabNo = 0
         IF nCatg = 0 THEN
            CONTROL GET TEXT hFind, %ID_Find TO findStr
            CONTROL GET CHECK CB.HNDL, %ID_FindWhole TO whole
            numView = 0: findStr = LCASE$(findStr)
            IF whole AND LEN(findStr) THEN findStr = findStr + " "
         END IF
         FOR i = 1 TO numRecords
            BIT RESET pamRec(i).flag, 1
            n = 0: ok = 0: BIT RESET pamRec(i).flag, 1
            IF (listNo = 0 OR listMode) AND BIT(pamRec(i).flag, 0) = 0 THEN ok = 1
            IF listNo AND BIT(pamRec(i).flag, 3 + listNo) THEN ok = 1
            IF ok THEN
               recordNo = i: getRecordData(0)
               IF LEFT$(recData(0), 1) = "!" THEN spec = 1
               IF nCatg AND pamRec(i).catg = nCatg THEN
                  n = 1
               ELSEIF LEN(findStr) THEN
                  FOR j = 0 TO 15
                     k = INSTR(LCASE$(recData(j)), findStr)
                     IF k THEN
                        n = 1: n1 = 0: n2 = 0
                        IF whole THEN 'check only if whole word
                           IF k > 1 THEN n1 = ASC(MID$(recData(j), k - 1, 1))
                           IF k + LEN(findStr) - 1 < LEN(recData(j)) THEN _
                              n2 = ASC(MID$(recData(j), k + LEN(findStr) - 1, 1))
                           IF n1 AND (n1 >= 97 AND n1 <= 122) THEN n = 0
                           IF n2 AND (n2 >= 97 AND n2 <= 122) THEN n = 0
                           EXIT FOR
                        END IF
                     END IF
                  NEXT j
               END IF
            END IF
            IF n AND spec THEN tabNo = 28
            IF n THEN BIT SET pamRec(i).flag, 1
         NEXT i
         savedTabNo = tabNo
         MENU SET STATE hListMenu, 1, %MF_GRAYED
         MENU SET STATE hListMenu, 2, %MF_GRAYED
         MENU SET STATE hListMenu, 3, %MF_GRAYED
         DIALOG END hFind
      ELSEIF CB.CTL = %ID_Catg AND CB.CTLMSG = %LBN_SELCHANGE THEN
         CONTROL DISABLE CB.HNDL, %ID_Find
         CONTROL DISABLE CB.HNDL, %ID_Find0
         CONTROL DISABLE CB.HNDL, %ID_FindWhole
      ELSEIF CBCTL = %ID_Catg AND CBCTLMSG = %LBN_DBLCLK THEN
         DIALOG SEND hFind, %WM_COMMAND, %IDOK, 0
      END IF
   END SELECT
END FUNCTION

'-----------------------------------------------------------------------
' List routines
'-----------------------------------------------------------------------
SUB listName
   DIALOG NEW hWin, "Specify Name for List", 5, 30, 130, 75, %WS_SYSMENU TO hListName
   CONTROL ADD LABEL, hListName, -1, "List Name:", 5, 5, 40, 10, %SS_RIGHT
   CONTROL ADD TEXTBOX, hListName, %ID_ListName, listNames(listNo), 50, 5, 70, 12
   CONTROL ADD BUTTON, hListName, %ID_OK, "&OK", 40, 25, 50, 25, %BS_DEFAULT
   DIALOG SHOW MODAL hListName CALL listNameProc
END SUB

CALLBACK FUNCTION listNameProc()
   LOCAL s AS STRING
   LOCAL i, j AS LONG
   SELECT CASE CBMSG
   CASE %WM_COMMAND
      IF CBCTL = %ID_OK THEN
         CONTROL GET TEXT hListName, %ID_ListName TO s
         IF LEN(TRIM$(s)) = 0 THEN EXIT FUNCTION
         IF listSelected THEN 'change existing list name
            listNames(listNo) = s
            s = "&" + TRIM$(STR$(listNo)) + " " + s
            MENU SET TEXT hListMenu, listNo + 5, s
         ELSE 'add new list name
            INCR numLists: listNames(numLists) = s
            listNo = numLists
            j = %ID_List1 + listNo - 1
            s = "&" + TRIM$(STR$(listNo)) + " " + s
            MENU ADD STRING, hListMenu, s, j, %MF_ENABLED, AT 5 + listNo
         END IF
         DIALOG END hListName
      END IF
   END SELECT
END FUNCTION

SUB showList
   'show selected list from list menu
   LOCAL i, j, f AS LONG
   IF listSelected = listNo THEN 'showing selected list
      MENU SET STATE hListMenu, listNo + 5, %MF_UNCHECKED
      listSelected = 0: listNo = 0
   ELSE 'showing another list
      MENU SET STATE hListMenu, listSelected + 5, %MF_UNCHECKED
      MENU SET STATE hListMenu, listNo + 5, %MF_CHECKED
      listSelected = listNo
   END IF
   j = 3 + listNo
   FOR i = 1 TO numRecords
      f = pamRec(i).flag
      IF undel(i) THEN ITERATE 'no deleted records
      IF listSelected THEN 'set active flag for undeleted or list records
         IF BIT(f, j) THEN BIT SET f, 1 ELSE BIT RESET f, 1
         IF BIT(f, 0) THEN BIT RESET f, 1
      ELSE 'reset active flag for all undeleted records
         IF BIT(f, 0) THEN BIT RESET f, 1 ELSE BIT SET f, 1
      END IF
      BIT RESET f, 2
      pamRec(i).flag = f                                         
   NEXT i
   numMarked = 0
END SUB

'-----------------------------------------------------------------------
'Dial Phone routines
'-----------------------------------------------------------------------
SUB dialPhone()
   LOCAL i AS INTEGER, n AS LONG, ID AS LONG, s AS STRING
   IF numMarked THEN
      s = "Multiple calls for" + STR$(numMarked) + " marked records"
      n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Dial Multiple Calls")
      IF n = %IDNO THEN EXIT SUB
      multiCalls = 1: ID = %ID_NextCall: s = "&Next"
   ELSE
      ID = %IDCANCEL: s = "&Cancel"
   END IF
   recordNo = viewList(hiLite)
   savedRecordNo = recordNo
   IF numMarked THEN multiCalls = 1
   formWidth = 205: formHeight = 212
   DIALOG NEW hWin, "Dial Phone", 5, 25, formWidth, formHeight, %WS_SYSMENU TO hDial
   CONTROL ADD LABEL, hDial, %ID_Name, "", 5, 10, 190, 10, %SS_NOPREFIX + %SS_NOWORDWRAP
   CONTROL ADD FRAME, hDial, -1, "", 5, 20, 185, 70
   getPhoneData: n = 0
   FOR i = 0 TO 3 
      CONTROL ADD LABEL, hDial, %ID_PhNoID + i, phoneID(i) + ":", 10, 30+15*i, 70, 10, %SS_RIGHT
      CONTROL ADD LABEL, hDial, %ID_PhNo + i, phoneNo(i), 90, 30+15*i, 90, 10, %SS_NOTIFY 
      IF LEN(phoneNo(i)) THEN n = 1
   NEXT i
   IF n THEN
      CONTROL ADD LABEL, hDial, %ID_PhSel , phoneNo(0), 90, 30, 90, 10
      CONTROL SET COLOR hDial, %ID_PhSel, %WHITE, %GRAY
   END IF
   CONTROL ADD LABEL, hDial, -1, "Dial:", 5, 96, 15, 10, %SS_RIGHT
   CONTROL ADD TEXTBOX, hDial, %ID_DialEd, "", 25, 96, 160, 12
   IF LEN(myPrefix) = 0 THEN n = %WS_DISABLED ELSE n = %WS_TABSTOP
   CONTROL ADD BUTTON, hDial, %IDOK, "&Dial Now", 25, 115, 50, 20
   CONTROL ADD BUTTON, hDial, ID, s, 80, 115, 50, 20
   CONTROL ADD CHECKBOX, hDial, %ID_Prefix, "&Add ssPrefix", 25, 140, 50, 12
   CONTROL ADD COMBOBOX, hDial, %ID_CBprefix, , 80, 140, 105, 50, %CBS_DROPDOWNLIST OR %CBS_AUTOHSCROLL OR %WS_TABSTOP
   CONTROL ADD LABEL, hDial, -1, "Info:", 5, 160, 15, 10, %SS_RIGHT
   CONTROL ADD LABEL, hDial, %ID_Info, "", 25, 160, 160, 12, %SS_NOPREFIX, %WS_EX_CLIENTEDGE
   CreateStatusWindow %WS_CHILD OR %WS_VISIBLE, "Status:", hDial, %ID_CallStatus
   DIALOG SHOW MODAL hDial CALL dialPhoneProc
END SUB

CALLBACK FUNCTION dialPhoneProc()
   LOCAL i, m, n AS LONG
   LOCAL s, phoneNumber AS STRING
   STATIC ssPrefix AS STRING
   STATIC hPhNo AS LONG
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      sPrefix(0) = myPrefix
      sPrefix(1) = morePrefixes1
      sPrefix(2) = morePrefixes2
      COMBOBOX RESET CBHNDL, %ID_CBPrefix
      FOR i = 0 TO 2
         s = sPrefix(i): n = INSTR(s, "~")
         s = TRIM$(MID$(s, n + 1))
         COMBOBOX ADD CBHNDL, %ID_CBprefix, s
      NEXT i
      COMBOBOX SELECT  CBHNDL, %ID_CBprefix, 1
      IF  nPhone >= 0 THEN
         CONTROL SET TEXT CBHNDL, %ID_DialEd, dialNo(nPhone)
         CONTROL SET TEXT CBHNDL, %ID_Info, info(nPhone)
      END IF
      CONTROL HANDLE CBHNDL, %ID_DialEd TO hPhNo
      gOrigPhNoProc = SetWindowLong (hPhNo, %GWL_WNDPROC, CODEPTR(newPhNoProc&))
      IF nPhone > 0 THEN
         CONTROL SET TEXT CBHNDL, %ID_PhSel, phoneNo(nPhone)
         CONTROL SET LOC CBHNDL, %ID_PhSel, 89, 30 + 15 * nPhone
      END IF
      CONTROL SET FOCUS CBHNDL, %ID_DialEd
   CASE %WM_COMMAND
      IF CBCTL = %IDCANCEL THEN
            dialingNow = 2: multiCalls = 0: lastCalled = 0: DIALOG END CBHNDL
      ELSEIF CBCTL = %ID_CBPrefix THEN
         IF CBCTLMSG = %CBN_SELCHANGE THEN
            DIALOG SEND CBHNDL, %WM_COMMAND, %ID_Prefix, 0
         END IF
      ELSEIF CBCTL = %ID_Prefix THEN
         CONTROL GET CHECK CBHNDL, CBCTL TO n
         CONTROL SEND CBHNDL, %ID_CBPrefix, %CB_GETCURSEL, 0, 0 TO m
         IF n THEN ssPrefix = TRIM$(PARSE$(sPrefix(m), "~", 1)) ELSE ssPrefix = ""
         IF nPhone < 0 THEN CONTROL GET CHECK CBHNDL, CBCTL TO n ELSE s = dialNo(nPhone)
         CONTROL SET TEXT CBHNDL, %ID_DialEd, ssPrefix + s
         CONTROL SET FOCUS CBHNDL, %ID_DialEd: EXIT FUNCTION
      ELSEIF CBCTL = %IDOK THEN 'dial and connect phone using TAPI 1.4
         CONTROL GET TEXT CBHNDL, %ID_DialEd TO phoneNumber
         CONTROL SET TEXT CBHNDL, %ID_CallStatus, "Status:": callStatus = 0
         n = dialNumber(phoneNumber)
         CONTROL SET FOCUS CBHNDL, %ID_DialEd
         IF callStatus = 1 THEN s = "line was busy"
         IF callStatus = 2 THEN s = "no dial tone"
         CONTROL SET TEXT CBHNDL, %ID_CallStatus, "Status: " + s
         IF multiCalls THEN
            s = "Phone Dialer"
            n = MSGBOX("Was the last call completed?", %MB_YESNO + %MB_ICONQUESTION, s)
            IF n = %IDYES THEN
               BIT RESET pamRec(recordNo).flag, 2: DECR numMarked
            END IF
            DIALOG SEND CBHNDL, %WM_COMMAND, %ID_NextCall, 0
         END IF
         IF callStatus = 0 AND numMarked = 0 THEN
            DIALOG SEND CBHNDL, %WM_COMMAND, %IDCANCEL, 0
         END IF
      ELSEIF CBCTL = %ID_NextCall THEN
         getPhoneData
         FOR i = 0 TO 3
             CONTROL SET TEXT CBHNDL, %ID_PhNoID + i, phoneID(i) + ":"
             CONTROL SET TEXT CBHNDL, %ID_PhNo + i, phoneNo(i)
         NEXT i
         IF  nPhone >= 0 THEN
            CONTROL SET TEXT CBHNDL, %ID_DialEd, dialNo(nPhone)
            CONTROL SET TEXT CBHNDL, %ID_Info, info(nPhone)
            CONTROL SET TEXT CBHNDL, %ID_PhSel, phoneNo(nPhone)
            CONTROL SET LOC CBHNDL, %ID_PhSel, 90, 30 + 15 * nPhone
         END IF
         CONTROL SET FOCUS CBHNDL, %ID_DialEd
      ELSEIF CBCTL >= 3020 AND CBCTL <= 3023 AND CBCTLMSG = %STN_CLICKED THEN
         i = CBCTL - %ID_PhNo
         IF LEN(phoneNo(i)) THEN
            nPhone = i
            CONTROL SET TEXT CBHNDL, %ID_PhSel, phoneNo(nPhone)
            CONTROL SET LOC CBHNDL, %ID_PhSel, 89, 30 + 15 * nPhone
            CONTROL SET TEXT CBHNDL, %ID_DialEd, dialNo(nPhone)
            CONTROL SET TEXT CBHNDL, %ID_Info, info(nPhone)
            CONTROL SET CHECK CBHNDL, %ID_Prefix, 0
         END IF
      END IF
      CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
   CASE %WM_DESTROY
      recordNo = savedRecordNo
      LineDrop hCall, BYVAL 0, BYVAL 0
      LineClose hLine
      LineShutdown hTapiApp
      dialingNow = 2  'make sure dialing loop is exited
   END SELECT
END FUNCTION

FUNCTION newPhNoProc&(BYVAL h&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&)
   LOCAL i AS LONG
   SELECT CASE wMsg&
   CASE %WM_KEYUP
      i = nPhone
      IF wParm& = %VK_DOWN AND nPhone >= 0 THEN
         DO: INCR i: IF i > 3 THEN i = 0
         LOOP UNTIL LEN(phoneNo(i)) OR i = nPhone
      ELSEIF wParm& = %VK_UP AND nPhone >= 0 THEN
         DO: DECR i: IF i < 0 THEN i = 3
         LOOP UNTIL LEN(phoneNo(i)) OR i = nPhone
      ELSE
         EXIT SELECT
      END IF
      IF i <> nPhone THEN  'nPhone >= 0 THEN
         nPhone = i
         CONTROL SET TEXT hDial, %ID_PhSel, phoneNo(nPhone)
         CONTROL SET LOC hDial, %ID_PhSel, 89, 30 + 15 * nPhone
         CONTROL SET TEXT hDial, %ID_DialEd, dialNo(nPhone)
         CONTROL SET TEXT hDial, %ID_Info, info(nPhone)
         CONTROL SET CHECK hDial, %ID_Prefix, 0
      END IF
   END SELECT
   FUNCTION = callWindowProc(gOrigPhNoProc, h&, wMsg&, wParm&, lParm&)
END FUNCTION

SUB getPhoneData
   '714-892-4706 plus aux info separated from phone number by space
   'aux info contains [xxx] -> xxx7148924706 plus more aux info
   '... [*82] is used for unblocking by yielding my caller id
   'aux info contains {xxx} -> 7148924706xxx plus more aux info
   '... {,,7777#} pause twice, continue dialing 7777#
   '--------------------------------------------------------------------
   LOCAL i, n AS LONG
   LOCAL s, unBlock, phoneExt AS STRING
   REDIM phoneNo(3), dialNo(3), info(3)
   IF multiCalls THEN
      recordNo = lastCalled
      DO: INCR recordNo
         IF recordNo > numRecords THEN recordNo = 1
         IF BIT(pamRec(recordNo).flag, 2) THEN lastCalled = recordNo
      LOOP UNTIL recordNo = lastCalled
   END IF 
   getRecordData(1)
   s = recData(1) + " " + recData(0): nPhone = -1
   CONTROL SET TEXT hDial, %ID_Name, s
   FOR i = 0 TO 3
      phoneNo(i) = ""
      s = PARSE$(recData(2 + i), $NUL, 1)
      IF LEN(s) THEN
         IF nPhone < 0 THEN nPhone = i
         n = INSTR(s, ANY " ") 'space as divider
         IF n THEN
            info(i) = TRIM$(MID$(s, n + 1))
            s = LEFT$(s, n - 1)
         END IF
         phoneNo(i) = s
         IF BIT(pamRec(recordNo).flag, 3) = 0 THEN 'inside USA
            IF inclAreaCode = 0 AND LEFT$(s, 3) = myAreaCode THEN s = MID$(s, 5) ELSE s = "1-" + s
         END IF
         unblock = PARSE$(info(i), ANY "[]", 2)   'such as *82 for unblocking
         info(i) = PARSE$(info(i), ANY "[]", 1) _
                 + PARSE$(info(i), ANY "[]", 3)   'rest of info
         dialNo(i) = unblock + REMOVE$(s, "-")
         phoneExt = PARSE$(info(i), ANY "{}", 2)  'such as ,,7777#
         info(i) = PARSE$(info(i), ANY "{}", 1) _
                 + PARSE$(info(i), ANY "{}", 3)   'rest of info
         dialNo(i) = unblock + REMOVE$(s, "-") + phoneExt
      END IF
   NEXT i
END SUB

SUB xDialPhone()
   LOCAL n AS LONG
   LOCAL s AS STRING
   formWidth = 200: formHeight = 150
   DIALOG NEW hWin, "Dial Unrecorded Number", 5, 25, formWidth, formHeight, %WS_SYSMENU TO hDial
   s = "Phone Number: "
   CONTROL ADD LABEL, hDial, -1, "Phone Number:", 5, 10, 50, 10  ', %SS_NOPREFIX + %SS_NOWORDWRAP
   CONTROL ADD TEXTBOX, hDial, %ID_PhoneNum, "", 60, 10, 80, 12
   IF LEN(myPrefix) = 0 THEN n = %WS_DISABLED ELSE n = %WS_TABSTOP
   CONTROL ADD COMBOBOX, hDial, %ID_CBprefix, , 60, 30, 105, 50, %CBS_DROPDOWNLIST OR %CBS_AUTOHSCROLL OR %WS_TABSTOP
   CONTROL ADD CHECKBOX, hDial, %ID_Prefix, "&Add ssPrefix", 10, 30, 50, 12
   CONTROL ADD LABEL, hDial, -1, "Dial:", 5, 60, 180, 10
   CONTROL ADD TEXTBOX, hDial, %ID_DialEd, "", 25, 60, 160, 12
   CONTROL ADD BUTTON, hDial, %IDOK, "&Dial Now", 25, 90, 50, 20
   CONTROL ADD BUTTON, hDial, %IDCANCEL, "&Cancel", 80, 90, 50, 20
   CreateStatusWindow %WS_CHILD OR %WS_VISIBLE, "Status:", hDial, %ID_CallStatus
   DIALOG SHOW MODAL hDial CALL xDialPhoneProc
END SUB

CALLBACK FUNCTION xDialPhoneProc()
   LOCAL i, k, n AS LONG
   LOCAL ssPrefix, s AS STRING
   STATIC phoneNumber AS STRING
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      phoneNumber = xDialLast  '""
      CONTROL SET TEXT CB.HNDL, %ID_PhoneNum, xDialLast
      CONTROL SET TEXT CB.HNDL, %IDOK, "&Ok"
      sPrefix(0) = myPrefix
      sPrefix(1) = morePrefixes1
      sPrefix(2) = morePrefixes2
      COMBOBOX RESET CBHNDL, %ID_CBPrefix
      FOR i = 0 TO 2
         s = sPrefix(i): n = INSTR(s, "~")
         s = TRIM$(MID$(s, n + 1) )
         COMBOBOX ADD CBHNDL, %ID_CBprefix, s
      NEXT i
      COMBOBOX SELECT CBHNDL, %ID_CBprefix, 1
   CASE %WM_COMMAND
      IF CBCTL = %IDCANCEL THEN
         DIALOG END CBHNDL
      ELSEIF CBCTL = %ID_Prefix AND LEN(phoneNumber) THEN 'change ssPrefix
         CONTROL GET CHECK CB.HNDL, CBCTL TO n: ssPrefix = ""
         IF n THEN CONTROL GET TEXT CB.HNDL, %ID_CBPrefix TO ssPrefix
         CONTROL SET TEXT CB.HNDL, %ID_DialEd, ssPrefix + phoneNumber
      ELSEIF CBCTL = %ID_PhoneNum THEN
         IF CBCTLMSG = %EN_UPDATE THEN
            CONTROL GET TEXT CBHNDL, CBCTL TO xDialLast
            IF LEN(xDialLast) = 0 THEN CONTROL SET TEXT CB.HNDL, %ID_DialEd, ""
         END IF
      ELSEIF CBCTL = %IDOK THEN 'dial and connect phone using TAPI
         CONTROL GET TEXT CBHNDL, %ID_DialEd TO phoneNumber
         IF LEN(phoneNumber) THEN 'dial now
            dialNumber phoneNumber
         ELSE 'filter phone number (892-CHAS --> 17148922427)
            CONTROL GET TEXT CB.HNDL, %ID_PhoneNum TO s
            s = REMOVE$(s, ANY " -/().,"): phoneNumber = s
            IF inclAreaCode THEN
               IF LEN(s) = 7 THEN s = myAreaCode + s
               IF LEN(s) = 10 THEN phoneNumber = "1" + s
            END IF
            FOR i = 1 TO LEN(phoneNumber)
               n = ASC(MID$(phoneNumber, i, 1))
               IF n >= 97 AND n <= 122 THEN n = n - 32
               IF n >= 65 AND n <= 90 THEN
                  k = 1 + (n - 62)\3
                  IF phoneChrsQZ THEN
                     IF n = 83 OR n = 86 OR n >= 89 THEN DECR k
                  END IF
                  MID$(phoneNumber, i, 1) = CHR$(48 + k)
               END IF
            NEXT i
            CONTROL GET CHECK CB.HNDL, %ID_Prefix TO n
            IF n THEN CONTROL GET TEXT CB.HNDL, %ID_CBPrefix TO ssPrefix
            CONTROL SET TEXT CB.HNDL, %ID_DialEd, ssPrefix + phoneNumber
            CONTROL SET TEXT CB.HNDL, %IDOK, "&Dial now"
         END IF
      END IF
   CASE %WM_DESTROY
      LineDrop hCall, BYVAL 0, BYVAL 0
      LineClose hLine
      LineShutdown hTapiApp
      dialingNow = 2 'make sure dialing loop is exited
   END SELECT
END FUNCTION

FUNCTION DialNumber(phoneNumber AS STRING) AS LONG
   LOCAL i, lRet AS LONG
   LOCAL numLines, lineNo AS DWORD
   LOCAL lcparams AS LINECALLPARAMS, minVer, maxVer, dwAPIVersion AS DWORD
   LOCAL numberToDial AS ASCIIZ *128
   LOCAL lineParams AS LINECALLPARAMS, extID AS LINEEXTENSIONID
   LOCAL devName AS STRING, devNameAddr, devNameSize AS DWORD
   '==============================================================================
   ' Initialize for TAPI 1.4
   '==============================================================================
   numberToDial = phoneNumber
   lRet = LineInitialize (hTapiApp, _
                         BYVAL 0, _
                         BYVAL CODEPTR(TapiCallback), _
                         BYVAL 0, _
                         numLines)
   IF lRet THEN
      MSGBOX "Cannot initialize TAPI Phone service", %MB_ICONERROR, "WinPam dialing": EXIT FUNCTION
   END IF
   lineNo = -1
   FOR i = 0 TO numLines - 1 'find the appropriate line
      '==============================================================================
      ' Negotiate for API Version
      '==============================================================================
      minVer = &h00010003
      maxVer = &h00020001
      lRet = LineNegotiateAPIVersion(BYVAL hTapiApp, BYVAL 0, BYVAL minVer, BYVAL maxVer,_
                                     dwAPIVersion, extID)
      IF lRet THEN ITERATE
      '==============================================================================
      ' Open a Line
      '==============================================================================
      lRet = LineOpen (BYVAL hTapiApp, _
                       BYVAL i, _
                       hLine, _
                       BYVAL dwAPIVersion, _
                       BYVAL 0, _
                       BYVAL 0, _
                       BYVAL %LINECALLPRIVILEGE_NONE, _
                       BYVAL %LINEMEDIAMODE_DATAMODEM, _
                       lcParams)
      IF lRet = 0 THEN lineNo = i: EXIT FOR
   NEXT i
   IF lineNo < 0 THEN MSGBOX "Could not open modem line", %MB_ICONERROR, "WinPam dialing": EXIT FUNCTION
   '==============================================================================
   ' Get modem name for selected line
   '==============================================================================
   LOCAL dwNeeded, sz AS DWORD, pldc AS LINEDEVCAPS PTR
   sz = SIZEOF(LINEDEVCAPS)
   DO
      pldc = VirtualAlloc(BYVAL %NULL, sz, %MEM_COMMIT, %PAGE_READWRITE)
      @pldc.dwTotalSize = sz
      LineGetDevCaps BYVAL hTapiApp, BYVAL lineNo, BYVAL dwAPIVersion, BYVAL 0, BYVAL pldc
      dwNeeded = @pldc.dwNeededSize: IF sz >= dwNeeded THEN EXIT DO
      sz = dwNeeded: VirtualFree BYVAL pldc, sz, %MEM_DECOMMIT
   LOOP UNTIL sz > 10000
   devNameAddr = pldc + @pldc.dwLineNameOffset
   devNameSize = @pldc.dwLineNameSize
   devName = PEEK$(devNameAddr, devNameSize)
   '==============================================================================
   ' Place call and finish up
   '==============================================================================
   lineParams.dwTotalSize = SIZEOF(LINECALLPARAMS)
   lineParams.dwMediaMode = %LINEMEDIAMODE_DATAMODEM
   lRet = LineMakeCall (BYVAL hLine, _
                        hCall, _
                        numberToDial, _
                        BYVAL 0, _
                        lineParams)
   IF lRet < 0 THEN
     MSGBOX "Could not make call: ", %MB_ICONERROR, "WinPam dialing": EXIT FUNCTION
   END IF
   dialingNow = 0
   DO UNTIL dialingNow: DIALOG DOEVENTS: LOOP
   IF dialingNow = 1 THEN phoneDlg hCall, devName
   LineDrop BYVAL hCall, BYVAL 0, BYVAL 0
   LineClose BYVAL hLine
   LineShutdown BYVAL hTapiApp
END FUNCTION

FUNCTION TapiCallback(BYVAL hDevice&, BYVAL dwMsg&, BYVAL CBInstance&,_
                      BYVAL Param1&, BYVAL Param2&, BYVAL Param3&) AS LONG
   LOCAL s AS STRING
   SELECT CASE dwMsg&
   CASE %LINE_CALLSTATE
      IF Param1& = %LINECALLSTATE_IDLE THEN
         IF callStatus = 0 THEN s = "idle": dialingNow = 2
      ELSEIF Param1& = %LINECALLSTATE_CONNECTED THEN
         s = "connected": dialingNow = 1
      ELSEIF Param1& = %LINECALLSTATE_BUSY THEN
         callStatus = 1: s = "busy": dialingNow = 1
      ELSEIF Param1& = %LINECALLSTATE_DISCONNECTED THEN
         IF Param2& = %LINEDISCONNECTMODE_BUSY THEN
            callStatus = 1: s = "busy": dialingNow = 1
         ELSEIF Param2& = %LINEDISCONNECTMODE_NODIALTONE THEN
            callStatus = 2: s = "No dial tone": dialingNow = 2
         END IF
      ELSEIF Param1& = %LINECALLSTATE_PROCEEDING THEN
         dialingNow = 1
      END IF
      IF LEN(s) THEN CONTROL SET TEXT hPhone, 101, "Line status: " + s
   END SELECT
END FUNCTION

SUB PhoneDlg(hCall AS DWORD, devName AS STRING)
   LOCAL nStyle AS DWORD, s AS STRING
   DIALOG NEW hDial, "Phone Dialer",,, 180, 100 TO hPhone
   CONTROL ADD LABEL, hPhone, -1, devName, 5, 5, 160, 12
   s = "Call is processing, lift the receiver" + $CRLF _
     + "... disconnect when dialing is complete"
   CONTROL ADD LABEL, hPhone, 101, s, 10, 25, 160, 24
   nStyle = %BS_DEFAULT + %WS_TABSTOP
   CONTROL ADD BUTTON, hPhone, %IDOK, "&Disconnect", 40, 60, 60, 25, nStyle
   CONTROL ADD BUTTON, hPhone, %IDCANCEL, "&Cancel", 0, 0, 0, 0, %BS_DEFAULT
   DIALOG SET USER hPhone, 1, hCall
   DIALOG SHOW MODAL hPhone, CALL phoneProc
END SUB

CALLBACK FUNCTION phoneProc
   SELECT CASE CBMSG
   CASE %WM_COMMAND
      IF CBCTL = %IDOK OR CBCTL = %IDCANCEL THEN
         DIALOG END CBHNDL
      END IF
   END SELECT
END FUNCTION

'-----------------------------------------------------------------------
'Print routines
'-----------------------------------------------------------------------
SUB printChoice
   LOCAL nStyle AS LONG
   formWidth = 130: formHeight = 130
   DIALOG NEW hWin, "Print What?", 25, 25, formWidth, formHeight, %WS_SYSMENU TO hPrintOpt

   nStyle = %WS_TABSTOP OR %WS_GROUP OR %BS_NOTIFY
   CONTROL ADD OPTION, hPrintOpt, %ID_PrintData, "Record Data", 10, 10, 100, 10, nStyle
   CONTROL ADD OPTION, hPrintOpt, %ID_AddrBook, "&Address Book", 10, 25, 100, 10
   CONTROL ADD OPTION, hPrintOpt, %ID_Labels, "&Label Sheets", 10, 40, 100, 10
   CONTROL ADD OPTION, hPrintOpt, %ID_Envelopes, "&Envelopes", 10, 55, 100, 10
   CONTROL ADD BUTTON, hPrintOpt, %IDOK, "&Ok", 40, 80, 45, 25
   DIALOG SHOW MODAL hPrintOpt CALL printOptProc
END SUB

CALLBACK FUNCTION printOptProc()
   LOCAL i, n AS LONG
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      CONTROL SET OPTION CB.HNDL, %ID_PrintData, %ID_PrintData, %ID_Envelopes
   CASE %WM_COMMAND
      IF CBCTL = %IDCANCEL THEN
         DIALOG END CBHNDL
      ELSEIF CBCTL = %IDOK THEN
         FOR i = %ID_PrintData TO %ID_Envelopes
            CONTROL GET CHECK CBHNDL, i TO n
            IF n AND i = %ID_PrintData THEN printData
            IF n AND i = %ID_AddrBook THEN printAddrBook
            IF n AND i = %ID_Labels THEN prnLabels
            IF n AND i = %ID_Envelopes THEN prnEnvelopes
            IF n THEN EXIT FOR: DIALOG END CB.HNDL
         NEXT i
      END IF
   END SELECT
END FUNCTION

'-----------------------------------------------------------------------
'Print record data
'-----------------------------------------------------------------------
SUB printData
   LOCAL hPrnDC, hFont, hOrigFont, fontHt, charHt, prnError AS LONG
   LOCAL s AS STRING, di AS DOCINFO, tm AS TEXTMETRIC
   LOCAL i, j, k, n, num, nLines, linesPerPg, y0 AS LONG
   DIM xx(60) AS LONG: DIM yy(60) AS LONG: DIM ss(60) AS STRING
   DIALOG END hPrintOpt
   s = "Print data for this entry?"
   IF numMarked THEN s = "Print data for" + STR$(numMarked) + " marked records?"
   n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Print Data")
   IF n = %IDNO THEN EXIT SUB
   hPrnDC = choosePrinter(0)
   IF hPrnDC = 0 THEN GOTO WrapUp
   s = "winPam Print"
   di.cbSize = SIZEOF(di)
   di.lpszDocName = VARPTR(s)
   fontHt = 11
   hFont = makeFont(hPrnDC, fontType, fontHt)
   hOrigFont = SelectObject (hPrnDC, hFont)
   linesPerPg = 60
   IF numMarked = 0 THEN k = viewList(hiLite)
   IF StartDoc(hPrnDC, di) <= 0 THEN prnError = 2: GOTO wrapUp
   IF StartPage(hPrnDC) <= 0 THEN prnError = 3: GOTO WrapUp
   getTextMetrics hPrnDC, tm
   charHt = tm.tmHeight + tm.tmExternalLeading
   FOR i = 1 TO numRecords
      IF BIT(pamRec(i).flag, 2) OR i = k THEN
         recordNo = i: getPrnData hPrnDC, num, ss(), xx(), yy(), charHt
         IF nLines + num > linesPerPg THEN
            EndPage hPrnDC
            nLines = 0: y0 = 0
            StartPage hPrnDC
            SelectObject hPrnDC, hFont
         END IF
         INCR nLines
         FOR j = 0 TO num
            IF j AND yy(j) > yy(j - 1) THEN INCR nLines
            printText hPrnDC, ss(j), xx(j), y0 + yy(j)
         NEXT j
         y0 = y0 + yy(num) + charHt
         INCR nLines
         BIT RESET pamRec(i).flag, 2
         IF numMarked THEN DECR numMarked
         IF numMarked = 0 THEN EXIT FOR
      END IF
   NEXT i
   EndPage hPrnDC
   EndDoc hPrnDC
wrapUp:
   IF prnError THEN
      s = "Printing error has occurred"
      MSGBOX s, %MB_ICONERROR, "Printing Error" + STR$(prnError)
   END IF
   SelectObject hPrnDC, hOrigFont
   DeleteObject hFont
   DeleteDC hPrnDC
END SUB

SUB getPrnData(hPrnDC AS LONG, n AS LONG, s() AS STRING, x() AS LONG, y() AS LONG, h AS LONG)
   'n = number of lines to print
   LOCAL i, k AS LONG
   LOCAL hh, x0 AS DOUBLE
   LOCAL note, s, s0, s1, s2, s3 AS STRING
   getRecordData(1)
   getMailAddr s0, s1, s2, s3
   x0 = 200
   n = 0: x(0) = x0: y(0) = 20
   s(0) = recData(0)
   IF LEN(recData(1)) THEN s(0) = s(0) + ", " + recData(1)              'name
   IF LEN(s1) THEN INCR n: x(n) = x0: y(n) = y(n - 1) + h: s(n) = s1    'addr 1
   IF LEN(s2) THEN INCR n: x(n) = x0: y(n) = y(n - 1) + h: s(n) = s2    'addr 2
   IF LEN(s3) THEN INCR n: x(n) = x0: y(n) = y(n - 1) + h: s(n) = s3    'city
   FOR i = 0 TO 3 'phones
      IF LEN(recData(i + 2)) THEN
         INCR n: x(n) = x0: y(n) = y(n - 1) + h
         'IF i MOD 2 THEN x(n) = x0 + 1000: y(n) = y(n - 1)
         k = INSTR(recData(i + 2), $NUL) - 1: IF k < 0 THEN k = LEN(recData(i + 2))
         s(n) = TRIM$(phoneID(i) + ": " + LEFT$(recData(i + 2), k))
      END IF
   NEXT i
   IF LEN(recData(6)) THEN
      INCR n: x(n) = x0: y(n) = y(n - 1) + h               'email
      s(n) = "E-mail: " + recData(6)
   END IF
   IF LEN(recData(14)) THEN                                'catg
      INCR n: x(n) = x0: y(n) = y(n - 1) + h
      s(n) = "catg: " + recData(14)
   END IF
   note = recData(15)
   IF LEN(note) THEN 'note
      INCR n: x(n) = x0: y(n) = y(n - 1) + h
      s(n) = "Note:": hh = h
      DO WHILE LEN(note)
         'Separate each line by $CRLF
         'Then truncate each of these to line length limits
         INCR n: x(n) = 400: y(n) = y(n - 1) + hh
         i = INSTR(note, $CRLF): s(n) = note
         IF i THEN s(n) = LEFT$(note, i - 1)
         s = truncateStr(hPrnDC, s(n), 3600)
         IF LEN(s) < LEN(s(n)) THEN
            i = INSTR(-1, s, " ")
            IF i THEN s(n) = LEFT$(s, i) ELSE s(n) = s
            note = TRIM$(MID$(note, i + 1))
         ELSEIF i THEN
            note = TRIM$(MID$(note, i + 2))
         ELSE
            note = ""
         END IF
      LOOP
   END IF
   INCR n: x(n) = x0: y(n) = y(n - 1) + h
   s(n) = STRING$(120, "-")
END SUB

FUNCTION MakeFont(hDC AS LONG, fontName AS STRING, BYVAL fontSize AS LONG, _
                                    OPT BYVAL fontAttr AS STRING) AS LONG
   'specify descr = b for bold, u for underline, i for italic
   LOCAL CyPixels, charHt AS LONG
   LOCAL wt, BOLD, underline, italic AS DWORD
   IF LEN(fontAttr) THEN
      BOLD = INSTR(fontAttr, "b") + 300
      underline = INSTR(fontAttr,"u")
      italic = INSTR(fontAttr,"i")
   END IF
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   charHt = (fontSize * CyPixels) \ 72
   wt = %FW_NORMAL + BOLD
   FUNCTION = CreateFont(-charHt, 0, 0, 0, wt, italic, underline, 0, _
              %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
              %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY fontName)
END FUNCTION

'-----------------------------------------------------------------------
'Print address book
'-----------------------------------------------------------------------
SUB printAddrBook
   LOCAL s AS STRING
   LOCAL n, formWi, formHt AS LONG
   DIALOG END hPrintOpt
   formWi = 190: formHt = 300
   DIALOG NEW hWin, "Print Address Book", 5, 10, formWi, formHt, %WS_SYSMENU TO hAddrBook
   s = "Print address book for "
   CONTROL ADD OPTION, hAddrBook, %ID_AllTabs, s + "all index tabs", 25, 10, 135, 10, %WS_GROUP
   CONTROL ADD OPTION, hAddrBook, %ID_ThisTab, s + "this index tab", 25, 25, 135, 10
   CONTROL ADD OPTION, hAddrBook, %ID_Marked, s + "marked records", 25, 40, 135, 10
   CONTROL DISABLE hAddrBook, %ID_ThisTab
   CONTROL DISABLE hAddrBook, %ID_Marked
   IF numMarked THEN n = 0 ELSE n = %WS_DISABLED
   CONTROL ADD LABEL, hAddrBook, -1, "Page title: ", 40, 55, 40, 10, n OR %WS_GROUP
   n = n OR %WS_TABSTOP OR %WS_BORDER
   CONTROL ADD TEXTBOX, hAddrBook, %ID_PgTitle, "", 75, 55, 35, 12, n, %WS_EX_CLIENTEDGE
   CONTROL ADD FRAME, hAddrBook, -1, "", 15, 5, 155, 65

   s = "Print full page (Portrait)"
   CONTROL ADD OPTION, hAddrBook, %ID_FullPage, s, 25, 85, 140, 10, %WS_GROUP
   s = "Print 2 pages (Landscape)"
   CONTROL ADD OPTION, hAddrBook, %ID_HalfPage, s, 25, 100, 140, 10
   s = "Print 6 mini pages (2.83 x 5.5)"
   CONTROL ADD OPTION, hAddrBook, %ID_MiniPage, s, 25, 115, 140, 10
   s = "Large Print (portrait)"
   CONTROL ADD OPTION, hAddrBook, %ID_LargePrn, s, 25, 130, 140, 10
   CONTROL ADD FRAME, hAddrBook, -1, "", 15, 75, 155, 70, %WS_GROUP
   CONTROL SET CHECK hAddrBook, %ID_FullPage, 1

   s = "Single line (name + one phone number)"
   CONTROL ADD CHECKBOX, hAddrBook, %ID_OneLine, s, 25, 155, 140, 10
   s = "No alphabetical page breaks"
   CONTROL ADD CHECKBOX, hAddrBook, %ID_noPgBreak, s, 25, 170, 140, 10
   s = "No alphabetical headers"
   CONTROL ADD CHECKBOX, hAddrBook, %ID_noHeaders, s, 25, 185, 140, 10
   s = "Double sided - Front side"
   CONTROL ADD CHECKBOX, hAddrBook, %ID_FrontSide, s, 25, 200, 140, 10
   s = "Double sided - Back side"
   CONTROL ADD CHECKBOX, hAddrBook, %ID_BackSide, s, 25, 215, 140, 10
   CONTROL ADD BUTTON, hAddrBook, %IDOK, "&OK", 50, formHt - 50, 40, 25, %BS_DEFAULT  + %WS_TABSTOP
   CONTROL ADD BUTTON, hAddrBook, %IDCANCEL, "&Cancel", 100, formHt - 50, 40, 25
   DIALOG SHOW MODAL hAddrBook CALL printAddrBookProc
END SUB

CALLBACK FUNCTION printAddrBookProc()
   LOCAL s AS STRING
   LOCAL recordNoSaved, tabNoSaved AS LONG
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      IF numMarked THEN
         CONTROL DISABLE hAddrBook, %ID_AllTabs
         CONTROL ENABLE hAddrBook, %ID_Marked
         CONTROL SET CHECK hAddrBook, %ID_Marked, 1
         CONTROL SET CHECK hAddrBook, %ID_noPgBreak, 1
         CONTROL DISABLE hAddrBook, %ID_noPgBreak
         CONTROL SET CHECK hAddrBook, %ID_noHeaders, 1
         CONTROL DISABLE hAddrBook, %ID_noHeaders
      ELSEIF tabNo THEN
         CONTROL ENABLE hAddrBook, %ID_ThisTab
         CONTROL SET CHECK hAddrBook, %ID_ThisTab, 1
         CONTROL DISABLE hAddrBook, %ID_noPgBreak
      ELSE
         CONTROL SET CHECK hAddrBook, %ID_AllTabs, 1
      END IF
   CASE %WM_COMMAND
      IF CBCTL = %IDCANCEL THEN
         DIALOG END hAddrBook
      ELSEIF CBCTL = %IDOK THEN
         CONTROL GET CHECK CBHNDL, %ID_OneLine TO singleLine
         CONTROL GET CHECK CBHNDL, %ID_noPgBreak TO noPgBreak
         CONTROL GET CHECK CBHNDL, %ID_noHeaders TO noHeaders
         CONTROL GET CHECK CBHNDL, %ID_FullPage TO fullPage
         CONTROL GET CHECK CBHNDL, %ID_HalfPage TO halfPage
         CONTROL GET CHECK CBHNDL, %ID_MiniPage TO miniPage
         CONTROL GET CHECK CBHNDL, %ID_LargePrn TO largePrn
         CONTROL GET CHECK CBHNDL, %ID_FrontSide TO frontSide
         CONTROL GET CHECK CBHNDL, %ID_BackSide TO backSide
         CONTROL GET TEXT hAddrBook, %ID_PgTitle TO pgTitle
         IF frontSide THEN
            s = "Verify that the two sided printer option is not set" _
              + $CRLF + $CRLF + "See Preferences on next window (Feaures tab if available)  "
            MSGBOX s, %MB_ICONINFORMATION, "Disable Two Sided Printing"
         END IF
         tabNoSaved = tabNo
         recordNoSaved = recordNo
         prnAddrBook
         IF frontSide AND printOk THEN
            s = "Wait till front sides have printed... " + $CRLF  _
              + "Reload the printed pages into the paper tray for back side printing" _
              + $CRLF + $CRLF + "(Be sure the first printed page is on top, second next, etc.)"
            MSGBOX s, %MB_ICONWARNING, "Print Back Side"
            CONTROL SET CHECK hAddrBook, %ID_FrontSide, 0
            CONTROL SET CHECK hAddrBook, %ID_BackSide, 1
         ELSE
            DIALOG END hAddrBook
            markRecords 3
         END IF
         tabNo = tabNoSaved
         recordNo = recordNoSaved
      END IF
   END SELECT
END FUNCTION

SUB printTabTitle(BYVAL hPrnDC AS LONG, x0 AS DOUBLE, y0 AS DOUBLE, s AS STRING)
   'print the address book tab title s at (x0, y0)
   LOCAL x, y, wi, ht AS DOUBLE
   LOCAL TXT AS ASCIIZ*16, sz AS SIZEL
   IF LEN(s) = 1 THEN TXT = "X" ELSE TXT = s
   GetTextExtentPoint hPrnDC, TXT, LEN(TXT), sz
   wi = sz.cx/LEN(TXT): ht = sz.cy
   x = x0 + (LEN(TXT)+1)*wi: y = y0 + 1.2*ht
   Rectangle hPrnDC, x0, y0, x, y
   TXT = s: x = x0 + .5 * wi: y = y0 + .1 * ht
   TextOut BYVAL hPrnDC, x, y, TXT, LEN(TXT)
END SUB

FUNCTION nextAddrBookData(ss() AS STRING, nxt AS LONG) AS LONG
   'get addresses and phone data to print address book
   LOCAL i, j, n AS LONG
   LOCAL s, s0 AS STRING
   n = nxt: nxt = 0
   FOR i = n + 1 TO numView
      recordNo = viewList(i)
      IF numMarked AND BIT(pamRec(recordNo).flag, 2) = 0 THEN ITERATE
      nxt = i: EXIT FOR
   NEXT i
   IF nxt = 0 THEN nxt = numView + 1: EXIT FUNCTION
   getMailAddr ss(0), ss(1), ss(2), ss(3): ss(0) = recData(0)
   IF LEN(recData(1)) THEN ss(0) = ss(0) + ", " + recData(1)
   IF singleLine THEN 'name + home/bus phone
      IF LEN(recData(2)) = 0 THEN recData(2) = recData(3)
      n = 1: ss(1) = ""
   ELSEIF miniPage THEN 'name, address, phone numbers... up to 6 lines
      FOR j = 3 TO 0 STEP -1 'find last field with something in it
         IF LEN(ss(j)) THEN n = j: EXIT FOR
      NEXT j
      FOR j = 0 TO 3 'add phone numbers
         IF LEN(recData(j + 2)) AND n < 5 THEN
            s = phoneID(j): s0 = recData(j + 2): INCR n
            ss(n) = PARSE$(s, " phone", 1) + ": " + PARSE$(s0, " ", 1)
         END IF
      NEXT j
      n = n + 2
   ELSE
      n = 4
   END IF
   FUNCTION = n
END FUNCTION

SUB prnAddrBook
   LOCAL j, k, n, landscape, COUNT, numLines, linesPerPage, x, y AS LONG
   LOCAL hFont, hPrnDC, hOrigFont, fontHt, minTab, maxTab AS LONG
   LOCAL leftDeadZone, topDeadZone, marked, xdpi, ydpi, nextAddrRecord AS LONG
   LOCAL pageNo, pgNo, beginNewPage, beginNewSheet, pagesPerSheet, doPrint, prnError AS LONG
   LOCAL x0, y0, x1, y1, x2, x00, charHt, sLen, rightPrnMargin AS DOUBLE
   LOCAL s, s0 AS STRING, tm AS TEXTMETRIC, di AS DOCINFO
   DIM xx(6) AS DOUBLE, yy(6) AS DOUBLE, pageSeq(12) AS BYTE
   'IF fullPage = 0 AND miniPage = 0 THEN landscape = 1
   IF halfPage OR miniPage THEN landscape = 1
   hPrnDC = choosePrinter(landscape)
   IF hPrnDC = 0 THEN GOTO WrapUp
   IF numMarked = 0 THEN reloadList = 1
   s = "winPam Print"
   di.cbSize = SIZEOF(di)
   di.lpszDocName = VARPTR(s)
   fontHt = 11
   IF miniPage THEN fontHt = 8
   IF largePrn THEN fontHt = 16
   hFont = makeFont(hPrnDC, fontType, fontHt)
   hOrigFont = SelectObject(hPrnDC, hFont)
   GetTextMetrics hPrnDC, tm
   charHt = tm.tmHeight + tm.tmExternalLeading
   xdpi = GetDeviceCaps (hPrnDC, %LOGPIXELSX)                'x direction dpi
   ydpi = GetDeviceCaps (hPrnDC, %LOGPIXELSY)                'y direction dpi
   leftDeadZone = GetDeviceCaps (hPrnDC, %PHYSICALOFFSETX)   'dead zone at left
   topDeadZone = GetDeviceCaps (hPrnDC, %PHYSICALOFFSETY)    'dead zone on top
   rightPrnMargin = .10
   x00 = MAX(leftPrnMargin * xdpi - leftDeadZone, 0)         'loc to start pring
   IF miniPage THEN
      linesPerPage = 5.0 * ydpi / charHt: pagesPerSheet = 6
      sLen = (8.5/3 - leftPrnMargin - rightPrnMargin) * xdpi
      xx(1) = x00: yy(1) = .25 * ydpi - topDeadZone
      xx(2) = x00 + 8.5/3 * xdpi: yy(2) = yy(1)
      xx(3) = x00 + 8.5/3*2 * xdpi: yy(3) = yy(1)
      xx(4) = xx(1): yy(4) = 5.5 * ydpi + yy(1)
      xx(5) = xx(2): yy(5) = yy(4)
      xx(6) = xx(3): yy(6) = yy(4)
      IF frontSide THEN 'double sided printing
         pagesPerSheet = 12
         pageSeq(1) = 1: pageSeq(3) = 2: pageSeq(5) = 3
         pageSeq(7) = 4: pageSeq(9) = 5: pageSeq(11) = 6
      ELSEIF backSide THEN 'double sided printing
         pagesPerSheet = 12
         sLen = (8.5/3 - leftPrnMargin) * xdpi - MAX(rightPrnMargin * xdpi, leftDeadZone)
         pageSeq(2) = 3: pageSeq(4) = 2: pageSeq(6) = 1
         pageSeq(8) = 6: pageSeq(10) = 5: pageSeq(12) = 4
      END IF
   ELSEIF halfPage THEN 'half pages in landscape
      linesPerPage = 8.0 * ydpi / charHt: pagesPerSheet = 2
      sLen = (5.5 - leftPrnMargin - rightPrnMargin) * xdpi
      xx(1) = x00: yy(1) = 0
      xx(2) = (5.5 + leftPrnMargin) * xdpi - leftDeadZone: yy(2) = 0
      IF frontSide THEN 'double sided printing
         pagesPerSheet = 4: pageSeq(1) = 1: pageSeq(3) = 2
      ELSEIF backSide THEN 'double sided printing
         pagesPerSheet = 4: pageSeq(2) = 2: pageSeq(4) = 1
         sLen = (5.5 - leftPrnMargin) * xdpi - MAX(rightPrnMargin * xdpi, leftDeadZone)
      END IF
   ELSE 'full page in portrait
      xx(1) = x00: yy(1) = 0
      linesPerPage = 10.5 * ydpi / charHt: pagesPerSheet = 1
      sLen = (8.5 - leftPrnMargin - rightPrnMargin) * xdpi
      IF frontSide THEN 'double sided printing
         pagesPerSheet = 2: pageSeq(1) = 1
      ELSEIF backSide THEN 'double sided printing
         pagesPerSheet = 2: pageSeq(2) = 2
         'sLen = (5.5 - leftPrnMargin) * xdpi - MAX(rightPrnMargin * xdpi, leftDeadZone)
      END IF
   END IF
   IF StartDoc(hPrnDC, di) <= 0 THEN prnError = 2: GOTO WrapUp
   minTab = tabNo: IF minTab = 27 THEN minTab = -1
   IF minTab THEN maxTab = minTab ELSE minTab = 2 * SGN(listNo) - 1: maxTab = 26
   IF numMarked THEN minTab = 0: maxTab = 0: marked = numMarked
   beginNewSheet = 1: printingAddrBook = 1
   FOR k = minTab TO maxTab
      tabRecords k
      IF numView = 0 THEN ITERATE
      nextAddrRecord = 0: REDIM ss(6) AS STRING
      numLines = nextAddrBookData(ss(), nextAddrRecord)
      DO
         IF beginNewSheet THEN
            EndPage hPrnDC
            beginNewSheet = 0: beginNewPage = 1: pageNo = 0
            IF StartPage(hPrnDC) <= 0 THEN prnError = 3: GOTO WrapUp
            hFont = makeFont(hPrnDC, fontType, fontHt)
            hOrigFont = SelectObject(hPrnDC, hFont)
            IF miniPage THEN
               y = 5.5 * ydpi - topDeadZone
               MoveToEx hPrnDC, 0, y, BYVAL 0
               LineTo hPrnDC, 8.5 * xdpi, y
               x = 8.5/3 * xdpi - leftDeadZone
               MoveToEx hPrnDC, x, 0, BYVAL 0
               LineTo hPrnDC, x, 11 * ydpi
               x = 8.5/3*2 * xdpi - leftDeadZone
               MoveToEx hPrnDC, x, 0, BYVAL 0
               LineTo hPrnDC, x, 11 * ydpi
            ELSEIF halfPage THEN
               x = 5.5 * xdpi - leftDeadZone
               MoveToEx hPrnDC, x, 0, BYVAL 0
               LineTo hPrnDC, x, 8.5 * ydpi
            END IF
         END IF
         IF beginNewPage = 1 THEN 'begin new page         
            INCR pageNo
            IF frontSide OR backSide THEN pgNo = pageSeq(pageNo) ELSE pgNo = pageNo
            IF frontSide = 0 AND backSide = 0 THEN doPrint = 1 ELSE doPrint = 0
            IF frontSide AND (pageNo MOD 2) THEN doPrint = 1
            IF backSide AND (pageNo MOD 2 = 0) THEN doPrint = 1
            x0 = xx(pgNo): y0 = yy(pgNo): s = ""
            COUNT = 1
         ELSEIF beginNewPage = 2 THEN 'continue current page
            IF frontSide = 0 AND backSide = 0 THEN doPrint = 1 ELSE doPrint = 0
            IF frontSide AND (pageNo MOD 2) THEN doPrint = 1
            IF backSide AND (pageNo MOD 2 = 0) THEN doPrint = 1
            IF noHeaders = 0 THEN COUNT = COUNT + 2
            x1 = x0: y1 = y0 + (COUNT - 1) * charHt
         END IF
          'first, draw top line separator for record - before tab title
         IF singleLine = 0 AND miniPage = 0 THEN
            x = x0: y = charHt * COUNT: INCR COUNT
            IF doPrint THEN printText hPrnDC, STRING$(96, "-"), x, y
         END IF
          'next, print tab title if new page
         IF beginNewPage = 1 AND doPrint THEN
            IF numMarked AND noHeaders = 0 THEN
               printTabTitle hPrnDC, x0, y0, pgTitle
            ELSEIF k < 0 AND noHeaders = 0 THEN
               printTabTitle hPrnDC, x0, y0, tabs(27)
            ELSEIF k < 27 AND noHeaders = 0 THEN
               printTabTitle hPrnDC, x0, y0, tabs(k)
            END IF
         ELSEIF beginNewPage = 2 AND doPrint AND numMarked = 0 AND noHeaders = 0 THEN
            printTabTitle hPrnDC, x1, y1, tabs(k)
         END IF
         IF beginNewPage AND (miniPage OR singleLine) THEN INCR COUNT
         beginNewPage = 0
         FOR j = 0 TO numLines - 1
            s = ss(j): n = sLen
            IF miniPage THEN
               IF singleLine AND j = 0 THEN
                  s = s + "  " + recData(2)
                  s = truncateStr(hPrnDC, s, n)
               END IF
               x = xx(pgNo): y = yy(pgNo) +  charHt * COUNT: INCR COUNT
               IF doPrint THEN printText hPrnDC, s, x, y
               IF LEN(ss(j)) = 0 THEN EXIT FOR
            ELSE
               x2 = 2.5: IF largePrn THEN x2 = 3.8
               x = xx(pgNo): y = yy(pgNo) + charHt * COUNT: INCR COUNT
               s = truncateStr(hPrnDC, s, n)
               IF doPrint THEN printText hPrnDC, ss(j), x, y
               x = x + x2 * xdpi: s = phoneID(j): s0 = recData(j + 2)
               'leave out "phone" and info
               s = PARSE$(s, " phone", 1) + ": " + PARSE$(s0, " ", 1)
               IF singleLine THEN s = "": IF j = 0 THEN s = recData(2)
               s = truncateStr(hPrnDC, s, n)
               IF doPrint THEN printText hPrnDC, s, x, y
            END IF
         NEXT j
         REDIM ss(6) AS STRING
         numLines = nextAddrBookData(ss(), nextAddrRecord)
         j = 0
         IF numMarked = 0 THEN
            IF miniPage THEN j = -1
            IF nextAddrRecord > numView THEN j = j + 3
         ELSE
            DECR marked: IF marked = 0 THEN EXIT FOR
         END IF
         IF COUNT + numLines + j >= linesPerPage THEN
            beginNewPage = 1: IF pageNo = pagesPerSheet THEN beginNewSheet = 1
         END IF
      LOOP UNTIL nextAddrRecord > numView
      IF noPgBreak = 0 OR beginNewPage THEN 'page break - begin new page
         beginNewPage = 1: IF pageNo = pagesPerSheet THEN beginNewSheet = 1
      ELSE 'no page break - continue same page
         beginNewPage = 2
      END IF
   NEXT k
   printOk = 1
   EndPage hPrnDC
   EndDoc hPrnDC
WrapUp:
   printingAddrBook = 0
   IF prnError THEN
      s = "Printing error has occurred"
      MSGBOX s, %MB_ICONERROR, "Printing Error" + STR$(prnError)
      EndDoc hPrnDC
   END IF
   SelectObject hPrnDC, hOrigFont
   DeleteObject hFont
   DeleteDC hPrnDC
END SUB

'-----------------------------------------------------------------------
'Print Labels
'-----------------------------------------------------------------------
SUB prnLabels
   local nStyle AS LONG
   formWidth = 200: formHeight = 110
   nStyle = %WS_TABSTOP + %CBS_DROPDOWNLIST
   DIALOG NEW hWin, "Print Labels", , ,formWidth, formHeight, %WS_SYSMENU TO hLabel
   CONTROL ADD LABEL, hLabel, -1, "Pick label size:", 5, 12, 48, 12, %SS_RIGHT
   CONTROL ADD COMBOBOX, hLabel, %ID_LabelSize, labelName(), 55, 10, 100, 70, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD OPTION, hLabel, %ID_MailAddr, "Mailing Addresses", 5, 30, 70, 15
   CONTROL ADD OPTION, hLabel, %ID_RetnAddr, "Return Addresses", 5, 45, 70, 15
   control add option, hLabel, %ID_CustomLabel, "Custom Label", 5, 60, 70, 15
   CONTROL ADD BUTTON, hLabel, %IDOK, "&Print", 100, 35, 40, 25, %BS_DEFAULT + %WS_TABSTOP
   CONTROL ADD BUTTON, hLabel, %IDCANCEL, "&Cancel", 145, 35, 40, 25
   DIALOG SHOW MODAL hLabel& CALL prnLabelsProc
END SUB

CALLBACK FUNCTION prnLabelsProc()
   LOCAL i, n, nType, nSize AS LONG
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      DIALOG END hPrintOpt
      COMBOBOX SELECT hLabel, %ID_LabelSize, CLNG(labelSizePref)
      CONTROL SET CHECK hLabel, %ID_MailAddr, 1
      CONTROL SET CHECK hLabel, %ID_RetnAddr, 0
   CASE %WM_COMMAND
      SELECT CASE CBCTL
      CASE %IDCANCEL
         DIALOG END hLabel
      CASE %ID_RetnAddr
         COMBOBOX SELECT hLabel, %ID_LabelSize, 6
      CASE %ID_MailAddr, %ID_CustomLabel
         COMBOBOX SELECT hLabel, %ID_LabelSize, CLNG(labelSizePref)
      CASE %IDOK
         CONTROL SEND hLabel, %ID_LabelSize, %CB_GETCURSEL, 0, 0 TO n
         IF n < 0 THEN EXIT FUNCTION ELSE nSize = n + 1
         for i = 0 to 2
            CONTROL GET CHECK hLabel, %ID_RetnAddr + i TO n
            if n then nType = i: exit for
         next i
         printLabels nSize, nType
         DIALOG END hLabel
      END SELECT
   END SELECT
END FUNCTION

SUB printLabels(nSize AS LONG, nType AS LONG)
   'ntype = 0  return Address labels
   '      = 1  mailing address labels
   '      = 2  custom labels
   '----------------------------------------------------
   LOCAL hPrnDC, prnError, nLabels AS LONG
   LOCAL hFont, hOrigFont, fontHt, beginNewPage AS LONG
   LOCAL i, j, k, n, COUNT, numToPrint, cols, rows, x, y AS LONG
   LOCAL dx, dy, x0, y0, xRes, yRes, charHt, noPrnLeft, noPrnTop AS DOUBLE
   LOCAL s, s1, s2, s3, s4, sLabel, savedFontType AS STRING
   LOCAL tm AS TEXTMETRIC, di AS DOCINFO
   s = labelName(nSize)
   cols = VAL(PARSE$(s, ANY "[x]", 2))
   rows = VAL(PARSE$(s, ANY "[x]", 3))
   nLabels = cols * rows
   IF nType = 1 THEN 'address labels
      numToPrint = 0
      FOR i = 1 TO numRecords
         IF BIT(pamRec(i).flag, 1) = 0 THEN ITERATE 'inactive
         IF BIT(pamRec(i).flag, 2) = 0 THEN ITERATE 'not marked
         recordNo = i: getMailAddr s1, s2, s3, s4
         IF LEN(s1) = 0 OR LEN(s2)= 0 OR LEN(s3) = 0 THEN ITERATE 'no addr
         INCR numToPrint
      NEXT i
      IF numToPrint = 0 THEN
         MSGBOX "No labels to print",%MB_ICONWARNING: EXIT SUB
      END IF
   else 'return address labels or custom labels
      sLabel = myRetAddr
      if nType = 2 then 'custom labels
         s = string$(60, 32)+$crlf+$crlf
         sLabel = myInput(0, "", "Label Content", s)
      end if
      s1 = PARSE$(sLabel, $CRLF, 1)
      s2 = PARSE$(sLabel, $CRLF, 2)
      s3 = PARSE$(sLabel, $CRLF, 3)
      IF LEN(s1) = 0 OR LEN(s2) = 0 OR LEN(s3) = 0 THEN
         MSGBOX "Incomplete label content specified", %MB_ICONWARNING: EXIT SUB
      END IF
   END IF
   savedRecordNo = recordNo
   savedFontType = fontType
   hPrnDC = choosePrinter(0)
   IF hPrnDC = 0 THEN GOTO WrapUp
   s = "winPam Print"
   di.cbSize = SIZEOF(di)
   di.lpszDocName = VARPTR(s)
   xRes = GetDeviceCaps (hPrnDC, %LOGPIXELSX)    'x direction dpi
   yRes = GetDeviceCaps (hPrnDC, %LOGPIXELSY)    'y direction dpi
   noPrnLeft = GetDeviceCaps (hPrnDC, %PHYSICALOFFSETX)  'printer dead zone left
   noPrnTop = GetDeviceCaps (hPrnDC, %PHYSICALOFFSETY)   'printer dead zone top
   x0 = labelWidth(nSize)
   y0 = labelHeight(nSize)
   fontHt = 6 + 7 * y0 - 1 * y0 ^ 2
   'IF x0 / y0 > 3.52 THEN fontType = "Courier New"
   hFont = makeFont(hPrnDC, fontType, fontHt)
   hOrigFont = SelectObject (hPrnDC, hFont)
   getTextMetrics hPrnDC, tm
   charHt = tm.tmHeight + tm.tmExternalLeading
   x = labelWidth(nSize) * xRes
   y = labelHeight(nSize) * yRes
   x0 = labelLeft(nSize) * xRes + charHt/2 - noPrnLeft
   y0 = labelTop(nSize) * yRes + (y - 4 * charHt) / 2 - noPrnTop
   x0 = MAX(x0, 0): y0 = MAX(y0, 0)
   dx = labelSpacW(nSize) * xRes
   dy = labelSpacH(nSize) * yRes
   IF StartDoc(BYVAL hPrnDC, di) <= 0 THEN prnError = 2: GOTO WrapUp
   i = 0: j = 0: COUNT = 0: beginNewPage = 1
   IF nType = 1 THEN n = numRecords ELSE n = nLabels
   numMarked = 0
   FOR k = 1 TO n
      IF beginNewPage THEN
         IF StartPage(hPrnDC) <= 0 THEN prnError = 3: GOTO WrapUp
         SelectObject hPrnDC, hFont: beginNewPage = 0
      END IF
      IF nType = 1 THEN
         IF BIT(pamRec(k).flag, 1) = 0 THEN ITERATE 'inactive
         IF BIT(pamRec(k).flag, 2) = 0 THEN ITERATE 'not marked
         recordNo = k: getMailAddr s1, s2, s3, s4
         IF LEN(s1) = 0 OR LEN(s2)= 0 OR LEN(s3) = 0 THEN  'no address
            BIT SET pamRec(k).flag, 2
            INCR numMarked: markedAs = 2: ITERATE
         ELSE
            BIT RESET pamRec(k).flag, 2
         END IF
      END IF
      INCR COUNT
      x = x0 + i * dx
      y = y0 + j * dy
      printText hPrnDC, s1, x, y  'name
      y = y + charHt
      printText hPrnDC, s2, x, y  'addr 1
      y = y + charHt
      printText hPrnDC, s3, x, y  'city or addr 2
      IF LEN(s4) THEN  '4 line address... city or country
         y = y + charHt
         printText hPrnDC, s4, x, y
      END IF
      INCR i: IF i = cols THEN i = 0: INCR j
      IF COUNT MOD nLabels = 0 AND COUNT < numToPrint THEN
         EndPage hPrnDC
         i = 0: j = 0: beginNewPage = 1
      END IF
   NEXT k
   EndPage hPrnDC
   EndDoc hPrnDC
WrapUp:
   IF prnError THEN
      s = "Printing error has occurred"
      MSGBOX s, %MB_ICONERROR, "Printing Error" + STR$(prnError)
   END IF
   SelectObject hPrnDC, hOrigFont
   DeleteObject hFont
   DeleteDC hPrnDC
   fontType = savedFontType
   recordNo = savedRecordNo
END SUB

SUB getMailAddr(s1 AS STRING, s2 AS STRING, s3 AS STRING, s4 AS STRING)
   LOCAL n AS LONG, s AS STRING
   getRecordData(1)
   s1 = recData(8)   'name
   s2 = recData(9)   'addr 1
   s3 = recData(10)  'addr 2
   s4 = ""           'city, state zip
   n = pamRec(recordNo).toTitle
   IF n THEN s1 = ToTitle(n) + " " + s1
   IF LEN(s1) = 0 THEN
      IF LEN(recData(1)) THEN s = " "
      s1 = recData(1) + s + recData(0)
   END IF
   IF notUSA THEN
      IF LEN(recData(10)) THEN
         s3 = recData(10) + "  " + recData(11)
      END IF
      IF LEN(recData(12)) THEN
         s4 = recData(12) + ", " + recData(13)
      END IF
   ELSE
      IF LEN(recData(11)) THEN
         s4 = recData(11)
         IF LEN(recData(13)) THEN
            s4 = s4 + ", " + recData(13) + "  " + recData(12)
         END IF
      END IF
      IF LEN(s3) = 0 THEN s3 = s4: s4 = ""
   END IF
END SUB

SUB printText(BYVAL hPrnDC AS LONG, s AS STRING, x AS LONG, y AS LONG, _
                    OPT BYVAL fontSize AS LONG, BYVAL fontAttr AS STRING)
   LOCAL hFont, hOrigFont AS LONG
   IF fontSize THEN
      hFont = makeFont(hPrnDC, fontType, fontSize, fontAttr)
      hOrigFont = SelectObject (BYVAL hPrnDC, BYVAL hFont)
   END IF
   TextOut BYVAL hPrnDC, x, y, BYCOPY s, LEN(s)
   IF hFont THEN DeleteObject SelectObject(BYVAL hPrnDC, BYVAL hOrigFont)
END SUB

'-----------------------------------------------------------------------
'print envelopes
'-----------------------------------------------------------------------
SUB prnEnvelopes()
   LOCAL nStyle AS LONG, s AS STRING
   s = "Pick envelope size:"
   IF numMarked THEN s = "Pick envelope size for" + STR$(numMarked) + " marked entries"
   formWidth = 170: formHeight = 120
   nStyle = %WS_TABSTOP + %CBS_DROPDOWNLIST
   DIALOG NEW hWin, "Print Envelope", , ,formWidth, formHeight, %WS_SYSMENU TO hEnvelope
   CONTROL ADD LABEL, hEnvelope, -1, s, 5, 5, 150, 12, %SS_LEFT
   CONTROL ADD COMBOBOX, hEnvelope, %ID_EnvSize, envName(), 5, 18, 120, 70, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hEnvelope, %IDOK, "&Print", 50, 60, 40, 25, %BS_DEFAULT + %WS_TABSTOP
   CONTROL ADD BUTTON, hEnvelope, %IDCANCEL, "&Cancel", 100, 60, 40, 25
   DIALOG SHOW MODAL hEnvelope CALL prnEnvelopeProc
END SUB

CALLBACK FUNCTION prnEnvelopeProc
   LOCAL n AS LONG
   SELECT CASE CBMSG
   CASE %WM_INITDIALOG
      DIALOG END hPrintOpt
      COMBOBOX SELECT hEnvelope, %ID_EnvSize, CLNG(envelopeSize)
   CASE %WM_COMMAND
      SELECT CASE CBCTL
      CASE %IDCANCEL
         DIALOG END hEnvelope
      CASE %IDOK
         IF numMarked = 0 THEN
            BIT SET pamRec(recordNo).flag, 2: numMarked = 1
         END IF
         CONTROL SEND hEnvelope, %ID_EnvSize, %CB_GETCURSEL, 0, 0 TO n
         IF n < 0 THEN EXIT FUNCTION ELSE envelopeSize = n + 1
         printEnvelope: DIALOG END hEnvelope
      END SELECT
   END SELECT
END FUNCTION

SUB printEnvelope
   LOCAL s, s1, s2, s3, s5, s6, s7, s8 AS STRING
   LOCAL envWidth, envLength, xres, yres, charHt, charHt1 AS DOUBLE
   LOCAL x, y, k, landscape, hPrnDC, hFont, hOrigFont, fontHt, prnError AS LONG
   LOCAL tm AS TEXTMETRIC, di AS DOCINFO
   'hPrnDC = getLandscapeDC
   landscape = 1
   hPrnDC = choosePrinter(landscape)
   s = "winPam Print"
   di.cbSize = SIZEOF(di)
   di.lpszDocName = VARPTR(s)
   xres = GetDeviceCaps(hPrnDC, %LOGPIXELSX)
   yres = GetDeviceCaps(hPrnDC, %LOGPIXELSY)
   s = envName(envelopeSize)
   envWidth = VAL(PARSE$(s, ANY "[x]", 2))
   envLength = VAL(PARSE$(s, ANY "[x]", 3))
   IF LEN(myRetAddr) THEN
      fontHt = 10
      hFont = makeFont(hPrnDC, fontType, fontHt)
      hOrigFont = SelectObject (hPrnDC, hFont)
      getTextMetrics hPrnDC, tm
      charHt1 = tm.tmHeight + tm.tmExternalLeading
      DeleteObject SelectObject(hPrnDC, hOrigFont)
   END IF
   fontHt = 14
   hFont = makeFont(hPrnDC, fontType, fontHt)
   hOrigFont = SelectObject (hPrnDC, hFont)
   getTextMetrics hPrnDC, tm
   charHt = tm.tmHeight + tm.tmExternalLeading
   savedRecordNo = recordNo
   IF hPrnDC = 0 THEN prnError = 1: GOTO WrapUp
   IF LEN(myRetAddr) THEN
      s1 = PARSE$(myRetAddr, $CRLF, 1)
      s2 = PARSE$(myRetAddr, $CRLF, 2)
      s3 = PARSE$(myRetAddr, $CRLF, 3)
   END IF
   IF StartDoc(BYVAL hPrnDC, di) <= 0 THEN prnError = 2: GOTO WrapUp
   numMarked = 0
   FOR k = 1 TO numRecords
      IF BIT(pamRec(k).flag, 1) = 0 THEN ITERATE 'inactive
      IF BIT(pamRec(k).flag, 2) = 0 THEN ITERATE 'not marked
      recordNo = k: getMailAddr s5, s6, s7, s8
      IF LEN(s5) = 0 OR LEN(s6)= 0 OR LEN(s7) = 0 THEN 'no address
         BIT SET pamRec(k).flag, 2
         INCR numMarked: markedAs = 2: ITERATE
      ELSE
         BIT RESET pamRec(k).flag, 2
      END IF
      MSGBOX "Ready to print envelope", %MB_ICONINFORMATION + %MB_OK, "Printing Envelopes"
      IF StartPage(hPrnDC) <= 0 THEN prnError = 3: GOTO WrapUp
      SelectObject hPrnDC, hFont
      IF LEN(myRetAddr) THEN 'print return address ---------------------
         fontHt = 10
         x = xres * envHorz(envelopeSize)
         y = yres * envVert(envelopeSize)
         printText hPrnDC, s1, x, y, fontHt
         y = y + charHt1
         printText hPrnDC, s2, x, y, fontHt
         y = y + charHt1
         printText hPrnDC, s3, x, y, fontHt
      END IF
      'print mailing address -------------------------------------------
      fontHt = 14
      x = xres * (envHorz(envelopeSize) + .40 * envLength)
      y = yres * (envVert(envelopeSize) + .40 * envWidth)
      printText hPrnDC, s5, x, y, fontHt  'name
      y = y + charHt
      printText hPrnDC, s6, x, y, fontHt  'addr 1
      y = y + charHt
      printText hPrnDC, s7, x, y, fontHt  'city or addr 2
      IF LEN(s8) THEN      '4 line address... city or country
         y = y + charHt
         printText hPrnDC, s8, x, y, fontHt
      END IF
      EndPage hPrnDC
   NEXT k
   EndDoc hPrnDC
WrapUp:
   IF prnError THEN
      s = "Printing error has occurred"
      MSGBOX s, %MB_ICONERROR, "Printing Error" + STR$(prnError)
   END IF
   IF numMarked THEN
      s = "Marked records are without address"
      MSGBOX s, %MB_OK + %MB_ICONWARNING, "Print Envelopes"
   END IF
   SelectObject hPrnDC, hOrigFont
   DeleteObject hFont
   DeleteDC hPrnDC
   recordNo = savedRecordNo
END SUB

FUNCTION choosePrinter(landscape AS LONG) AS LONG
   'choose printer and return device context handle
   LOCAL n, hdc, hDevMode AS LONG
   LOCAL pDevMode AS DEVMODE PTR
   LOCAL pd AS PRINTDLGAPI, pDevNames AS DEVNAMES PTR
   LOCAL tm AS TEXTMETRIC, psz AS ASCIIZ PTR
   pd.lStructSize = SIZEOF(pd)
   pd.Flags = %PD_RETURNDC OR %PD_HIDEPRINTTOFILE
   pd.Flags = pd.Flags OR %PD_ALLPAGES OR %PD_NOSELECTION OR %PD_NOPAGENUMS
   IF PrintDlg(pd) THEN 'call print dialog to select printer
      pDevNames = GlobalLock(pd.hDevNames)
      psz = pDevNames + @pDevNames.wDeviceOffset
      GlobalUnlock pd.hDevnames: hdc = pd.hDC
   END IF
   hDevMode = pd.hDevMode
   n = landscape + 1
   IF hDevMode THEN
      pDevMode = GlobalLock(hDevMode)
      IF n AND @pDevMode.dmFields AND %DM_ORIENTATION THEN
         IF n THEN @pDevMode.dmOrientation = n
         @pDevMode.dmFields = @pDevMode.dmFields OR %DM_ORIENTATION
         ResetDC hdc, @pDevMode
         GlobalUnlock hDevMode
      END IF
   END IF
   FUNCTION = hdc
END FUNCTION

'-----------------------------------------------------------------------
'Show calendar
'-----------------------------------------------------------------------
FUNCTION calendar(OPT BYVAL sDate AS STRING) AS STRING
   'nDate = year:mo  (101934, mo = 10, yr = 1934)
   'If nDate is specified then open calendar to that month and year
   'Otherwise, open calendar to current date month and year
   LOCAL n AS LONG
   DIALOG NEW 0, "Calendar", , , 442, 200, %WS_SYSMENU TO hCal
   DIALOG SET COLOR hCal, -1, %WHITE
   CONTROL ADD BUTTON, hCal, %IDC_DecrYr, "<<  Year", 40, 150, 58, 25
   CONTROL ADD BUTTON, hCal, %IDC_DecrMo, "<  Month", 100, 150, 58, 25
   CONTROL ADD BUTTON, hCal, %IDC_IncrMo, "Month  >", 160, 150, 58, 25
   CONTROL ADD BUTTON, hCal, %IDC_IncrYr, "Year  >>", 220, 150, 58, 25
   CONTROL ADD BUTTON, hCal, %IDC_Today, "Cancel", 320, 150, 80, 25
   DIALOG SET USER hCal, 1, VAL(sDate)
   DIALOG SHOW MODAL hCal CALL calendarProc
   IF theYr >= 2000 THEN n = theYr - 2000 ELSE n = theYr - 1900
   FUNCTION = FORMAT$(theMo, "00") + "-" + FORMAT$(theDay, "00") + "-" + FORMAT$(n, "00")
END FUNCTION

CALLBACK FUNCTION calendarProc
   LOCAL day, nDate AS LONG
   LOCAL s AS STRING, ps AS PAINTSTRUCT
   STATIC mo, yr AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         initialized = 0
         DIALOG GET USER CBHNDL, 1 TO nDate
         mo = VAL(LEFT$(DATE$, 2))
         yr = VAL(RIGHT$(DATE$, 4))
         today = VAL(MID$(DATE$, 4, 2))
         thisMo = mo: thisYr = yr
         theMo = 0: theDay = 0: theYr = yr
         xMouse = 0: yMouse = 0
         IF nDate THEN
            s = RIGHT$("0" + TRIM$(STR$(nDate)), 8)
            mo = VAL(LEFT$(s, 2))
            day = VAL(MID$(s, 3, 2))
            yr = VAL(RIGHT$(s, 4))
            theMo = mo: theDay = day: theYr = yr
         END IF
         DECR mo: IF mo = 0 THEN mo = 12: DECR yr
         CONTROL SEND CBHNDL, %IDC_Today, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
         CONTROL SET FOCUS CBHNDL, %IDC_Today
      CASE %WM_PAINT
         'refreshScrn
         BeginPaint hCal, ps
         IF NOT initialized THEN initCalendar
         showMonths mo, yr
         EndPaint hCal, ps
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDC_DecrYr
               DECR yr: InvalidateRect CBHNDL, BYVAL %NULL, 1
            CASE %IDC_DecrMo
               DECR mo: IF mo < 1 THEN mo = 12: DECR yr
               InvalidateRect CBHNDL, BYVAL %NULL, 1
            CASE %IDC_IncrMo
               INCR mo: IF mo > 12 THEN mo = 1: INCR yr
               InvalidateRect CBHNDL, BYVAL %NULL, 1
            CASE %IDC_IncrYr
               INCR yr: InvalidateRect CBHNDL, BYVAL %NULL, 1
            CASE %IDC_Today, %IDCANCEL
               IF thisMo = 1 THEN mo = 0: INCR yr
               IF mo = thisMo - 1 AND yr = thisYr THEN
                  DIALOG END CBHNDL
               ELSE
                  mo = thisMo - 1: yr = thisYr
                  IF mo = 0 THEN mo = 12: DECR yr
                  InvalidateRect CBHNDL, BYVAL %NULL, 1
               END IF
         END SELECT
      CASE %WM_LBUTTONDOWN
         xMouse = LOWRD(CBLPARAM): yMouse = HIWRD(CBLPARAM)
         InvalidateRect CBHNDL, BYVAL %NULL, 1
      CASE %WM_LBUTTONDBLCLK
         xMouse = LOWRD(CBLPARAM): yMouse = HIWRD(CBLPARAM)
         InvalidateRect CBHNDL, BYVAL %NULL, 1
         DIALOG END CBHNDL
   END SELECT
END FUNCTION

SUB initCalendar
   LOCAL hdc, hFont, hOrigFont, i, n AS LONG
   hdc = GetDC(hCal)
   hFont = makeFont(hDC, "MS Sans Serif", 10)
   hOrigFont = SelectObject(hdc, hFont)
   ti = "Sun  Mon  Tue  Wed  Thu  Fri  Sat"
   FOR i = 0 TO 2
      n = 220 * i
      SetTextColor hdc, %BLACK
      SetBkColor hdc, %WHITE
      showText hdc, 10 + n, 40, ti
      MoveToEx hDC, 10 + n, 60, BYVAL %NULL
      LineTo hDC, 210 + n, 60
      IF i < 2 THEN 'draw vert lines
         MoveToEx hDC, 220 + n, 20, BYVAL %NULL
         LineTo hDC, 220 + n, 220
      END IF
   NEXT i
   MoveToEx hDC, 10, 220, BYVAL %NULL
   LineTo hDC, 640, 220
   DeleteObject SelectObject(hdc, hOrigFont)
   ReleaseDC hCal, hdc
   initialized = -1
END SUB

SUB showMonths(BYVAL mo AS LONG, BYVAL yr AS LONG)
   LOCAL hdc, hFont, hFont1, hOrigFont, memdc, hBit AS LONG
   LOCAL i, j, m, n, startDay, days, k1, k2, x, y, moYrLen AS LONG
   LOCAL s, ss AS STRING, t AS SIZEL, sz AS ASCIIZ * 128
   DIM months(12) AS STRING
   months(1) = "January" : months(2) = "February" : months(3) = "March"
   months(4) = "April"   : months(5) = "May"      : months(6) = "June"
   months(7) = "July"    : months(8) = "August"   : months(9) = "September"
   months(10)= "October" : months(11)= "November" : months(12)= "December"
   hdc = GetDC(hCal)
   hBit = LoadBitmap(GetModuleHandle(BYVAL %NULL), "TodayBitMap")
   hFont = makeFont(hdc, "Courier New", 10)
   hFont1 = makeFont(hdc, "MS Sans Serif", 12)
   SelectObject hdc, hFont1
   sz = SPACE$(42): GetTextExtentPoint32 hdc, sz, LEN(sz), t
   moYrLen = t.cx: ss = "Today"
   FOR i = 0 TO 2
      SelectObject hdc, hFont1
      SetTextColor hdc, %WHITE
      SetBkColor hdc, RGB(128, 128, 255)
      s = months(mo) + STR$(yr): sz = s
      GetTextExtentPoint32 hdc, sz, LEN(sz), t
      showText hdc, 25 + 220*i, 10, SPACE$(42)
      showText hdc, INT((moYrLen - t.cx)/2) + 25 + 220*i, 10, s
      SelectObject hdc, hFont
      startDay = dayOfWeek(mo, yr, 1)
      days = daysInMonth(mo, yr)
      m = 1: n = startDay
      FOR j = 1 TO days
         s = RIGHT$(" " + STR$(j), 2): k1 = %BLACK: k2 = %WHITE
         x = 15 + 220*i + 29*n: y = 45 + 25*m
         SetTextColor hdc, k1: SetBkColor hdc, k2
         IF (xMouse > x AND xMouse < x + 29 AND yMouse > y AND yMouse < y + 25) THEN
            SetTextColor hdc, k2: SetBkColor hdc, k1
            theDay = j: theMo = mo: theYr = yr: xMouse = 0: yMouse = 0
         ELSEIF j = theDay AND mo = theMo AND yr = theYr AND xMouse = 0 THEN
            SetTextColor hdc, k2: SetBkColor hdc, k1
         END IF
         showText hDC, x, y, s
         IF j = today AND mo = thisMo AND yr = thisYr THEN
            memdc = CreateCompatibleDC(hdc)
            SelectObject memdc, hBit
            BitBlt hdc, x-3, y-3, 32, 32, memdc, 0, 0, %SRCAND
            DeleteDC memdc
            IF i = 1 THEN ss = "Cancel"
         END IF
         INCR n: IF n MOD 7 = 0 THEN INCR m: n = 0
      NEXT j
      INCR mo: IF mo > 12 THEN mo = 1: INCR yr
   NEXT i
   CONTROL SET TEXT hCal, %IDC_Today, ss
   DeleteObject hBit
   DeleteObject SelectObject(hdc, hOrigFont)
   ReleaseDC hCal, hdc
END SUB

FUNCTION daysInMonth(mo AS LONG, yr AS LONG) AS LONG
   LOCAL days AS INTEGER
   IF mo < 8 THEN
      days = 30 + mo MOD 2
   ELSE
      days = 30 + (mo + 1) MOD 2
   END IF
   IF mo = 2 THEN
      days = 28
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN INCR days 'leap yr
   END IF
   daysInMonth = days
END FUNCTION

FUNCTION dayOfWeek(mo AS LONG, yr AS LONG, day AS LONG) AS LONG
   'Sun=0, Mon=1, Tue=2,... Sat=6
   LOCAL n AS LONG
   n = yr - 1899 + (yr - 1901) \ 4
   IF mo < 8 THEN
      n = n + 30 * (mo - 1) + mo \ 2
   ELSE
      n = n + 30 * (mo - 1) + (mo + 1) \ 2
   END IF
   IF mo > 2 THEN
      n = n - 2
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN IF mo > 2 THEN INCR n 'leap yr
   END IF
   FUNCTION = (n + day - 1) MOD 7
END FUNCTION

SUB showText(hDC AS LONG, x AS LONG, y AS LONG, TXT AS STRING)
   TextOut hDC, x, y, BYVAL STRPTR(TXT), LEN(TXT)
END SUB

'-----------------------------------------------------------------------
'Routines for Reminders
'-----------------------------------------------------------------------
SUB showReminders()
   LOCAL nStyle AS LONG                             
   formWidth = 410: formHeight = 250
   DIALOG NEW hWin, "Reminders", -40, -5, formWidth, formHeight, %WS_SYSMENU TO hRemind
   nStyle=%WS_VSCROLL + %LBS_DISABLENOSCROLL + %WS_TABSTOP + %LBS_USETABSTOPS
   CONTROL ADD LISTBOX, hRemind, %ID_ListReminders, , 10, 20, 400, 175, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hRemind, %ID_Header, "   Date", 10, 10, 50, 10, %BS_LEFT
   CONTROL ADD BUTTON, hRemind, %ID_Header, "Day", 60, 10, 40, 10, %BS_CENTER
   CONTROL ADD BUTTON, hRemind, %ID_Header, "Time", 100, 10, 40, 10, %BS_CENTER
   CONTROL ADD BUTTON, hRemind, %ID_Header, "     Event",140, 10, 65, 10,  %BS_LEFT
   CONTROL ADD BUTTON, hRemind, %ID_Header, "     Description", 205, 10, 160, 10, %BS_LEFT
   CONTROL ADD BUTTON, hRemind, %ID_Header, "  Notify", 365, 10, 30, 10, %BS_LEFT
   CONTROL ADD BUTTON, hRemind, %ID_NewReminder, "&New", 10, 200, 40, 20
   CONTROL ADD BUTTON, hRemind, %ID_EditReminder, "&Edit", 50, 200, 40, 20
   CONTROL ADD BUTTON, hRemind, %ID_DelReminder, "&Delete", 90, 200, 40, 20
   CONTROL ADD BUTTON, hRemind, %ID_UnusedEvents, "&Unused", 150, 200, 40, 20
   CONTROL ADD BUTTON, hRemind, %ID_FindReminder, "&Find", 190, 200, 40, 20
   CONTROL ADD BUTTON, hRemind, %ID_Next, "&Next", 230, 200, 40, 20, %WS_DISABLED
   CONTROL ADD BUTTON, hRemind, %ID_Prev, "&Prev", 270, 200, 40, 20, %WS_DISABLED
   CONTROL ADD BUTTON, hRemind, %ID_PrnReminders, "&Print", 330, 200, 40, 20
   'CONTROL ADD BUTTON, hRemind, %IDCANCEL, "&Close", 330, 200, 40, 20, %BS_DEFAULT + %WS_TABSTOP
   DIALOG SHOW MODAL hRemind CALL showRemindersProc
END SUB

CALLBACK FUNCTION showRemindersProc
   LOCAL i, n, thisDate, fileNum AS LONG
   LOCAL s AS STRING, b AS BYTE
   STATIC nBegin, nStep, found, foundLast AS LONG
   STATIC sFind AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         nEvents(1) = "birthday"
         nEvents(2) = "anniversary"
         nEvents(3) = "appointment"
         numEvents = 3
         IF isfile(remindersFile) THEN
            s = REMOVE$(DATE$, "-")
            thisDate = VAL(RIGHT$(s, 4) + LEFT$(s, 4))
            fileNum = FREEFILE
            OPEN remindersFile FOR BINARY AS #fileNum
            s = LEFT$($version, 8)
            GET #fileNum,, s
            GET #fileNum,, numReminders
            GET #fileNum,, numEvents
            REDIM myReminders(numReminders + 20)
            FOR i = 1 TO numReminders
               GET #fileNum,, myReminders(i)
            NEXT i
            FOR i = 4 TO numEvents
               GET #fileNum, , b
               nEvents(i) = SPACE$(b)
               GET #fileNum,, nEvents(i)
            NEXT i
            CLOSE #fileNum
         ELSE
            s = "No reminder file found in this folder... create one now?"
            n = MSGBOX(s, %MB_ICONINFORMATION OR %MB_YESNO, "Open Reminder File")
            IF n = %IDNO THEN DIALOG END CBHNDL: EXIT FUNCTION
            numReminders = 0: saveReminders
         END IF
         reminderNo = 0: reminderHiLite = 1: listReminders
      CASE %WM_COMMAND
         SELECT CASE CBCTL
         CASE %ID_NewReminder
            reminderNo = 0: reminderForm
         CASE %ID_EditReminder
            CONTROL SEND hRemind, %ID_ListReminders, %LB_GETCURSEL, 0, 0 TO n
            INCR n: reminderNo = n: reminderForm
         CASE %ID_DelReminder
            n = MSGBOX("Delete this reminder?", %MB_YESNO + %MB_ICONWARNING, "Reminders")
            IF n = %IDYES THEN
               CONTROL SEND hRemind, %ID_ListReminders, %LB_GETCURSEL, 0, 0 TO n: INCR n
               DECR numReminders: reminderNo = 0: reminderHiLite = MIN(numReminders, n)
               ARRAY DELETE myReminders(n): savReminders = 1: listReminders
            END IF
         case %ID_UnusedEvents
            unusedEvents()
         CASE %ID_FindReminder
            sFind = LCASE$(myInput(CB.HNDL, "Find what:  ", "", sFind))
            IF LEN(sFind) THEN
               CONTROL enable CB.HNDL, %ID_Next
               CONTROL enable CB.HNDL, %ID_Prev
               nBegin = 0: nStep = 1: DIALOG SEND CBHNDL, %WM_COMMAND, %ID_Search, 0
            END IF
         CASE %ID_Next
            nStep = 1: DIALOG SEND CBHNDL, %WM_COMMAND, %ID_Search, 0
         CASE %ID_Prev
            nStep = -1: DIALOG SEND CBHNDL, %WM_COMMAND, %ID_Search, 0
         CASE %ID_Search
            found = 0
            DO UNTIL nBegin + nStep < 1 OR nBegin + nStep > numReminders
               i = nBegin + nStep: nBegin = i: b = myReminders(i).nEvent
               IF INSTR(LCASE$(nEvents(b)), sFind) THEN found = i: EXIT DO
               IF INSTR(LCASE$(myReminders(i).descr), sFind) THEN found = i: EXIT DO
            LOOP
            IF found THEN
               CONTROL SEND CBHNDL, %ID_ListReminders, %LB_SETCURSEL, found - 1, 0
               foundLast = found
            ELSE
               MSGBOX "None found", , ""
               IF nStep > 0 THEN n = 0 ELSE n = 1
               nBegin = foundLast + n
            END IF
         CASE %ID_PrnReminders
            printReminders
            CONTROL SET FOCUS hRemind, %ID_ListReminders
         CASE %IDCANCEL, %IDOK
            DIALOG SEND hRemind, %WM_SYSCOMMAND, %SC_CLOSE, 0
         END SELECT
         CONTROL SEND hRemind, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_CLOSE THEN
            IF savReminders THEN
               s = "Closing reminders..." + $CRLF + "Do you want to save the changes?"
               n = MSGBOX(s, %MB_YESNOCANCEL + %MB_ICONWARNING, "Closing Reminders")
               IF n = %IDYES THEN
                  saveReminders
               elseif n = %IDCANCEL THEN
                  FUNCTION = 1: EXIT FUNCTION
               end if
            END IF
            savReminders = 0: remindMode = 0
            DIALOG END hRemind
         END IF
   END SELECT
END FUNCTION

SUB saveReminders
   LOCAL fileNum, i AS LONG
   LOCAL s AS STRING
   local b AS BYTE
   fileNum = FREEFILE
   OPEN remindersFile FOR BINARY AS fileNum
   s = LEFT$($version, 8)
   PUT #fileNum,, s
   PUT #fileNum,, numReminders
   PUT #fileNum,, numEvents
   FOR i = 1 TO numReminders
      PUT #fileNum,, myReminders(i)
   NEXT i
   FOR i = 4 TO numEvents 'first 3 are fixed
      b = LEN(nEvents(i))
      PUT fileNum, , b
      PUT #fileNum,, nEvents(i)
   NEXT i
   CLOSE #fileNum
   'copy changed reminders file to dataFolder (ver 3.19)
   if pathname$(path, remindersFile) <> dataFolder then
      filecopy remindersFile, dataFolder + $RemindFile
   end if
END SUB

sub unusedEvents()
   local nStyle, hUnused as long
   nStyle=%WS_VSCROLL + %WS_TABSTOP
   DIALOG NEW hWin, "Unused Events", 20, 20, 135, 175, %WS_SYSMENU TO hUnused
   CONTROL ADD LISTBOX, hUnused, %ID_ListUnused, , 10, 10, 110, 115, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hUnused, %ID_DelEventBtn, "&Delete event", 40, 125, 70, 20
   DIALOG SHOW MODAL hUnused CALL unusedProc()
end sub

callback function unusedProc()
   local i, j, k, n as long
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         listbox reset CB.HNDL, %ID_ListUnused 
         for i = 1 to numEvents
            n = 0
            for j = 1 to numReminders
               if i = myReminders(j).nEvent then n = 1: exit for
            next j
            if n = 0 then
               incr k
               listbox add CB.HNDL, %ID_ListUnused, nEvents(i)
               listbox set user CB.HNDL, %ID_ListUnused, k, i 
            end if
         next i
         listbox select CB.HNDL, %ID_ListUnused, 1
      case %WM_COMMAND
         SELECT CASE CBCTL
            CASE %ID_DelEventBtn
               listbox get count CB.HNDL, %ID_ListUnused to n
               if n then
                  listbox get select CB.HNDL, %ID_ListUnused to k
                  listbox get user CB.HNDL, %ID_ListUnused, k to i
                  listbox delete CB.HNDL, %ID_ListUnused, k
                  listbox select CB.HNDL, %ID_ListUnused, k
                  ARRAY DELETE nEvents(j): DECR numEvents
                  FOR i = 1 TO numReminders
                     IF myReminders(i).nEvent > j THEN DECR myReminders(i).nEvent
                  NEXT i
                  savReminders = 1
               end if
         end select
   end select
end function

SUB reminderForm
   LOCAL s AS STRING, k AS LONG
   IF reminderNo THEN s = "Edit" ELSE s = "Add new"
   s = s + " Reminder"
   DIALOG NEW hRemind, s, 7, 5, 220, 190, %WS_SYSMENU TO hRemindForm
   k = %WS_TABSTOP OR %CBS_DROPDOWN OR %WS_VSCROLL OR %CBS_DISABLENOSCROLL
   CONTROL ADD LABEL, hRemindForm, -1, "Event", 5, 7, 22, 10, %SS_RIGHT
   CONTROL ADD COMBOBOX, hRemindForm, %ID_Event, nEvents(), 30, 5, 70, 60, k
   CONTROL ADD LABEL, hRemindForm, -1, "Descr", 5, 27, 22, 10, %SS_RIGHT
   CONTROL ADD TEXTBOX, hRemindForm, %ID_Descr, "", 30, 25, 155, 13
   CONTROL ADD LABEL, hRemindForm, -1, "Date", 2, 47, 25, 10, %SS_RIGHT
   CONTROL ADD TEXTBOX, hRemindForm, %ID_Date, "", 30, 45, 35, 13
   CONTROL ADD IMGBUTTONX, hRemindForm, %ID_Calendar, "calendar", 67, 43, 15, 15
   CONTROL ADD LABEL, hRemindForm, %ID_YearOf, "", 86, 47, 62, 10, %SS_RIGHT
   CONTROL ADD TEXTBOX, hRemindForm, %ID_Year, "", 150, 45, 35, 13
   CONTROL ADD LABEL, hRemindForm, -1, "Notify", 5, 67, 22, 10, %SS_RIGHT
   CONTROL ADD TEXTBOX, hRemindForm, %ID_Notify, "", 30, 65, 18, 13
   CONTROL ADD LABEL, hRemindForm, -1, "days before", 50, 67, 60, 10, %SS_LEFT
   CONTROL ADD TEXTBOX, hRemindForm, %ID_Period, "", 165, 65, 15, 13
   CONTROL ADD LABEL, hRemindForm, %ID_NumOf, "", 114, 67, 48, 10, %SS_RIGHT
   CONTROL ADD OPTION, hRemindForm, %ID_Annual, "Annual", 10, 100, 40, 10, %WS_GROUP
   CONTROL ADD OPTION, hRemindForm, %ID_OneTime, "One time", 10, 110, 40, 10
   CONTROL ADD OPTION, hRemindForm, %ID_ByWeekday, "Monthly weekday", 10, 120, 80, 10
   CONTROL ADD OPTION, hRemindForm, %ID_Monthly, "Monthly period", 10, 130, 80, 10
   CONTROL ADD OPTION, hRemindForm, %ID_Weekly, "Weekly period", 10, 140, 80, 10
   CONTROL ADD OPTION, hRemindForm, %ID_Daily, "Daily period", 10, 150, 80, 10
   CONTROL ADD FRAME, hRemindForm, -1, "Event frequency", 5, 90, 100, 76, %WS_GROUP
   IF reminderNo THEN s = "&Replace" ELSE s = "&Add"
   CONTROL ADD BUTTON, hRemindForm, %ID_Add, s, 130, 90, 50, 25
   CONTROL ADD BUTTON, hRemindForm, %IDCANCEL, "&Cancel", 130, 120, 50, 25
   DIALOG SHOW MODAL hRemindForm CALL reminderFormProc
END SUB

CALLBACK FUNCTION reminderFormProc
   LOCAL k, m AS QUAD, remind AS reminderType
   LOCAL i, n, yr, mo, day, thisDay, thisMonth, hdc AS LONG
   LOCAL s, s1, s2, s3, s4, s5 AS STRING, TXT AS ASCIIZ * 32
   STATIC nEvent AS LONG, nOpt AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         IF reminderNo THEN 'edit reminder
            nEvent = myReminders(reminderNo).nEvent
            CONTROL SET TEXT hRemindForm, %ID_Event, nEvents(nEvent)
            CONTROL SET TEXT hRemindForm, %ID_Descr, TRIM$(myReminders(reminderNo).descr)
            n = myReminders(reminderNo).date: s = TRIM$(STR$(n))
            s = MID$(s, 5, 2) + "-" + RIGHT$(s, 2) + "-" + MID$(s, 3, 2)
            CONTROL SET TEXT hRemindForm, %ID_Date, s
            nOpt = myReminders(reminderNo).annual: showPeriod(nOpt)
            CONTROL SET CHECK hRemindForm, %ID_Annual - 1 + nOpt, 1
            CONTROL SET TEXT hRemindForm, %ID_Date, s
            n = myReminders(reminderNo).time
            IF nEvent <= 3 THEN
               IF nEvent = 1 THEN s = "Year of birth"
               IF nEvent = 2 THEN s = "Year of marriage"
               IF nEvent = 3 THEN s = "Appointment time"
               CONTROL SET TEXT CBHNDL, %ID_YearOf, s
            ELSE
               CONTROL SET TEXT CBHNDL, %ID_YearOf, "Time"
            END IF
            IF n THEN
               IF nEvent >= 3 THEN 'appointment time
                  IF n >= 1200 THEN s = " pm" ELSE s = " am"
                  IF n >= 1300 THEN
                     n = n - 1200
                  ELSEIF n < 100 THEN
                     n = 1200 + n
                  END IF
                  s4 = TRIM$(STR$(n\100)) + ":" + RIGHT$(TRIM$(STR$(n)), 2) + s
               ELSE
                  s4 = TRIM$(STR$(n))
               END IF
               CONTROL SET TEXT CBHNDL, %ID_Year, s4
            END IF
            n = myReminders(reminderNo).Adv
            CONTROL SET TEXT CBHNDL, %ID_Notify, TRIM$(STR$(n))
            n = myReminders(reminderNo).period
            CONTROL SET TEXT CBHNDL, %ID_Period, TRIM$(STR$(n))
            CONTROL SET FOCUS CBHNDL, %ID_Event
         ELSE 'new reminder
            CONTROL SHOW STATE CBHNDL, %ID_Period, %SW_HIDE
         END IF
      CASE %WM_COMMAND
         IF CBCTL = %ID_Calendar THEN
            CONTROL GET TEXT hRemindForm, %ID_Date TO s
            IF LEN(s) THEN
               IF invalidDate(s) THEN CONTROL SET TEXT hRemindForm, %ID_Date, "": EXIT FUNCTION
               day = VAL(PARSE$(s, "-", 2)): mo = VAL(PARSE$(s, "-", 1))
               thisDay = VAL(PARSE$(DATE$, "-", 2)): thisMonth = VAL(PARSE$(DATE$, "-", 1))
               yr = VAL(PARSE$(DATE$, "-", 3))
               IF mo < thisMonth OR (day < thisDay AND mo <= thisMonth) THEN INCR yr
               IF mo > 12 THEN mo = 1: INCR yr
            END IF
            s = FORMAT$(mo, "00") + FORMAT$(day, "00") + FORMAT$(yr, "0000")
            IF mo = 0 AND day = 0 THEN s = ""
            s = calendar(s)
            IF LEFT$(s, 5) = "00-00" THEN s = ""
            CONTROL SET TEXT CBHNDL, %ID_Date, s
            CONTROL SET FOCUS CBHNDL, %ID_Date
         ELSEIF CBCTL = %ID_Add THEN
            CONTROL GET TEXT CBHNDL, %ID_Event TO s
            CONTROL GET TEXT CBHNDL, %ID_Descr TO s1
            CONTROL GET TEXT CBHNDL, %ID_Date TO s2
            CONTROL GET TEXT CBHNDL, %ID_Notify TO s3
            CONTROL GET TEXT CBHNDL, %ID_Year TO s4
            CONTROL GET TEXT CBHNDL, %ID_Period TO s5
            FOR i = 1 TO 6
               CONTROL GET CHECK CBHNDL, %ID_Annual + i - 1 TO n
               IF n THEN nOpt = i: EXIT FOR
            NEXT i
            IF LEN(s) = 0 OR LEN(s2) = 0 OR LEN(s3) = 0 OR n = 0 THEN
               MSGBOX "Must fill all fields and specify event frequency", _
                      %MB_OK + %MB_ICONINFORMATION, "Reminder Form"
               EXIT FUNCTION
            END IF
            n = invalidDate(s2)
            IF n THEN
               IF n = 1 THEN
                  s = "use form mm-dd-yy with 2 digit yr"
               ELSEIF n = 2 THEN
                  s = "day or month out of range"
               END IF
               s = "invalid date - " + s + "   "
               MSGBOX s, %MB_OK + %MB_ICONINFORMATION, "ReminderForm"
               CONTROL SET FOCUS CBHNDL, %ID_Date: EXIT FUNCTION
            END IF
            IF VAL(s3) > 255 THEN
               MSGBOX "Maximum of 255 days", %MB_OK + %MB_ICONERROR, "Reminder Form"
               CONTROL SET FOCUS CBHNDL, %ID_Notify: EXIT FUNCTION
            END IF
            IF VAL(s5) = 0 THEN s5 = "1"
            TXT = s: n = VARPTR(TXT)
            CONTROL SEND CBHNDL, %ID_Event, %CB_FINDSTRINGEXACT, 0, n TO nEvent
            INCR nEvent
            IF nEvent = 0 THEN 'new event
               INCR numEvents: nEvent = numEvents: nEvents(nEvent) = s
               COMBOBOX ADD CBHNDL, %ID_Event, s
            END IF
            IF nEvent >= 3 AND LEN(s4) THEN 'store appt time as military time
               IF INSTR(s4, ":") = 0 THEN
                  IF VAL(s4) > 12 THEN
                     MSGBOX "Bad time format", %MB_OK + %MB_ICONERROR, "Reminder Form"
                     CONTROL SET FOCUS CBHNDL, %ID_Year: EXIT FUNCTION
                  END IF
                  s = s4: n = VAL(s) * 100
               ELSE
                  s = LCASE$(REMOVE$(s4, ":")): n = VAL(s)
               END IF
               IF RIGHT$(s, 1) = "p" OR RIGHT$(s, 2) = "pm" THEN
                  IF n < 1200 THEN n = n + 1200
               ELSE
                  IF n >= 1200 THEN n = MAX(n - 1200, 1)
               END IF
               s4 = TRIM$(STR$(n))
            END IF
            remind.nEvent = nEvent
            remind.descr = s1
            yr = VAL(RIGHT$(s2, 2)) + 2000: mo = VAL(LEFT$(s2, 2))
            day = VAL(MID$(s2, 4, 2))
            remind.date = newDate(yr, mo, day)
            remind.time = VAL(s4)
            remind.period = VAL(s5)
            remind.annual = nOpt
            remind.adv = CBYT(VAL(s3))
            IF reminderNo THEN 'edited reminder... delete it now
               ARRAY DELETE myReminders(reminderNo): DECR numReminders
            END IF
            n = 0
            IF remind.nEvent > 2 THEN k = remind.time
            k = remind.date * 10000 + k
            FOR i = 1 TO numReminders 'find insert position
               IF myReminders(i).nEvent > 2 THEN m = myReminders(i).time ELSE m = 0
               m = myReminders(i).date * 10000 + m: IF m > k THEN n = i: EXIT FOR
            NEXT i
            IF numReminders >= UBOUND(myReminders) THEN
               REDIM PRESERVE myReminders(numReminders + 20)
            END IF
            INCR numReminders: IF n = 0 THEN n = numReminders
            ARRAY INSERT myReminders(n) FOR numReminders - n + 1, remind
            DIALOG END CBHNDL
            reminderNo = n
            savReminders = 1
            listReminders
            CONTROL SET FOCUS hRemind, %ID_ListReminders
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END hCal
            DIALOG END CBHNDL
         ELSEIF CBCTL = %ID_Event THEN
            IF CBCTLMSG = %CBN_SELENDOK THEN
               IF CBCTLMSG = %CBN_SELENDOK THEN
                  CONTROL SEND CBHNDL, %ID_Event, %CB_GETCURSEL, 0, 0 TO nEvent
               ELSE
                  CONTROL GET TEXT CBHNDL, %ID_Event TO s
                  TXT = s: n = VARPTR(TXT)
                  CONTROL SEND CBHNDL, %ID_Event, %CB_FINDSTRINGEXACT, 0, n TO nEvent
               END IF
               INCR nEvent
               IF nEvent AND nEvent <= 3 THEN
                  FOR i = 0 TO 4
                     CONTROL SET CHECK CBHNDL, %ID_Annual + i, 0
                  NEXT i
                  IF nEvent < 3 THEN nOpt = 1
                  IF nEvent = 3 AND reminderNo = 0 THEN nOpt = 2
                  CONTROL SET CHECK CBHNDL, %ID_Annual + nOpt - 1, 1
                  IF nEvent = 1 THEN s = "Year of birth"
                  IF nEvent = 2 THEN s = "Year of marriage"
                  IF nEvent = 3 THEN s = "Appointment time"
                  CONTROL SET TEXT CBHNDL, %ID_YearOf, s
                  showPeriod nOpt
               ELSE
                  CONTROL SET TEXT CBHNDL, %ID_YearOf, "Time"
               END IF
               CONTROL SET FOCUS CBHNDL, %ID_Descr
            END IF
         ELSEIF CBCTL = %ID_Descr AND CBCTLMSG = %EN_CHANGE THEN
            hdc = GetDC(CBHNDL)
            CONTROL GET TEXT CBHNDL, %ID_Descr TO s
            IF stringSize(hDC, s) > 300 THEN
               CONTROL SET TEXT CBHNDL, %ID_Descr, truncateStr(hdc, s, 300)
               CONTROL SEND CBHNDL, %ID_Descr, %EM_SETSEL, -LEN(s), LEN(s)
            END IF
         ELSEIF CBCTL = %ID_Date AND CBCTLMSG = %EN_CHANGE THEN
            FOR i = %ID_Annual TO %ID_Daily
               CONTROL GET CHECK CBHNDL, i TO n
               IF n THEN n = i - %ID_Annual + 1: EXIT FOR
            NEXT i
            IF n = 0 THEN EXIT FUNCTION
            IF n = 3 THEN showPeriod 3
            IF n < 3 THEN showPeriod n
         ELSEIF CBCTL >= %ID_Annual THEN
            IF nEvent = 1 OR nEvent = 2 THEN
               CONTROL SET OPTION CBHNDL, %ID_Annual, %ID_Annual, %ID_Daily
            ELSEIF nEvent > 3 THEN
               CONTROL SET TEXT CBHNDL, %ID_YearOf, "Time"
            END IF
            nOpt = CBCTL - %ID_Annual + 1: showPeriod nOpt
         END IF
   END SELECT
END FUNCTION

SUB showPeriod(nOpt AS LONG)
   'Show monthly day such as "Third monday"
   '     or define monthly, weekly, or daily period
   LOCAL s, s1, nth, daysOfTheWeek AS STRING
   LOCAL day, mo, yr, thisDay, thisMonth, n AS LONG
   daysOfTheWeek = "Sunday Monday Tuesday Wednesday Thursday Friday Saturday"
   CONTROL GET TEXT hRemindForm, %ID_Date TO s
   IF invalidDate(s) THEN EXIT SUB
   day = VAL(PARSE$(s, "-", 2)): mo = VAL(PARSE$(s, "-", 1))
   thisDay = VAL(PARSE$(DATE$, "-", 2)): thisMonth = VAL(PARSE$(DATE$, "-", 1))
   yr = VAL(PARSE$(DATE$, "-", 3))
   IF mo < thisMonth OR (day < thisDay AND mo <= thisMonth) THEN INCR yr
   IF mo > 12 THEN mo = 1: INCR yr
   IF nOpt = 3 THEN
      nth = "1st 2nd 3rd 4th"
      CONTROL SHOW STATE hRemindForm, %ID_Period, %SW_HIDE
      n = dayOfWeek(mo, yr, day)
      s = PARSE$(daysOfTheWeek, " ", n + 1)
      n = day \ 7 + SGN(day MOD 7): s1 = PARSE$(nth, " ", n)
      s = s1 + " " + s
   ELSEIF nOpt > 3 THEN
      CONTROL SHOW STATE hRemindForm, %ID_Period, %SW_RESTORE
      IF nOpt = 4 THEN s = "No of months"
      IF nOpt = 5 THEN s = "No of weeks"
      IF nOpt = 6 THEN s = "No of days"
   ELSE
      CONTROL SET TEXT hRemindForm, %ID_NumOf, ""
      CONTROL SHOW STATE hRemindForm, %ID_Period, %SW_HIDE
      n = dayOfWeek(mo, yr, day)
      s = PARSE$(daysOfTheWeek, " ", n + 1)
   END IF
   CONTROL SET TEXT hRemindForm, %ID_NumOf, s
END SUB

FUNCTION invalidDate(s AS STRING) AS LONG
   'valid date: 10-13-04
   LOCAL s1, s2, s3, t AS STRING
   LOCAL n1, n2, n3, invalid AS LONG
   invalid = 0
   REPLACE "/" WITH "-" IN s
   s1 = PARSE$(s, "-", 1): n1 = VAL(s1)
   s2 = PARSE$(s, "-", 2): n2 = VAL(s2)
   s3 = PARSE$(s, "-", 3): n3 = VAL(s3)
   s = RIGHT$("0" + s1, 2) + "-" + RIGHT$("0" + s2, 2)
   IF n3 = 0 THEN
      n3 = VAL(RIGHT$(DATE$, 2))
      IF LEFT$(s, 5) < LEFT$(DATE$, 5) THEN INCR n3
   END IF
   t = TRIM$(STR$(2000 + n3)) + LEFT$(s, 5)
   IF n1 = 0 OR n2 = 0 OR n3 > 99 THEN
      invalid = 1
   ELSEIF n1 > 12 OR n2 > daysInMonth(n1, 2003 + n3) THEN
      invalid = 2
   ELSE
      s = s + "-" + RIGHT$("0" + TRIM$(STR$(n3)), 2)
   END IF
   invalidDate = invalid
END FUNCTION

SUB listReminders
   LOCAL i, j, m, n, mo, year, day, start, update AS LONG
   LOCAL s, ss, t, weekDay, daysInWeek AS STRING
   LOCAL TXT AS ASCIIZ * 100
   daysInWeek = "Sun Mon Tue Wed Thu Fri Sat"
   DIM lptr AS LONG PTR
   DIM tabstops(5) AS LONG
   tabstops(0) = 0     'date
   tabstops(1) = 60    'day of week
   tabstops(2) = -120  'time
   tabstops(3) = 134   'event
   tabstops(4) = 200   'descr
   tabstops(5) = -375  'notify
   lptr=VARPTR(tabstops(0))
   CONTROL SEND hRemind, %ID_ListReminders, %LB_SETTABSTOPS, 6, lptr
   LISTBOX RESET hRemind, %ID_ListReminders
   IF reminderNo THEN reminderHiLite = reminderNo
   today = VAL(RIGHT$(DATE$, 4) + LEFT$(DATE$, 2) + MID$(DATE$, 4, 2))
   IF numReminders THEN
      DO 'update reminders that are past due
         update = 0: n = myReminders(1).date - today
         IF n < 0 THEN updateReminder 1: update = 1
      LOOP UNTIL update = 0
   END IF
   today = today MOD 10000: start = -1
   FOR i = 1 TO numReminders 'find where to begin displaying list
      n = myReminders(i).date MOD 10000
      IF n >= today THEN start = i: EXIT FOR
   NEXT i
   IF start = -1 THEN start = 1
   FOR i = 1 TO numReminders
      j = start + i - 1
      IF j > numReminders THEN j = j - numReminders
      n = myReminders(j).date: m = 0: s = TRIM$(STR$(n)): t = ""
      mo = VAL(MID$(s, 5, 2)): day = VAL(RIGHT$(s, 2)): year = VAL(LEFT$(s, 4))
      'n = dayOfWeek(mo, year, day)
      weekDay = MID$(daysInWeek, 4 * dayOfWeek(mo, year, day)+1, 3)
      IF myReminders(j).nEvent > 2 THEN m = myReminders(j).time
      IF m >= 1200 THEN ss = " pm" ELSE ss = " am"
      IF m >= 1300 THEN
         m = m - 1200
      ELSEIF m AND m < 100 THEN
         m = 1200 + m
      END IF
      IF m THEN t = FORMAT$(m\100, "##") + ":" + FORMAT$(m MOD 100, "00") + ss
      s = MID$(s, 5, 2) + "/" + RIGHT$(s, 2) + "/" + LEFT$(s, 4)
      s = s + $TAB + weekDay
      s = s + $TAB + t
      s = s + $TAB + TRIM$(nEvents(myReminders(j).nEvent))
      s = s + $TAB + truncateStr(hDispDC, TRIM$(myReminders(j).descr), 300)
      TXT = s + $TAB + STR$(myReminders(j).adv)
      CONTROL SEND hRemind, %ID_ListReminders, %LB_ADDSTRING, 0, VARPTR(TXT) TO n
      INCR n: IF n = reminderNo THEN reminderHiLite = n
   NEXT i
   LISTBOX SELECT hRemind, %ID_ListReminders, reminderHiLite
END SUB

SUB updateReminder(j AS LONG)
   'revise the date of reminder j
   LOCAL i, n, n0, nth, day, mo, yr AS LONG, k, m AS QUAD
   LOCAL s AS STRING, remind AS reminderType
   s = TRIM$(STR$(myReminders(j).Date))
   yr = VAL(LEFT$(s, 4)): mo = VAL(MID$(s, 5, 2)): day = VAL(RIGHT$(s, 2))
   today = VAL(RIGHT$(DATE$, 4) + LEFT$(DATE$, 2) + MID$(DATE$, 4, 2))
   k = myReminders(j).annual
   IF k = 1 THEN 'anual
      'update annual reminder to next year
      WHILE newDate(yr, mo, day) < today: INCR yr: WEND
   ELSEIF k = 2 THEN 'one time only
      ARRAY DELETE myReminders(j): DECR numReminders: EXIT SUB
   ELSEIF k = 3 THEN
      'update monthly reminder to same weekday of next month
      n = dayOfWeek(mo, yr, day)
      nth = day \ 7 + SGN(day MOD 7)
      WHILE newDate(yr, mo, day) < today
         INCR mo: IF mo > 12 THEN mo = 1: INCR yr
         m = dayOfWeek(mo, yr, 1)
         day = n - m + 1 + (nth - 1) * 7
         IF n < m THEN day = day + 7
      WEND
   ELSEIF k = 4 THEN
      'update monthly reminder by monthly period
      n = myReminders(j).period
      WHILE newDate(yr, mo, day) < today
         mo = mo + n: IF mo > 12 THEN mo = 1: INCR yr
      WEND
   ELSE
      'update weekly or daily reminder by period
      n0 = myReminders(j).period
      IF k = 5 THEN n0 = 7 * n0
      WHILE newDate(yr, mo, day) < today
         n = n0
         m = daysInMonth(mo, yr) - day
         IF m >= n THEN
            day = day + n
         ELSE
            WHILE n > m
               INCR mo: IF mo > 12 THEN mo = 1: INCR yr
               n = n - m: m = daysInMonth(mo, yr)
            WEND: day = n
         END IF
      WEND
   END IF
   s = RIGHT$("0" + TRIM$(STR$(mo)), 2) + RIGHT$("0" + TRIM$(STR$(day)), 2)
   myReminders(j).date = VAL(TRIM$(STR$(yr)) + s)
   remind = myReminders(j)
   ARRAY DELETE myReminders(j)
   n = numReminders
   IF remind.nEvent > 2 THEN k = remind.time
   k = remind.date*10000 + k
   FOR i = 1 TO numReminders 'find insert position
      IF myReminders(i).nEvent > 2 THEN m = myReminders(i).time ELSE m = 0
      m = myReminders(i).date * 10000 + m: IF m > k THEN n = i: EXIT FOR
   NEXT i
   ARRAY INSERT myReminders(n) FOR numReminders - n + 1, remind
END SUB

FUNCTION newDate(yr AS LONG, mo AS LONG, day AS LONG) AS LONG
   FUNCTION = yr * 10000 + mo * 100 + day
END FUNCTION

SUB printReminders
   LOCAL m, n, i, y, x0, y0, nCount, linesPerPg, hPrn, prnEvent AS LONG
   LOCAL hPrnDC, hFont, hOrigFont, fontHt, xdpi, ydpi, leftDeadZone, topDeadZone AS LONG
   LOCAL beginNewPage, prnError AS BYTE, charHt, leftMargin AS DOUBLE
   LOCAL s, ss, t AS STRING, tm AS TEXTMETRIC, di AS DOCINFO

   DIALOG NEW hRemind,"Print Reminders",,, 190, 100, %WS_SYSMENU TO hPrn
   CONTROL ADD BUTTON, hPrn, %ID_PrnAll, "", 10, 20, 10, 10, %WS_TABSTOP 'OR %BS_FLAT
   CONTROL ADD LABEL, hPrn, %ID_PrnAll, "Print all reminders", 25, 20, 160, 12, %SS_NOTIFY
   CONTROL ADD BUTTON, hPrn, %ID_PrnEvents, "", 10, 40, 10, 10, %WS_TABSTOP 'OR %BS_FLAT
   CONTROL ADD LABEL, hPrn, %ID_PrnEvents, "Print reminders for this event only", 25, 40, 160, 12, %SS_NOTIFY
   DIALOG SHOW MODAL hPrn, CALL printRemindersProc TO n

   IF n = 0 THEN EXIT SUB ELSE prnEvent = n - 1
   IF prnEvent THEN
      CONTROL SEND hRemind, %ID_ListReminders, %LB_GETCURSEL, 0, 0 TO n
      prnEvent = myReminders(n + 1).nEvent
   END IF
   hPrnDC = choosePrinter(0)
   IF hPrnDC = 0 THEN EXIT SUB
   s = "winPam Print"
   di.cbSize = SIZEOF(di)
   di.lpszDocName = VARPTR(s)
   fontHt = 11
   hFont = makeFont(hPrnDC, fontType, fontHt)
   hOrigFont = SelectObject (hPrnDC, hFont)
   getTextMetrics hPrnDC, tm
   charHt = tm.tmHeight + tm.tmExternalLeading
   xdpi = GetDeviceCaps (hPrnDC, %LOGPIXELSX) 'x direction dpi
   ydpi = GetDeviceCaps (hPrnDC, %LOGPIXELSY) 'y direction dpi
   leftDeadZone = GetDeviceCaps (hPrnDC, %PHYSICALOFFSETX)   'dead zone at left
   topDeadZone = GetDeviceCaps (hPrnDC, %PHYSICALOFFSETY)    'dead zone on top
   linesPerPg = 9.75*ydpi\charHt: leftMargin = 0.75
   x0 = leftMargin * xdpi - leftDeadZone
   y0 = .500 * ydpi - topDeadZone
   IF StartDoc(hPrnDC, di) <= 0 THEN prnError = 2: GOTO WrapUp
   beginNewPage = 1
   FOR i = 1 TO numReminders
      IF prnEvent AND myReminders(i).nEvent <> prnEvent THEN ITERATE
      IF beginNewPage THEN
         nCount = 0: beginNewPage = 0
         IF StartPage(hPrnDC) <= 0 THEN prnError = 3: GOTO WrapUp
         printText hPrnDC, "Date", x0 + .12*xdpi, y0
         printText hPrnDC, "Time", x0 + 1.20*xdpi, y0
         printText hPrnDC, "Event", x0 + 2.20*xdpi, y0
         printText hPrnDC, "Description", x0 + 4.00*xdpi, y0
         printText hPrnDC, "Notify", x0 + 6.75*xdpi, y0
      END IF
      y = y0 + charHt * (nCount + 2)
      s = TRIM$(STR$(myReminders(i).date))
      s = MID$(s, 5, 2) + "/" + RIGHT$(s, 2) + "/" + LEFT$(s, 4)
      printText hPrnDC, s, x0, y 'date
      n = myReminders(i).date: m = 0: t = ""
      IF myReminders(i).nEvent > 2 THEN m = myReminders(i).time
      IF m >= 1200 THEN ss = " pm" ELSE ss = " am"
      IF m >= 1300 THEN
         m = m - 1200
      ELSEIF m AND m <= 100 THEN
         m = 1200 + m
      END IF
      IF m THEN t = FORMAT$(m\100, "##") + ":" + FORMAT$(m MOD 100, "00") + ss
      printText hPrnDC, t, x0 + 1.70*xdpi - stringSize(hPrnDC, t), y 'time
      printText hPrnDC, nEvents(myReminders(i).nEvent), x0 + 2.00*xdpi, y 'event
      s = myReminders(i).descr
      printText hPrnDC, truncateStr(hPrnDC, s, 3.05*xdpi), x0 + 3.50*xdpi, y 'descr
      s = STR$(myReminders(i).adv)
      printText hPrnDC, s, x0 + 7.00*xdpi - stringSize(hPrnDC, s), y 'notify
      INCR nCount
      IF nCount > linesPerPg THEN
         EndPage hPrnDC: beginNewPage = 1
      END IF
   NEXT i
   EndPage hPrnDC
   EndDoc hPrnDC
WrapUp:
   IF prnError THEN
      s = "Printing error has occurred"
      MSGBOX s, %MB_ICONERROR, "Printing Error" + STR$(prnError)
   END IF
   SelectObject hPrnDC, hOrigFont
   DeleteObject hFont
   DeleteDC hPrnDC
END SUB

CALLBACK FUNCTION printRemindersProc()
   SELECT CASE CBMSG
   CASE %WM_COMMAND
      IF CBCTLMSG = %BN_CLICKED THEN
         IF CBCTL = %ID_PrnAll THEN DIALOG END CBHNDL, 1
         IF CBCTL = %ID_PrnEvents THEN DIALOG END CBHNDL, 2
      END IF
   END SELECT
END FUNCTION

'-----------------------------------------------------------------------
'Importing & Exporting data
'-----------------------------------------------------------------------
SUB portData
   LOCAL s, sPath, f AS STRING
   LOCAL i, n, yLine, nStyle AS LONG
   DATA "Last name", "First name", "Home phone", "Bus phone", "Cell phone", "Fax phone"
   DATA "E-mail address", "Street address", "City", "Postal zip", "State", "Country"
   IF portOpt THEN
      ti = "Im": sPath = dataFolder: f = ""
      n = %OFN_LONGNAMES + %OFN_FILEMUSTEXIST
      OpenFileDialog BYVAL hWin, BYVAL "Open Import File", f, BYVAL sPath,_
         BYVAL "Comma separated values (*.csv)|*.csv|All Files (*.*)|*.*", BYVAL "*.csv", n
      importFln = f
   ELSE
      ti = "Ex": sPath = dataFolder: f = ""
      n = n OR %OFN_LONGNAMES OR %OFN_OVERWRITEPROMPT
      SaveFileDialog(BYVAL hWin, BYVAL "Save Export File", f, BYVAL sPath,_
         BYVAL "Comma separated values (*.csv)|*.csv|All Files (*.*)|*.*", "csv", n)
      exportFln = f
   END IF
   IF LEN(f) = 0 THEN EXIT SUB ELSE importFln = f
   ti = ti + "ported Data"
   DIALOG NEW hWin, ti, , , 140, 270, %WS_SYSMENU TO hImport
   s = "Comma separated values" + $CRLF + "Define sequence of "
   s = s + ti +"..."
   CONTROL ADD LABEL, hImport, -1, s, 5, 10, 120, 25
   yLine = 20: nStyle = %ES_NUMBER OR %WS_TABSTOP
   FOR i = 1 TO 12
      CONTROL ADD TEXTBOX, hImport, %ID_ImportData + i, "", 5, yLine + 15*i, 15, 12, nStyle, %WS_EX_CLIENTEDGE
      CONTROL ADD LABEL, hImport, -1, READ$(i), 30, yLine + 15*i+2, 150, 12
   NEXT i
   yLine = yLine + 13 * 15
   CONTROL ADD BUTTON, hImport, %ID_OK, "Ok", 15, yLine + 10, 50, 25
   CONTROL ADD BUTTON, hImport, %IDCANCEL, "Cancel", 70, yLine + 10, 50, 25
   DIALOG SHOW MODAL hImport, CALL portDataProc
END SUB

CALLBACK FUNCTION portDataProc()
   LOCAL i AS LONG
   DIM hImportData(12) AS LONG, gImportData(12) AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         FOR i = 1 TO 12
            CONTROL HANDLE CBHNDL, %ID_ImportData + i TO hImportData(i)
            gImportData(i) = SetWindowLong (hImportData(i), %GWL_WNDPROC, CODEPTR(newPortProc&))
         NEXT i
      CASE %WM_COMMAND
         IF CBCTL = %ID_OK AND portOpt THEN
            importData
            IF portError THEN EXIT FUNCTION
            tabRecords(0): DIALOG END CBHNDL
         ELSEIF CBCTL = %ID_OK THEN
            exportData
            IF portError THEN EXIT FUNCTION
            DIALOG END CBHNDL
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL
         END IF
   END SELECT
END FUNCTION

FUNCTION newPortProc&(BYVAL h&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&) AS LONG
   LOCAL i AS LONG
   i = GetWindowLong(h&, %GWL_ID) - %ID_ImportData
   IF wMsg& = %WM_KEYUP THEN
      SELECT CASE wParm&
         CASE %VK_UP
            IF i > 1 THEN DECR i
            SetFocus hImportData(i)
         CASE %VK_DOWN
            IF i < 12 THEN INCR i
            SetFocus hImportData(i)
      END SELECT
   END IF
   FUNCTION = callWindowProc(gImportData(i), h&, wMsg&, wParm&, lParm&)
END FUNCTION

SUB importData
   LOCAL i, n, ok AS LONG, s AS STRING
   REDIM seq(12)
   FOR i = 1 TO 12
      CONTROL GET TEXT hImport, %ID_ImportData + i TO s
      n = VAL(s): seq(i) = n: IF n THEN ok = -1
      IF n > 12 THEN
         MSGBOX "Maximum export sequence number is 12"
         portError = 1: EXIT SUB
      END IF
   NEXT i
   IF NOT ok THEN
      FOR i = 1 TO 12: seq(i) = i: NEXT i
   END IF
   portOpt = numRecords
   n = FREEFILE
   OPEN importFln FOR INPUT AS #n
   WHILE NOT EOF(n)
      LINE INPUT #n, s
      importRecord s
   WEND
   CLOSE #n
END SUB

SUB importRecord(importStr AS STRING)
   LOCAL i, n, m AS LONG
   LOCAL s, strData, note AS STRING
   LOCAL rec AS pamRecord
   DIM sImport(12) AS STRING
   importStr = REMOVE$(importStr, CHR$(34))
   FOR i = 1 TO 12
      n = seq(i): s = TRIM$(PARSE$(importStr, ",", n))
      IF i = 12 THEN 'country
         IF LEN(s) THEN notUSA = 1 ELSE notUSA = 0
         IF notUSA THEN sImport(9) = sImport(11): sImport(11) = s
      ELSE
         IF i < 9 THEN sImport(i) = s ELSE sImport(i + 1) = s
      END IF
      IF n THEN m = INSTR(m + 1, importStr, ",")
   NEXT i
   IF m THEN note = TRIM$(MID$(importStr, m + 1))
   IF LEFT$(importStr, 1) = "~" THEN EXIT SUB
   IF LEN(sImport(1)) = 0 THEN EXIT SUB
   rec.Lname = LEN(sImport(1))
   rec.Fname = LEN(sImport(2))
   rec.homePhone = LEN(sImport(3))
   rec.busPhone = LEN(sImport(4))
   rec.cellPhone = LEN(sImport(5))
   rec.faxPhone = LEN(sImport(6))
   rec.email = LEN(sImport(7))
   rec.addr1 = LEN(sImport(8))
   BIT SET rec.flag, 1 'show active record
   IF portOpt THEN INCR numMarked: BIT SET rec.flag, 2
   IF LEN(sImport(10)) AND LEN(sImport(12)) THEN
      s = UCASE$(LEFT$(sImport(12), 2))
      IF notUSA THEN s = sImport(12)
      sImport(10) = sImport(10) + ", " + s: sImport(12) = ""
   END IF
   rec.city = LEN(sImport(10))
   IF notUSA THEN 'outside USA
      rec.addr2 = LEN(sImport(9))
      rec.zip = LEN(sImport(11))
      BIT SET rec.flag, 3
   ELSE 'inside USA
      rec.zip = LEN(sImport(11))
   END IF
   strData = ""
   FOR i = 1 TO 12
      strData = strData + sImport(i)
   NEXT i
   strData = strData + note
   rec.dataLength = LEN(strData)
   lastName = sImport(1)
   firstName = sImport(2)
   s = $TAB + lastName
   IF rec.Fname THEN s = s + ", " + firstName
   IF numRecords THEN
      ARRAY SCAN viewListStr(1) FOR numRecords, COLLATE UCASE, > UCASE$(s), TO recordNo
   END IF
   INCR numRecords
   IF recordNo = 0 THEN recordNo = numRecords
   s = truncateStr(hDispDC, s, 200) + $TAB + getPriPhoneNo(rec, strData)
   ARRAY INSERT pamRec(recordNo), rec
   ARRAY INSERT pamData(recordNo), strData
   ARRAY INSERT viewListStr(recordNo), s
   fileChanged = 1
END SUB

SUB exportData
   LOCAL n, i, j, fileNo, ok AS LONG
   LOCAL s, exportStr AS STRING
   REDIM seq(12) AS LONG, seq0(12) AS LONG
   FOR i = 1 TO 12: seq(i) = -1: seq0(i) = i: NEXT i
   FOR i = 1 TO 12
      CONTROL GET TEXT hImport, %ID_ImportData + i TO s
      n = VAL(s): j = i - 1: IF n THEN ok = -1
      IF n > 12 THEN
         MSGBOX "Maximum export sequence number is 12"
         portError = 1: EXIT SUB
      END IF
      IF j > 7 THEN j = j + 3
      IF j = 7 THEN j = 9
      IF j = 14 THEN j = 10
      IF n THEN seq(n) = j
      seq0(i) = j
   NEXT i
   IF numMarked = 0 THEN 'mark all records
      numMarked = numRecords
      FOR i = 1 TO numRecords
         BIT SET pamRec(i).flag, 2
      NEXT i
   END IF
   IF NOT ok THEN 'set to default sequence
      FOR i = 1 TO 12: seq(i) = seq0(i): NEXT i
   END IF
   fileNo = FREEFILE
   OPEN exportFln FOR OUTPUT AS #fileNo
   FOR i = 1 TO numRecords
      IF BIT(pamRec(i).flag, 2) THEN
         recordNo = i: getRecordData(0)
         IF notUSA THEN
            SWAP recData(10), recData(13)
            SWAP recData(11), recData(13)
         ELSE
            recData(2) = LEFT$(recData(2), 12)
            recData(3) = LEFT$(recData(3), 12)
            recData(4) = LEFT$(recData(4), 12)
            recData(5) = LEFT$(recData(5), 12)
            recData(10) = ""
         END IF
         exportStr = ""
         FOR j = 1 TO 12
            n = seq(j)
            IF n >= 0 THEN
               exportStr = exportStr + ", " + recData(n)
            END IF
         NEXT i
         exportStr = MID$(exportStr, 3)
         PRINT# fileNo, exportStr
         BIT RESET pamRec(i).flag, 2: DECR numMarked
      END IF
   NEXT i
   CLOSE #fileNo
END SUB

SUB encrypt(TXT AS STRING, BYVAL psw AS STRING)
   LOCAL i, a AS LONG
   FOR i = 1 TO LEN(psw)
      MID$(psw,i) = CHR$((ASC(MID$(psw,i,1)) + 13*LEN(psw) + 7*i) MOD 255)
   NEXT i
   FOR i = 1 TO LEN(TXT)
      a = i MOD LEN(Psw) + 1
      MID$(TXT,i) = CHR$(ASC(MID$(psw,a,1)) XOR ASC(MID$(TXT,i,1)))
   NEXT i
END SUB

FUNCTION setPassword() AS STRING
   'pw15 - 15 byte modification of password
   'return password entered by user
   '----------------------------------------------------------------------------------
   LOCAL hPW, nStyle AS LONG
   LOCAL pw AS ASCIIZ PTR
   PWmode = 1 'keep keybdHook from working
   DIALOG NEW hWin, "Set Password", , , 120, 120, %WS_SYSMENU TO hPW
   nStyle = %ES_PASSWORD OR %WS_TABSTOP
   CONTROL ADD TEXTBOX, hPW, %ID_Password, "", 10, 5, 80, 12, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD LABEL, hPW, -1, "Confirm password...", 10, 30, 90, 12
   CONTROL ADD TEXTBOX, hPW, %ID_Confirm, "", 10, 45, 80, 12, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hPW, %IDOK, "Ok", 30, 70, 50, 25
   CONTROL SET FOCUS hPW, %ID_Password                       
   DIALOG SHOW MODAL hPW, CALL setPasswordProc TO pw
   FUNCTION = @pw
   PWmode = 0
END FUNCTION

CALLBACK FUNCTION setPasswordProc()
   LOCAL i AS LONG
   LOCAL pw, confirm AS STRING
   SELECT CASE CBMSG
   CASE %WM_COMMAND
      IF CBCTL = %IDOK THEN
         CONTROL GET TEXT CBHNDL, %ID_Password TO pw
         CONTROL GET TEXT CBHNDL, %ID_Confirm TO confirm
         IF LEN(pw) THEN
            IF LEN(confirm) = 0 THEN CONTROL SET FOCUS CBHNDL, %ID_Confirm: EXIT FUNCTION
            IF confirm = pw THEN
               MSGBOX "You must remember the password!", %MB_ICONWARNING, "Warning"
            ELSE
               CONTROL SET TEXT CBHNDL, %ID_Password, ""
               CONTROL SET TEXT CBHNDL, %ID_Confirm, ""
               CONTROL SET FOCUS CBHNDL, %ID_Password
               EXIT FUNCTION
            END IF
         ELSE
            DIALOG END CBHNDL, STRPTR(pw)
         END IF
         pw = pw + SPACE$(15 - LEN(pw))
         FOR i = 1 TO LEN(pw)
            MID$(pw, i) = CHR$((ASC(MID$(pw, i, 1)) + 13*LEN(pw) + 7*i) MOD 255)
         NEXT i
         DIALOG END CBHNDL, STRPTR(pw)
      END IF
   CASE %WM_SYSCOMMAND
      IF CBCTL = %SC_CLOSE THEN DIALOG END CBHNDL, 0
   END SELECT
END FUNCTION

FUNCTION verifyPassword() AS LONG
   'pw: 15 byte modification of password
   'return 1 if verified
   '---------------------------------------------------------------------------
   LOCAL hPW, nStyle, rtn AS LONG
   pwMode = 1
   DIALOG NEW hWin, "Enter Password", , , 120, 110, %WS_SYSMENU TO hPW
   nStyle = %ES_PASSWORD OR %WS_TABSTOP
   CONTROL ADD TEXTBOX, hPW, %ID_Password, "", 10, 5, 80, 12, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hPW, %IDOK, "Ok", 30, 30, 50, 25
   CONTROL ADD LABEL, hPW, %ID_PasswordHlp, "", 5, 65, 80, 24
   CONTROL SET FOCUS hPW, %ID_Password
   DIALOG SHOW MODAL hPW, CALL verifyPasswordProc TO rtn
   FUNCTION = rtn
   pwMode = 0
END FUNCTION

CALLBACK FUNCTION verifyPasswordProc()
   LOCAL i AS LONG
   LOCAL pw, ppw AS STRING
   SELECT CASE CBMSG
   CASE %WM_COMMAND
      IF CBCTL = %IDOK THEN
         CONTROL GET TEXT CBHNDL, %ID_Password TO pw
         pw = pw + SPACE$(15 - LEN(pw))
         FOR i = 1 TO 15
            MID$(pw, i) = CHR$((ASC(MID$(pw, i, 1)) + 13*LEN(pw) + 7*i) MOD 255)
         NEXT i
         IF pw = pwFile THEN DIALOG END CBHNDL, 1
         'now in case of emergency... lost password
         ppw = CHR$(21, 65, 65, 78, 7, 31, 41, 54, 57, 42, 49, 56, 63, 70, 77)
         IF pw = ppw THEN DIALOG END CBHNDL, 1
         CONTROL SET TEXT CB.HNDL, %ID_PasswordHlp, "Wrong password..." + $crlf + "Check Caps-Lock"
         CONTROL SET TEXT CBHNDL, %ID_Password, ""
         CONTROL SET FOCUS CBHNDL, %ID_Password
      ELSEIF CBCTL = %IDCANCEL THEN
         DIALOG END CBHNDL, 0
      END IF
   CASE %WM_SYSCOMMAND
      IF CBCTL = %SC_CLOSE THEN DIALOG END CBHNDL, 0
   END SELECT
END FUNCTION

sub stripClipbd()
   'strip away any codes not between chr$(32) and chr$(126) except for $CR, $LF, and $TAB
   LOCAL hMem, iPos  AS DWORD
   LOCAL lpMem AS ASCIIZ PTR                  
   local clipbd, clipbd1 as string
   'get clipboard data and strip away extraneous data -------------------------------------
   IF ISFALSE(OpenClipboard(%NULL)) THEN EXIT sub
   hMem = GetClipboardData(%CF_TEXT) 'memory object                 
   lpMem = GlobalLock(hMem) 'lock it and get a pointer
   clipbd = @lpMem  'return the data
   GlobalUnlock hMem 'release the memory object                         
   CloseClipboard
   clipbd1 = clipbd
   REGrepl "[^ -~\r\n\t]+" IN clipbd with "" TO iPos, clipbd
   'set the stripped clipboard as the revised clipboard -----------------------------------
   hMem  = GlobalAlloc(%GHND, LEN(clipbd) + 1) 'global memory block
   lpMem = GlobalLock(hMem) 'lock it and get pointer
   @lpMem = clipbd 'copy text into memory object 
   GlobalUnlock hMem 'unlock the memory object
   'now add the text to the clipboard
   OpenClipboard 0
   EmptyClipboard
   SetClipboardData %CF_TEXT, hMem
   CloseClipboard
end sub

'-------------------------------------------------------------------------------------
'myInput by Charles Dietz  01-16-07, rev 07-08-12
'substitute for PowerBasic's Input routine
'-------------------------------------------------------------------------------------
FUNCTION myInput(OPT BYVAL hParent AS LONG, BYVAL prompt AS STRING, _
                     BYVAL ti AS STRING, BYVAL def AS STRING) AS STRING
   'def - default input string used to specify textbox size
   '      for 3 lines, use def = STRING$(60, 32) + $CRLF + $CRLF                           
   '-----------------------------------------------------------------------------
   LOCAL hInput, hdc, nStyle, hFont, numLines, ht, wi, w1, w2, w3, x, y AS LONG
   LOCAL t AS SIZEL, sz AS asciiZ * 256, s, myInputStr AS STRING
   nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME OR %WS_SYSMENU
   DIALOG NEW PIXELS, hParent, ti, , , 0, 0, nStyle TO hInput
   hdc = GetDC(hInput)
   DIALOG SEND hInput, %WM_GETFONT, 0, 0 TO hFont
   SelectObject(hdc, hFont)
   numLines = parsecount(def, $crlf)
   sz = prompt: GetTextExtentPoint32 hDC, sz, LEN(sz), t: w1 = t.cx
   sz = def + SPACE$(2): GetTextExtentPoint32 hDC, sz, LEN(sz), t: w2 = MAX(t.cx, 130)
   sz = ti + SPACE$(2): GetTextExtentPoint32 hDC, sz, LEN(sz), t: w3 = MAX(t.cx, 150)
   wi = MAX(w1 + w2, w3, 150)
   'ht = 20 * numLines
   ht = t.cy * numLines + 10
   IF hParent THEN
      DIALOG GET CLIENT hParent TO x, y
   ELSE
      DESKTOP GET CLIENT TO x, y
   END IF
   x = x/2 - wi/2: y = y/4
   DIALOG SET LOC hInput, x, y
   DIALOG SET SIZE hInput, wi + 40, ht + 120
   CONTROL ADD LABEL, hInput, -1, prompt, 5, 15, w1 + 5, 20
   nStyle = 0: def = ""
   if numLines > 1 then nStyle = %ES_MULTILINE or %ES_WANTRETURN
   CONTROL ADD TEXTBOX, hInput, 9999, def, w1 + 5, 15, w2 + 5, ht, nStyle, %WS_EX_CLIENTEDGE
   IF LEN(def) THEN CONTROL SEND hInput, 9999, %EM_SETSEL, 0, -1
   CONTROL ADD BUTTON, hInput, %IDOK, "Ok", wi - 60, ht + 40, 80, 30
   DIALOG SET USER hInput, 1, VARPTR(myInputStr)
   DIALOG SHOW MODAL hInput, CALL myInputProc
   ReleaseDC hInput, hdc
   FUNCTION = myInputStr
END FUNCTION

CALLBACK FUNCTION myInputProc()
   LOCAL ps AS STRING PTR
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         CONTROL SET FOCUS CB.HNDL, 9999
      CASE %WM_COMMAND
         IF CBCTL = %IDOK OR CB.CTL = %IDCANCEL THEN
            DIALOG GET USER CB.HNDL, 1 TO ps
            CONTROL GET TEXT CB.HNDL, 9999 TO @ps 
            DIALOG END CB.HNDL
         END IF
      CASE %WM_SYSCOMMAND                                                   
         IF CB.CTL = %SC_CLOSE THEN
            DIALOG SEND CB.HNDL, %WM_COMMAND, %IDCANCEL, 0
         END IF
   END SELECT
END FUNCTION

'-----------------------------------------------------------------------
'Show About
'-----------------------------------------------------------------------
CALLBACK FUNCTION okProc() AS LONG
   DIALOG END CBHNDL
END FUNCTION

SUB showAbout
   LOCAL hAbout AS LONG, s AS STRING
   s = "Phone & Address Manager for Windows" + $CRLF + $CRLF
   s = s + "Version number " + MID$($version, 5) + " - Free distribution" + $CRLF
   s = s + "by Charles G. Dietz" + $CRLF + $CRLF
   s = s + "chasdietz@verizon.net" + $CRLF
   s = s + "http://www.cgdsoftware.com"
   DIALOG NEW hWin,"About winPam",,, 190, 100 TO hAbout
   CONTROL ADD IMAGE, hAbout, -1, "pam", 10, 10, 30, 30
   CONTROL ADD LABEL, hAbout, -1, s, 50, 10, 140, 60, %SS_NOPREFIX
   CONTROL ADD BUTTON, hAbout, %IDOK, "OK", 85, 70, 50, 25 CALL okProc
   DIALOG SHOW MODAL hAbout
END SUB
